define(["@jupyter-widgets/base"],(t=>(()=>{"use strict";var e={146:e=>{e.exports=t},147:t=>{t.exports=JSON.parse('{"name":"pdpilot","version":"0.4.6","description":"A Jupyter widget for exploring PDP and ICE plots.","keywords":["jupyter","jupyterlab","jupyterlab-extension","widgets"],"files":["lib/**/*.js","dist/*.js","css/*.css"],"homepage":"https://github.com/DanielKerrigan/PDPilot","bugs":{"url":"https://github.com/DanielKerrigan/PDPilot/issues"},"license":"BSD-3-Clause","author":{"name":"Daniel Kerrigan","email":"kerrigan.d@northeastern.edu"},"main":"lib/index.js","types":"./lib/index.d.ts","repository":{"type":"git","url":"https://github.com/DanielKerrigan/PDPilot"},"scripts":{"build":"webpack --mode=development && jupyter labextension build --development=True .","build:prod":"webpack --mode=production && jupyter labextension build .","clean":"npm run clean:lib && npm run clean:nbextension && npm run clean:labextension","clean:lib":"rimraf lib","clean:labextension":"rimraf pdpilot/labextension","clean:nbextension":"rimraf pdpilot/nbextension/static/index.js","fix":"prettier --plugin-search-dir . --write src && eslint . --ext .ts,.tsx,.svelte --fix","check":"prettier --plugin-search-dir . --check src && eslint . --ext .ts,.tsx,.svelte","prepack":"npm run build:prod","watch":"npm run watch:nbextension","watch:nbextension":"webpack --watch --mode=development","watch:labextension":"jupyter labextension watch .","test":"uvu -r tsm tests"},"dependencies":{"@jupyter-widgets/base":"^1.1.10 || ^2 || ^3 || ^4 || ^5 || ^6","d3":"^7.4.4","simple-statistics":"^7.8.0"},"devDependencies":{"@babel/core":"^7.5.0","@babel/preset-env":"^7.5.0","@jupyterlab/builder":"^3.0.0","@lumino/application":"^1.6.0","@lumino/widgets":"^1.6.0","@tsconfig/svelte":"^3.0.0","@types/d3":"^7.4.0","@types/webpack-env":"^1.13.6","@typescript-eslint/eslint-plugin":"^5.45.0","@typescript-eslint/parser":"^5.45.0","acorn":"^7.2.0","css-loader":"^6.7.0","eslint":"^8.28.0","eslint-config-prettier":"^8.5.0","eslint-plugin-svelte3":"^4.0.0","fs-extra":"^7.0.0","identity-obj-proxy":"^3.0.0","mkdirp":"^0.5.1","npm-run-all":"^4.1.3","prettier":"^2.8.0","prettier-plugin-svelte":"^2.8.1","rimraf":"^2.6.2","source-map-loader":"^1.1.3","style-loader":"^3.0.0","svelte":"^3.54.0","svelte-loader":"^3.1.5","svelte-preprocess":"5.0.0","ts-loader":"^9.0.0","tslib":"^2.4.1","tsm":"^2.2.1","typescript":"^4.9.3","uvu":"^0.5.3","webpack":"^5.0.0","webpack-cli":"^4.0.0"},"jupyterlab":{"extension":true,"outputDir":"pdpilot/labextension/"}}')}},n={};function r(t){var i=n[t];if(void 0!==i)return i.exports;var o=n[t]={exports:{}};return e[t](o,o.exports,r),o.exports}r.d=(t,e)=>{for(var n in e)r.o(e,n)&&!r.o(t,n)&&Object.defineProperty(t,n,{enumerable:!0,get:e[n]})},r.o=(t,e)=>Object.prototype.hasOwnProperty.call(t,e),r.r=t=>{"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})};var i={};return(()=>{r.r(i),r.d(i,{MODULE_NAME:()=>n,MODULE_VERSION:()=>e,PDPilotModel:()=>Wd,PDPilotView:()=>Xd});const t=r(147),e=t.version,n=t.name;var o=r(146);function l(){}function a(t){return t()}function s(){return Object.create(null)}function c(t){t.forEach(a)}function u(t){return"function"==typeof t}function d(t,e){return t!=t?e==e:t!==e||t&&"object"==typeof t||"function"==typeof t}function h(t){return 0===Object.keys(t).length}function f(t,...e){if(null==t)return l;const n=t.subscribe(...e);return n.unsubscribe?()=>n.unsubscribe():n}function p(t,e,n){t.$$.on_destroy.push(f(e,n))}function g(t,e,n,r){return t[1]&&r?function(t,e){for(const n in e)t[n]=e[n];return t}(n.ctx.slice(),t[1](r(e))):n.ctx}function m(t,e,n){return t.set(n),e}new Set;let v,y=!1;function w(t,e){t.appendChild(e)}function b(t,e,n){const r=function(t){if(!t)return document;const e=t.getRootNode?t.getRootNode():t.ownerDocument;return e&&e.host?e:t.ownerDocument}(t);if(!r.getElementById(e)){const t=k("style");t.id=e,t.textContent=n,function(t,e){w(t.head||t,e),e.sheet}(r,t)}}function x(t,e,n){t.insertBefore(e,n||null)}function $(t){t.parentNode&&t.parentNode.removeChild(t)}function _(t,e){for(let n=0;n<t.length;n+=1)t[n]&&t[n].d(e)}function k(t){return document.createElement(t)}function M(t){return document.createElementNS("http://www.w3.org/2000/svg",t)}function L(t){return document.createTextNode(t)}function S(){return L(" ")}function A(){return L("")}function N(t,e,n,r){return t.addEventListener(e,n,r),()=>t.removeEventListener(e,n,r)}function z(t,e,n){null==n?t.removeAttribute(e):t.getAttribute(e)!==n&&t.setAttribute(e,n)}function T(t,e,n){const r=new Set;for(let e=0;e<t.length;e+=1)t[e].checked&&r.add(t[e].__value);return n||r.delete(e),Array.from(r)}function C(t,e){e=""+e,t.wholeText!==e&&(t.data=e)}function B(t,e){t.value=null==e?"":e}function j(t,e,n,r){null===n?t.style.removeProperty(e):t.style.setProperty(e,n,r?"important":"")}function q(t,e){for(let n=0;n<t.options.length;n+=1){const r=t.options[n];if(r.__value===e)return void(r.selected=!0)}t.selectedIndex=-1}function P(t){const e=t.querySelector(":checked")||t.options[0];return e&&e.__value}function E(t,e,n){t.classList[n?"add":"remove"](e)}function O(t){v=t}function D(){if(!v)throw new Error("Function called outside component initialization");return v}function H(t){D().$$.on_mount.push(t)}function R(){const t=D();return(e,n,{cancelable:r=!1}={})=>{const i=t.$$.callbacks[e];if(i){const o=function(t,e,{bubbles:n=!1,cancelable:r=!1}={}){const i=document.createEvent("CustomEvent");return i.initCustomEvent(t,n,r,e),i}(e,n,{cancelable:r});return i.slice().forEach((e=>{e.call(t,o)})),!o.defaultPrevented}return!0}}new Map;const I=[],V=[],F=[],W=[],X=Promise.resolve();let Y=!1;function K(){Y||(Y=!0,X.then(Q))}function U(t){F.push(t)}function G(t){W.push(t)}const Z=new Set;let J=0;function Q(){const t=v;do{for(;J<I.length;){const t=I[J];J++,O(t),tt(t.$$)}for(O(null),I.length=0,J=0;V.length;)V.pop()();for(let t=0;t<F.length;t+=1){const e=F[t];Z.has(e)||(Z.add(e),e())}F.length=0}while(I.length);for(;W.length;)W.pop()();Y=!1,Z.clear(),O(t)}function tt(t){if(null!==t.fragment){t.update(),c(t.before_update);const e=t.dirty;t.dirty=[-1],t.fragment&&t.fragment.p(t.ctx,e),t.after_update.forEach(U)}}const et=new Set;let nt,rt;function it(){nt={r:0,c:[],p:nt}}function ot(){nt.r||c(nt.c),nt=nt.p}function lt(t,e){t&&t.i&&(et.delete(t),t.i(e))}function at(t,e,n,r){if(t&&t.o){if(et.has(t))return;et.add(t),nt.c.push((()=>{et.delete(t),r&&(n&&t.d(1),r())})),t.o(e)}else r&&r()}function st(t,e){t.d(1),e.delete(t.key)}function ct(t,e){at(t,1,1,(()=>{e.delete(t.key)}))}function ut(t,e,n,r,i,o,l,a,s,c,u,d){let h=t.length,f=o.length,p=h;const g={};for(;p--;)g[t[p].key]=p;const m=[],v=new Map,y=new Map;for(p=f;p--;){const t=d(i,o,p),a=n(t);let s=l.get(a);s?r&&s.p(t,e):(s=c(a,t),s.c()),v.set(a,m[p]=s),a in g&&y.set(a,Math.abs(p-g[a]))}const w=new Set,b=new Set;function x(t){lt(t,1),t.m(a,u),l.set(t.key,t),u=t.first,f--}for(;h&&f;){const e=m[f-1],n=t[h-1],r=e.key,i=n.key;e===n?(u=e.first,h--,f--):v.has(i)?!l.has(r)||w.has(r)?x(e):b.has(i)?h--:y.get(r)>y.get(i)?(b.add(r),x(e)):(w.add(i),h--):(s(n,l),h--)}for(;h--;){const e=t[h];v.has(e.key)||s(e,l)}for(;f;)x(m[f-1]);return m}function dt(t,e,n,r){const i=t.$$.props[e];void 0!==i&&(t.$$.bound[i]=n,void 0===r&&n(t.$$.ctx[i]))}function ht(t){t&&t.c()}function ft(t,e,n,r){const{fragment:i,after_update:o}=t.$$;i&&i.m(e,n),r||U((()=>{const e=t.$$.on_mount.map(a).filter(u);t.$$.on_destroy?t.$$.on_destroy.push(...e):c(e),t.$$.on_mount=[]})),o.forEach(U)}function pt(t,e){const n=t.$$;null!==n.fragment&&(c(n.on_destroy),n.fragment&&n.fragment.d(e),n.on_destroy=n.fragment=null,n.ctx=[])}function gt(t,e,n,r,i,o,a,u=[-1]){const d=v;O(t);const h=t.$$={fragment:null,ctx:[],props:o,update:l,not_equal:i,bound:s(),on_mount:[],on_destroy:[],on_disconnect:[],before_update:[],after_update:[],context:new Map(e.context||(d?d.$$.context:[])),callbacks:s(),dirty:u,skip_bound:!1,root:e.target||d.$$.root};a&&a(h.root);let f=!1;if(h.ctx=n?n(t,e.props||{},((e,n,...r)=>{const o=r.length?r[0]:n;return h.ctx&&i(h.ctx[e],h.ctx[e]=o)&&(!h.skip_bound&&h.bound[e]&&h.bound[e](o),f&&function(t,e){-1===t.$$.dirty[0]&&(I.push(t),K(),t.$$.dirty.fill(0)),t.$$.dirty[e/31|0]|=1<<e%31}(t,e)),n})):[],h.update(),f=!0,c(h.before_update),h.fragment=!!r&&r(h.ctx),e.target){if(e.hydrate){y=!0;const t=(p=e.target,Array.from(p.childNodes));h.fragment&&h.fragment.l(t),t.forEach($)}else h.fragment&&h.fragment.c();e.intro&&lt(t.$$.fragment),ft(t,e.target,e.anchor,e.customElement),y=!1,Q()}var p;O(d)}"undefined"!=typeof window?window:"undefined"!=typeof globalThis?globalThis:global,new Set(["allowfullscreen","allowpaymentrequest","async","autofocus","autoplay","checked","controls","default","defer","disabled","formnovalidate","hidden","inert","ismap","itemscope","loop","multiple","muted","nomodule","novalidate","open","playsinline","readonly","required","reversed","selected"]),"function"==typeof HTMLElement&&(rt=class extends HTMLElement{constructor(){super(),this.attachShadow({mode:"open"})}connectedCallback(){const{on_mount:t}=this.$$;this.$$.on_disconnect=t.map(a).filter(u);for(const t in this.$$.slotted)this.appendChild(this.$$.slotted[t])}attributeChangedCallback(t,e,n){this[t]=n}disconnectedCallback(){c(this.$$.on_disconnect)}$destroy(){pt(this,1),this.$destroy=l}$on(t,e){if(!u(e))return l;const n=this.$$.callbacks[t]||(this.$$.callbacks[t]=[]);return n.push(e),()=>{const t=n.indexOf(e);-1!==t&&n.splice(t,1)}}$set(t){this.$$set&&!h(t)&&(this.$$.skip_bound=!0,this.$$set(t),this.$$.skip_bound=!1)}});class mt{$destroy(){pt(this,1),this.$destroy=l}$on(t,e){if(!u(e))return l;const n=this.$$.callbacks[t]||(this.$$.callbacks[t]=[]);return n.push(e),()=>{const t=n.indexOf(e);-1!==t&&n.splice(t,1)}}$set(t){this.$$set&&!h(t)&&(this.$$.skip_bound=!0,this.$$set(t),this.$$.skip_bound=!1)}}const vt=[];function yt(t,e=l){let n;const r=new Set;function i(e){if(d(t,e)&&(t=e,n)){const e=!vt.length;for(const e of r)e[1](),vt.push(e,t);if(e){for(let t=0;t<vt.length;t+=2)vt[t][0](vt[t+1]);vt.length=0}}}return{set:i,update:function(e){i(e(t))},subscribe:function(o,a=l){const s=[o,a];return r.add(s),1===r.size&&(n=e(i)||l),o(t),()=>{r.delete(s),0===r.size&&(n(),n=null)}}}}function wt(t,e,n){const r=!Array.isArray(t),i=r?[t]:t,o=e.length<2;return function(t,n){return{subscribe:yt(t,(t=>{let n=!1;const a=[];let s=0,d=l;const h=()=>{if(s)return;d();const n=e(r?a[0]:a,t);o?t(n):d=u(n)?n:l},p=i.map(((t,e)=>f(t,(t=>{a[e]=t,s&=~(1<<e),n&&h()}),(()=>{s|=1<<e}))));return n=!0,h(),function(){c(p),d()}})).subscribe}}(n)}function bt(t,e,n){t.prototype=e.prototype=n,n.constructor=t}function xt(t,e){var n=Object.create(t.prototype);for(var r in e)n[r]=e[r];return n}function $t(){}var _t=.7,kt=1/_t,Mt="\\s*([+-]?\\d+)\\s*",Lt="\\s*([+-]?(?:\\d*\\.)?\\d+(?:[eE][+-]?\\d+)?)\\s*",St="\\s*([+-]?(?:\\d*\\.)?\\d+(?:[eE][+-]?\\d+)?)%\\s*",At=/^#([0-9a-f]{3,8})$/,Nt=new RegExp(`^rgb\\(${Mt},${Mt},${Mt}\\)$`),zt=new RegExp(`^rgb\\(${St},${St},${St}\\)$`),Tt=new RegExp(`^rgba\\(${Mt},${Mt},${Mt},${Lt}\\)$`),Ct=new RegExp(`^rgba\\(${St},${St},${St},${Lt}\\)$`),Bt=new RegExp(`^hsl\\(${Lt},${St},${St}\\)$`),jt=new RegExp(`^hsla\\(${Lt},${St},${St},${Lt}\\)$`),qt={aliceblue:15792383,antiquewhite:16444375,aqua:65535,aquamarine:8388564,azure:15794175,beige:16119260,bisque:16770244,black:0,blanchedalmond:16772045,blue:255,blueviolet:9055202,brown:10824234,burlywood:14596231,cadetblue:6266528,chartreuse:8388352,chocolate:13789470,coral:16744272,cornflowerblue:6591981,cornsilk:16775388,crimson:14423100,cyan:65535,darkblue:139,darkcyan:35723,darkgoldenrod:12092939,darkgray:11119017,darkgreen:25600,darkgrey:11119017,darkkhaki:12433259,darkmagenta:9109643,darkolivegreen:5597999,darkorange:16747520,darkorchid:10040012,darkred:9109504,darksalmon:15308410,darkseagreen:9419919,darkslateblue:4734347,darkslategray:3100495,darkslategrey:3100495,darkturquoise:52945,darkviolet:9699539,deeppink:16716947,deepskyblue:49151,dimgray:6908265,dimgrey:6908265,dodgerblue:2003199,firebrick:11674146,floralwhite:16775920,forestgreen:2263842,fuchsia:16711935,gainsboro:14474460,ghostwhite:16316671,gold:16766720,goldenrod:14329120,gray:8421504,green:32768,greenyellow:11403055,grey:8421504,honeydew:15794160,hotpink:16738740,indianred:13458524,indigo:4915330,ivory:16777200,khaki:15787660,lavender:15132410,lavenderblush:16773365,lawngreen:8190976,lemonchiffon:16775885,lightblue:11393254,lightcoral:15761536,lightcyan:14745599,lightgoldenrodyellow:16448210,lightgray:13882323,lightgreen:9498256,lightgrey:13882323,lightpink:16758465,lightsalmon:16752762,lightseagreen:2142890,lightskyblue:8900346,lightslategray:7833753,lightslategrey:7833753,lightsteelblue:11584734,lightyellow:16777184,lime:65280,limegreen:3329330,linen:16445670,magenta:16711935,maroon:8388608,mediumaquamarine:6737322,mediumblue:205,mediumorchid:12211667,mediumpurple:9662683,mediumseagreen:3978097,mediumslateblue:8087790,mediumspringgreen:64154,mediumturquoise:4772300,mediumvioletred:13047173,midnightblue:1644912,mintcream:16121850,mistyrose:16770273,moccasin:16770229,navajowhite:16768685,navy:128,oldlace:16643558,olive:8421376,olivedrab:7048739,orange:16753920,orangered:16729344,orchid:14315734,palegoldenrod:15657130,palegreen:10025880,paleturquoise:11529966,palevioletred:14381203,papayawhip:16773077,peachpuff:16767673,peru:13468991,pink:16761035,plum:14524637,powderblue:11591910,purple:8388736,rebeccapurple:6697881,red:16711680,rosybrown:12357519,royalblue:4286945,saddlebrown:9127187,salmon:16416882,sandybrown:16032864,seagreen:3050327,seashell:16774638,sienna:10506797,silver:12632256,skyblue:8900331,slateblue:6970061,slategray:7372944,slategrey:7372944,snow:16775930,springgreen:65407,steelblue:4620980,tan:13808780,teal:32896,thistle:14204888,tomato:16737095,turquoise:4251856,violet:15631086,wheat:16113331,white:16777215,whitesmoke:16119285,yellow:16776960,yellowgreen:10145074};function Pt(){return this.rgb().formatHex()}function Et(){return this.rgb().formatRgb()}function Ot(t){var e,n;return t=(t+"").trim().toLowerCase(),(e=At.exec(t))?(n=e[1].length,e=parseInt(e[1],16),6===n?Dt(e):3===n?new Vt(e>>8&15|e>>4&240,e>>4&15|240&e,(15&e)<<4|15&e,1):8===n?Ht(e>>24&255,e>>16&255,e>>8&255,(255&e)/255):4===n?Ht(e>>12&15|e>>8&240,e>>8&15|e>>4&240,e>>4&15|240&e,((15&e)<<4|15&e)/255):null):(e=Nt.exec(t))?new Vt(e[1],e[2],e[3],1):(e=zt.exec(t))?new Vt(255*e[1]/100,255*e[2]/100,255*e[3]/100,1):(e=Tt.exec(t))?Ht(e[1],e[2],e[3],e[4]):(e=Ct.exec(t))?Ht(255*e[1]/100,255*e[2]/100,255*e[3]/100,e[4]):(e=Bt.exec(t))?Ut(e[1],e[2]/100,e[3]/100,1):(e=jt.exec(t))?Ut(e[1],e[2]/100,e[3]/100,e[4]):qt.hasOwnProperty(t)?Dt(qt[t]):"transparent"===t?new Vt(NaN,NaN,NaN,0):null}function Dt(t){return new Vt(t>>16&255,t>>8&255,255&t,1)}function Ht(t,e,n,r){return r<=0&&(t=e=n=NaN),new Vt(t,e,n,r)}function Rt(t){return t instanceof $t||(t=Ot(t)),t?new Vt((t=t.rgb()).r,t.g,t.b,t.opacity):new Vt}function It(t,e,n,r){return 1===arguments.length?Rt(t):new Vt(t,e,n,null==r?1:r)}function Vt(t,e,n,r){this.r=+t,this.g=+e,this.b=+n,this.opacity=+r}function Ft(){return`#${Kt(this.r)}${Kt(this.g)}${Kt(this.b)}`}function Wt(){const t=Xt(this.opacity);return`${1===t?"rgb(":"rgba("}${Yt(this.r)}, ${Yt(this.g)}, ${Yt(this.b)}${1===t?")":`, ${t})`}`}function Xt(t){return isNaN(t)?1:Math.max(0,Math.min(1,t))}function Yt(t){return Math.max(0,Math.min(255,Math.round(t)||0))}function Kt(t){return((t=Yt(t))<16?"0":"")+t.toString(16)}function Ut(t,e,n,r){return r<=0?t=e=n=NaN:n<=0||n>=1?t=e=NaN:e<=0&&(t=NaN),new Zt(t,e,n,r)}function Gt(t){if(t instanceof Zt)return new Zt(t.h,t.s,t.l,t.opacity);if(t instanceof $t||(t=Ot(t)),!t)return new Zt;if(t instanceof Zt)return t;var e=(t=t.rgb()).r/255,n=t.g/255,r=t.b/255,i=Math.min(e,n,r),o=Math.max(e,n,r),l=NaN,a=o-i,s=(o+i)/2;return a?(l=e===o?(n-r)/a+6*(n<r):n===o?(r-e)/a+2:(e-n)/a+4,a/=s<.5?o+i:2-o-i,l*=60):a=s>0&&s<1?0:l,new Zt(l,a,s,t.opacity)}function Zt(t,e,n,r){this.h=+t,this.s=+e,this.l=+n,this.opacity=+r}function Jt(t){return(t=(t||0)%360)<0?t+360:t}function Qt(t){return Math.max(0,Math.min(1,t||0))}function te(t,e,n){return 255*(t<60?e+(n-e)*t/60:t<180?n:t<240?e+(n-e)*(240-t)/60:e)}function ee(t,e,n,r,i){var o=t*t,l=o*t;return((1-3*t+3*o-l)*e+(4-6*o+3*l)*n+(1+3*t+3*o-3*l)*r+l*i)/6}bt($t,Ot,{copy(t){return Object.assign(new this.constructor,this,t)},displayable(){return this.rgb().displayable()},hex:Pt,formatHex:Pt,formatHex8:function(){return this.rgb().formatHex8()},formatHsl:function(){return Gt(this).formatHsl()},formatRgb:Et,toString:Et}),bt(Vt,It,xt($t,{brighter(t){return t=null==t?kt:Math.pow(kt,t),new Vt(this.r*t,this.g*t,this.b*t,this.opacity)},darker(t){return t=null==t?_t:Math.pow(_t,t),new Vt(this.r*t,this.g*t,this.b*t,this.opacity)},rgb(){return this},clamp(){return new Vt(Yt(this.r),Yt(this.g),Yt(this.b),Xt(this.opacity))},displayable(){return-.5<=this.r&&this.r<255.5&&-.5<=this.g&&this.g<255.5&&-.5<=this.b&&this.b<255.5&&0<=this.opacity&&this.opacity<=1},hex:Ft,formatHex:Ft,formatHex8:function(){return`#${Kt(this.r)}${Kt(this.g)}${Kt(this.b)}${Kt(255*(isNaN(this.opacity)?1:this.opacity))}`},formatRgb:Wt,toString:Wt})),bt(Zt,(function(t,e,n,r){return 1===arguments.length?Gt(t):new Zt(t,e,n,null==r?1:r)}),xt($t,{brighter(t){return t=null==t?kt:Math.pow(kt,t),new Zt(this.h,this.s,this.l*t,this.opacity)},darker(t){return t=null==t?_t:Math.pow(_t,t),new Zt(this.h,this.s,this.l*t,this.opacity)},rgb(){var t=this.h%360+360*(this.h<0),e=isNaN(t)||isNaN(this.s)?0:this.s,n=this.l,r=n+(n<.5?n:1-n)*e,i=2*n-r;return new Vt(te(t>=240?t-240:t+120,i,r),te(t,i,r),te(t<120?t+240:t-120,i,r),this.opacity)},clamp(){return new Zt(Jt(this.h),Qt(this.s),Qt(this.l),Xt(this.opacity))},displayable(){return(0<=this.s&&this.s<=1||isNaN(this.s))&&0<=this.l&&this.l<=1&&0<=this.opacity&&this.opacity<=1},formatHsl(){const t=Xt(this.opacity);return`${1===t?"hsl(":"hsla("}${Jt(this.h)}, ${100*Qt(this.s)}%, ${100*Qt(this.l)}%${1===t?")":`, ${t})`}`}}));const ne=t=>()=>t;function re(t,e){var n=e-t;return n?function(t,e){return function(n){return t+n*e}}(t,n):ne(isNaN(t)?e:t)}const ie=function t(e){var n=function(t){return 1==(t=+t)?re:function(e,n){return n-e?function(t,e,n){return t=Math.pow(t,n),e=Math.pow(e,n)-t,n=1/n,function(r){return Math.pow(t+r*e,n)}}(e,n,t):ne(isNaN(e)?n:e)}}(e);function r(t,e){var r=n((t=It(t)).r,(e=It(e)).r),i=n(t.g,e.g),o=n(t.b,e.b),l=re(t.opacity,e.opacity);return function(e){return t.r=r(e),t.g=i(e),t.b=o(e),t.opacity=l(e),t+""}}return r.gamma=t,r}(1);function oe(t){return function(e){var n,r,i=e.length,o=new Array(i),l=new Array(i),a=new Array(i);for(n=0;n<i;++n)r=It(e[n]),o[n]=r.r||0,l[n]=r.g||0,a[n]=r.b||0;return o=t(o),l=t(l),a=t(a),r.opacity=1,function(t){return r.r=o(t),r.g=l(t),r.b=a(t),r+""}}}var le=oe((function(t){var e=t.length-1;return function(n){var r=n<=0?n=0:n>=1?(n=1,e-1):Math.floor(n*e),i=t[r],o=t[r+1],l=r>0?t[r-1]:2*i-o,a=r<e-1?t[r+2]:2*o-i;return ee((n-r/e)*e,l,i,o,a)}}));function ae(t,e){var n,r=e?e.length:0,i=t?Math.min(r,t.length):0,o=new Array(i),l=new Array(r);for(n=0;n<i;++n)o[n]=ge(t[n],e[n]);for(;n<r;++n)l[n]=e[n];return function(t){for(n=0;n<i;++n)l[n]=o[n](t);return l}}function se(t,e){var n=new Date;return t=+t,e=+e,function(r){return n.setTime(t*(1-r)+e*r),n}}function ce(t,e){return t=+t,e=+e,function(n){return t*(1-n)+e*n}}function ue(t,e){var n,r={},i={};for(n in null!==t&&"object"==typeof t||(t={}),null!==e&&"object"==typeof e||(e={}),e)n in t?r[n]=ge(t[n],e[n]):i[n]=e[n];return function(t){for(n in r)i[n]=r[n](t);return i}}oe((function(t){var e=t.length;return function(n){var r=Math.floor(((n%=1)<0?++n:n)*e),i=t[(r+e-1)%e],o=t[r%e],l=t[(r+1)%e],a=t[(r+2)%e];return ee((n-r/e)*e,i,o,l,a)}}));var de=/[-+]?(?:\d+\.?\d*|\.?\d+)(?:[eE][-+]?\d+)?/g,he=new RegExp(de.source,"g");function fe(t,e){var n,r,i,o=de.lastIndex=he.lastIndex=0,l=-1,a=[],s=[];for(t+="",e+="";(n=de.exec(t))&&(r=he.exec(e));)(i=r.index)>o&&(i=e.slice(o,i),a[l]?a[l]+=i:a[++l]=i),(n=n[0])===(r=r[0])?a[l]?a[l]+=r:a[++l]=r:(a[++l]=null,s.push({i:l,x:ce(n,r)})),o=he.lastIndex;return o<e.length&&(i=e.slice(o),a[l]?a[l]+=i:a[++l]=i),a.length<2?s[0]?function(t){return function(e){return t(e)+""}}(s[0].x):function(t){return function(){return t}}(e):(e=s.length,function(t){for(var n,r=0;r<e;++r)a[(n=s[r]).i]=n.x(t);return a.join("")})}function pe(t,e){e||(e=[]);var n,r=t?Math.min(e.length,t.length):0,i=e.slice();return function(o){for(n=0;n<r;++n)i[n]=t[n]*(1-o)+e[n]*o;return i}}function ge(t,e){var n,r,i=typeof e;return null==e||"boolean"===i?ne(e):("number"===i?ce:"string"===i?(n=Ot(e))?(e=n,ie):fe:e instanceof Ot?ie:e instanceof Date?se:(r=e,!ArrayBuffer.isView(r)||r instanceof DataView?Array.isArray(e)?ae:"function"!=typeof e.valueOf&&"function"!=typeof e.toString||isNaN(e)?ue:ce:pe))(t,e)}function me(t,e){return t=+t,e=+e,function(n){return Math.round(t*(1-n)+e*n)}}function ve(t,e){return null==t||null==e?NaN:t<e?-1:t>e?1:t>=e?0:NaN}function ye(t,e){return null==t||null==e?NaN:e<t?-1:e>t?1:e>=t?0:NaN}function we(t){let e,n,r;function i(t,r,i=0,o=t.length){if(i<o){if(0!==e(r,r))return o;do{const e=i+o>>>1;n(t[e],r)<0?i=e+1:o=e}while(i<o)}return i}return 2!==t.length?(e=ve,n=(e,n)=>ve(t(e),n),r=(e,n)=>t(e)-n):(e=t===ve||t===ye?t:be,n=t,r=t),{left:i,center:function(t,e,n=0,o=t.length){const l=i(t,e,n,o-1);return l>n&&r(t[l-1],e)>-r(t[l],e)?l-1:l},right:function(t,r,i=0,o=t.length){if(i<o){if(0!==e(r,r))return o;do{const e=i+o>>>1;n(t[e],r)<=0?i=e+1:o=e}while(i<o)}return i}}}function be(){return 0}function xe(t){return null===t?NaN:+t}const $e=we(ve),_e=$e.right,ke=($e.left,we(xe).center,_e);function Me(t){return+t}var Le=[0,1];function Se(t){return t}function Ae(t,e){return(e-=t=+t)?function(n){return(n-t)/e}:(n=isNaN(e)?NaN:.5,function(){return n});var n}function Ne(t,e,n){var r=t[0],i=t[1],o=e[0],l=e[1];return i<r?(r=Ae(i,r),o=n(l,o)):(r=Ae(r,i),o=n(o,l)),function(t){return o(r(t))}}function ze(t,e,n){var r=Math.min(t.length,e.length)-1,i=new Array(r),o=new Array(r),l=-1;for(t[r]<t[0]&&(t=t.slice().reverse(),e=e.slice().reverse());++l<r;)i[l]=Ae(t[l],t[l+1]),o[l]=n(e[l],e[l+1]);return function(e){var n=ke(t,e,1,r)-1;return o[n](i[n](e))}}function Te(t,e){return e.domain(t.domain()).range(t.range()).interpolate(t.interpolate()).clamp(t.clamp()).unknown(t.unknown())}function Ce(){return function(){var t,e,n,r,i,o,l=Le,a=Le,s=ge,c=Se;function u(){var t,e,n,s=Math.min(l.length,a.length);return c!==Se&&(t=l[0],e=l[s-1],t>e&&(n=t,t=e,e=n),c=function(n){return Math.max(t,Math.min(e,n))}),r=s>2?ze:Ne,i=o=null,d}function d(e){return null==e||isNaN(e=+e)?n:(i||(i=r(l.map(t),a,s)))(t(c(e)))}return d.invert=function(n){return c(e((o||(o=r(a,l.map(t),ce)))(n)))},d.domain=function(t){return arguments.length?(l=Array.from(t,Me),u()):l.slice()},d.range=function(t){return arguments.length?(a=Array.from(t),u()):a.slice()},d.rangeRound=function(t){return a=Array.from(t),s=me,u()},d.clamp=function(t){return arguments.length?(c=!!t||Se,u()):c!==Se},d.interpolate=function(t){return arguments.length?(s=t,u()):s},d.unknown=function(t){return arguments.length?(n=t,d):n},function(n,r){return t=n,e=r,u()}}()(Se,Se)}function Be(t,e){switch(arguments.length){case 0:break;case 1:this.range(t);break;default:this.range(e).domain(t)}return this}function je(t,e){switch(arguments.length){case 0:break;case 1:"function"==typeof t?this.interpolator(t):this.range(t);break;default:this.domain(t),"function"==typeof e?this.interpolator(e):this.range(e)}return this}var qe=Math.sqrt(50),Pe=Math.sqrt(10),Ee=Math.sqrt(2);function Oe(t,e,n){var r,i,o,l,a=-1;if(n=+n,(t=+t)==(e=+e)&&n>0)return[t];if((r=e<t)&&(i=t,t=e,e=i),0===(l=De(t,e,n))||!isFinite(l))return[];if(l>0){let n=Math.round(t/l),r=Math.round(e/l);for(n*l<t&&++n,r*l>e&&--r,o=new Array(i=r-n+1);++a<i;)o[a]=(n+a)*l}else{l=-l;let n=Math.round(t*l),r=Math.round(e*l);for(n/l<t&&++n,r/l>e&&--r,o=new Array(i=r-n+1);++a<i;)o[a]=(n+a)/l}return r&&o.reverse(),o}function De(t,e,n){var r=(e-t)/Math.max(0,n),i=Math.floor(Math.log(r)/Math.LN10),o=r/Math.pow(10,i);return i>=0?(o>=qe?10:o>=Pe?5:o>=Ee?2:1)*Math.pow(10,i):-Math.pow(10,-i)/(o>=qe?10:o>=Pe?5:o>=Ee?2:1)}var He,Re=/^(?:(.)?([<>=^]))?([+\-( ])?([$#])?(0)?(\d+)?(,)?(\.\d+)?(~)?([a-z%])?$/i;function Ie(t){if(!(e=Re.exec(t)))throw new Error("invalid format: "+t);var e;return new Ve({fill:e[1],align:e[2],sign:e[3],symbol:e[4],zero:e[5],width:e[6],comma:e[7],precision:e[8]&&e[8].slice(1),trim:e[9],type:e[10]})}function Ve(t){this.fill=void 0===t.fill?" ":t.fill+"",this.align=void 0===t.align?">":t.align+"",this.sign=void 0===t.sign?"-":t.sign+"",this.symbol=void 0===t.symbol?"":t.symbol+"",this.zero=!!t.zero,this.width=void 0===t.width?void 0:+t.width,this.comma=!!t.comma,this.precision=void 0===t.precision?void 0:+t.precision,this.trim=!!t.trim,this.type=void 0===t.type?"":t.type+""}function Fe(t,e){if((n=(t=e?t.toExponential(e-1):t.toExponential()).indexOf("e"))<0)return null;var n,r=t.slice(0,n);return[r.length>1?r[0]+r.slice(2):r,+t.slice(n+1)]}function We(t){return(t=Fe(Math.abs(t)))?t[1]:NaN}function Xe(t,e){var n=Fe(t,e);if(!n)return t+"";var r=n[0],i=n[1];return i<0?"0."+new Array(-i).join("0")+r:r.length>i+1?r.slice(0,i+1)+"."+r.slice(i+1):r+new Array(i-r.length+2).join("0")}Ie.prototype=Ve.prototype,Ve.prototype.toString=function(){return this.fill+this.align+this.sign+this.symbol+(this.zero?"0":"")+(void 0===this.width?"":Math.max(1,0|this.width))+(this.comma?",":"")+(void 0===this.precision?"":"."+Math.max(0,0|this.precision))+(this.trim?"~":"")+this.type};const Ye={"%":(t,e)=>(100*t).toFixed(e),b:t=>Math.round(t).toString(2),c:t=>t+"",d:function(t){return Math.abs(t=Math.round(t))>=1e21?t.toLocaleString("en").replace(/,/g,""):t.toString(10)},e:(t,e)=>t.toExponential(e),f:(t,e)=>t.toFixed(e),g:(t,e)=>t.toPrecision(e),o:t=>Math.round(t).toString(8),p:(t,e)=>Xe(100*t,e),r:Xe,s:function(t,e){var n=Fe(t,e);if(!n)return t+"";var r=n[0],i=n[1],o=i-(He=3*Math.max(-8,Math.min(8,Math.floor(i/3))))+1,l=r.length;return o===l?r:o>l?r+new Array(o-l+1).join("0"):o>0?r.slice(0,o)+"."+r.slice(o):"0."+new Array(1-o).join("0")+Fe(t,Math.max(0,e+o-1))[0]},X:t=>Math.round(t).toString(16).toUpperCase(),x:t=>Math.round(t).toString(16)};function Ke(t){return t}var Ue,Ge,Ze,Je=Array.prototype.map,Qe=["y","z","a","f","p","n","µ","m","","k","M","G","T","P","E","Z","Y"];function tn(t){var e=t.domain;return t.ticks=function(t){var n=e();return Oe(n[0],n[n.length-1],null==t?10:t)},t.tickFormat=function(t,n){var r=e();return function(t,e,n,r){var i,o=function(t,e,n){var r=Math.abs(e-t)/Math.max(0,n),i=Math.pow(10,Math.floor(Math.log(r)/Math.LN10)),o=r/i;return o>=qe?i*=10:o>=Pe?i*=5:o>=Ee&&(i*=2),e<t?-i:i}(t,e,n);switch((r=Ie(null==r?",f":r)).type){case"s":var l=Math.max(Math.abs(t),Math.abs(e));return null!=r.precision||isNaN(i=function(t,e){return Math.max(0,3*Math.max(-8,Math.min(8,Math.floor(We(e)/3)))-We(Math.abs(t)))}(o,l))||(r.precision=i),Ze(r,l);case"":case"e":case"g":case"p":case"r":null!=r.precision||isNaN(i=function(t,e){return t=Math.abs(t),e=Math.abs(e)-t,Math.max(0,We(e)-We(t))+1}(o,Math.max(Math.abs(t),Math.abs(e))))||(r.precision=i-("e"===r.type));break;case"f":case"%":null!=r.precision||isNaN(i=function(t){return Math.max(0,-We(Math.abs(t)))}(o))||(r.precision=i-2*("%"===r.type))}return Ge(r)}(r[0],r[r.length-1],null==t?10:t,n)},t.nice=function(n){null==n&&(n=10);var r,i,o=e(),l=0,a=o.length-1,s=o[l],c=o[a],u=10;for(c<s&&(i=s,s=c,c=i,i=l,l=a,a=i);u-- >0;){if((i=De(s,c,n))===r)return o[l]=s,o[a]=c,e(o);if(i>0)s=Math.floor(s/i)*i,c=Math.ceil(c/i)*i;else{if(!(i<0))break;s=Math.ceil(s*i)/i,c=Math.floor(c*i)/i}r=i}return t},t}function en(){var t=Ce();return t.copy=function(){return Te(t,en())},Be.apply(t,arguments),tn(t)}function nn(){var t,e,n,r,i,o=0,l=1,a=Se,s=!1;function c(e){return null==e||isNaN(e=+e)?i:a(0===n?.5:(e=(r(e)-t)*n,s?Math.max(0,Math.min(1,e)):e))}function u(t){return function(e){var n,r;return arguments.length?([n,r]=e,a=t(n,r),c):[a(0),a(1)]}}return c.domain=function(i){return arguments.length?([o,l]=i,t=r(o=+o),e=r(l=+l),n=t===e?0:1/(e-t),c):[o,l]},c.clamp=function(t){return arguments.length?(s=!!t,c):s},c.interpolator=function(t){return arguments.length?(a=t,c):a},c.range=u(ge),c.rangeRound=u(me),c.unknown=function(t){return arguments.length?(i=t,c):i},function(i){return r=i,t=i(o),e=i(l),n=t===e?0:1/(e-t),c}}function rn(t,e){return e.domain(t.domain()).interpolator(t.interpolator()).clamp(t.clamp()).unknown(t.unknown())}function on(){var t=tn(nn()(Se));return t.copy=function(){return rn(t,on())},je.apply(t,arguments)}function ln(t,e){void 0===e&&(e=t,t=ge);for(var n=0,r=e.length-1,i=e[0],o=new Array(r<0?0:r);n<r;)o[n]=t(i,i=e[++n]);return function(t){var e=Math.max(0,Math.min(r-1,Math.floor(t*=r)));return o[e](t-e)}}function an(){var t,e,n,r,i,o,l,a=0,s=.5,c=1,u=1,d=Se,h=!1;function f(t){return isNaN(t=+t)?l:(t=.5+((t=+o(t))-e)*(u*t<u*e?r:i),d(h?Math.max(0,Math.min(1,t)):t))}function p(t){return function(e){var n,r,i;return arguments.length?([n,r,i]=e,d=ln(t,[n,r,i]),f):[d(0),d(.5),d(1)]}}return f.domain=function(l){return arguments.length?([a,s,c]=l,t=o(a=+a),e=o(s=+s),n=o(c=+c),r=t===e?0:.5/(e-t),i=e===n?0:.5/(n-e),u=e<t?-1:1,f):[a,s,c]},f.clamp=function(t){return arguments.length?(h=!!t,f):h},f.interpolator=function(t){return arguments.length?(d=t,f):d},f.range=p(ge),f.rangeRound=p(me),f.unknown=function(t){return arguments.length?(l=t,f):l},function(l){return o=l,t=l(a),e=l(s),n=l(c),r=t===e?0:.5/(e-t),i=e===n?0:.5/(n-e),u=e<t?-1:1,f}}function sn(){var t=tn(an()(Se));return t.copy=function(){return rn(t,sn())},je.apply(t,arguments)}function cn(t){for(var e=t.length/6|0,n=new Array(e),r=0;r<e;)n[r]="#"+t.slice(6*r,6*++r);return n}Ue=function(t){var e,n,r=void 0===t.grouping||void 0===t.thousands?Ke:(e=Je.call(t.grouping,Number),n=t.thousands+"",function(t,r){for(var i=t.length,o=[],l=0,a=e[0],s=0;i>0&&a>0&&(s+a+1>r&&(a=Math.max(1,r-s)),o.push(t.substring(i-=a,i+a)),!((s+=a+1)>r));)a=e[l=(l+1)%e.length];return o.reverse().join(n)}),i=void 0===t.currency?"":t.currency[0]+"",o=void 0===t.currency?"":t.currency[1]+"",l=void 0===t.decimal?".":t.decimal+"",a=void 0===t.numerals?Ke:function(t){return function(e){return e.replace(/[0-9]/g,(function(e){return t[+e]}))}}(Je.call(t.numerals,String)),s=void 0===t.percent?"%":t.percent+"",c=void 0===t.minus?"−":t.minus+"",u=void 0===t.nan?"NaN":t.nan+"";function d(t){var e=(t=Ie(t)).fill,n=t.align,d=t.sign,h=t.symbol,f=t.zero,p=t.width,g=t.comma,m=t.precision,v=t.trim,y=t.type;"n"===y?(g=!0,y="g"):Ye[y]||(void 0===m&&(m=12),v=!0,y="g"),(f||"0"===e&&"="===n)&&(f=!0,e="0",n="=");var w="$"===h?i:"#"===h&&/[boxX]/.test(y)?"0"+y.toLowerCase():"",b="$"===h?o:/[%p]/.test(y)?s:"",x=Ye[y],$=/[defgprs%]/.test(y);function _(t){var i,o,s,h=w,_=b;if("c"===y)_=x(t)+_,t="";else{var k=(t=+t)<0||1/t<0;if(t=isNaN(t)?u:x(Math.abs(t),m),v&&(t=function(t){t:for(var e,n=t.length,r=1,i=-1;r<n;++r)switch(t[r]){case".":i=e=r;break;case"0":0===i&&(i=r),e=r;break;default:if(!+t[r])break t;i>0&&(i=0)}return i>0?t.slice(0,i)+t.slice(e+1):t}(t)),k&&0==+t&&"+"!==d&&(k=!1),h=(k?"("===d?d:c:"-"===d||"("===d?"":d)+h,_=("s"===y?Qe[8+He/3]:"")+_+(k&&"("===d?")":""),$)for(i=-1,o=t.length;++i<o;)if(48>(s=t.charCodeAt(i))||s>57){_=(46===s?l+t.slice(i+1):t.slice(i))+_,t=t.slice(0,i);break}}g&&!f&&(t=r(t,1/0));var M=h.length+t.length+_.length,L=M<p?new Array(p-M+1).join(e):"";switch(g&&f&&(t=r(L+t,L.length?p-_.length:1/0),L=""),n){case"<":t=h+t+_+L;break;case"=":t=h+L+t+_;break;case"^":t=L.slice(0,M=L.length>>1)+h+t+_+L.slice(M);break;default:t=L+h+t+_}return a(t)}return m=void 0===m?6:/[gprs]/.test(y)?Math.max(1,Math.min(21,m)):Math.max(0,Math.min(20,m)),_.toString=function(){return t+""},_}return{format:d,formatPrefix:function(t,e){var n=d(((t=Ie(t)).type="f",t)),r=3*Math.max(-8,Math.min(8,Math.floor(We(e)/3))),i=Math.pow(10,-r),o=Qe[8+r/3];return function(t){return n(i*t)+o}}}}({thousands:",",grouping:[3],currency:["$",""]}),Ge=Ue.format,Ze=Ue.formatPrefix;const un=t=>le(t[t.length-1]),dn=un(new Array(3).concat("edf8b17fcdbb2c7fb8","ffffcca1dab441b6c4225ea8","ffffcca1dab441b6c42c7fb8253494","ffffccc7e9b47fcdbb41b6c42c7fb8253494","ffffccc7e9b47fcdbb41b6c41d91c0225ea80c2c84","ffffd9edf8b1c7e9b47fcdbb41b6c41d91c0225ea80c2c84","ffffd9edf8b1c7e9b47fcdbb41b6c41d91c0225ea8253494081d58").map(cn)),hn=un(new Array(3).concat("d8b365f5f5f55ab4ac","a6611adfc27d80cdc1018571","a6611adfc27df5f5f580cdc1018571","8c510ad8b365f6e8c3c7eae55ab4ac01665e","8c510ad8b365f6e8c3f5f5f5c7eae55ab4ac01665e","8c510abf812ddfc27df6e8c3c7eae580cdc135978f01665e","8c510abf812ddfc27df6e8c3f5f5f5c7eae580cdc135978f01665e","5430058c510abf812ddfc27df6e8c3c7eae580cdc135978f01665e003c30","5430058c510abf812ddfc27df6e8c3f5f5f5c7eae580cdc135978f01665e003c30").map(cn));class fn extends Map{constructor(t,e=yn){if(super(),Object.defineProperties(this,{_intern:{value:new Map},_key:{value:e}}),null!=t)for(const[e,n]of t)this.set(e,n)}get(t){return super.get(gn(this,t))}has(t){return super.has(gn(this,t))}set(t,e){return super.set(mn(this,t),e)}delete(t){return super.delete(vn(this,t))}}class pn extends Set{constructor(t,e=yn){if(super(),Object.defineProperties(this,{_intern:{value:new Map},_key:{value:e}}),null!=t)for(const e of t)this.add(e)}has(t){return super.has(gn(this,t))}add(t){return super.add(mn(this,t))}delete(t){return super.delete(vn(this,t))}}function gn({_intern:t,_key:e},n){const r=e(n);return t.has(r)?t.get(r):n}function mn({_intern:t,_key:e},n){const r=e(n);return t.has(r)?t.get(r):(t.set(r,n),n)}function vn({_intern:t,_key:e},n){const r=e(n);return t.has(r)&&(n=t.get(r),t.delete(r)),n}function yn(t){return null!==t&&"object"==typeof t?t.valueOf():t}function wn(t){return t}function bn(t,e,...n){return function(t,e,n,r){return function t(i,o){if(o>=r.length)return n(i);const l=new fn,a=r[o++];let s=-1;for(const t of i){const e=a(t,++s,i),n=l.get(e);n?n.push(t):l.set(e,[t])}for(const[e,n]of l)l.set(e,t(n,o));return e(l)}(t,0)}(t,wn,e,n)}function xn(t,e,n){t=+t,e=+e,n=(i=arguments.length)<2?(e=t,t=0,1):i<3?1:+n;for(var r=-1,i=0|Math.max(0,Math.ceil((e-t)/n)),o=new Array(i);++r<i;)o[r]=t+r*n;return o}function $n(t){const e=function(t,e){let n=0;for(let e of t)(e=+e)&&(n+=e);return n}(t);return t.map((t=>t/e))}function _n(t,e,n,r){const i=window.devicePixelRatio||1;t.width=n*i,t.height=r*i,t.style.width=n+"px",t.style.height=r+"px",e.scale(i,i)}function kn(t){return t>=.001&&t<=1||t>=-1&&t<=.001?Ge(".3~f")(t):Ge("~s")(t)}function Mn(t,e,n,r,i,o,l,a,s){var c,u;if(i){if("lines"===r)return en().domain([t.ice.ice_min,t.ice.ice_max]).nice().range([e-s.bottom,s.top]);if("centered-lines"===r)return en().domain([t.ice.centered_ice_min,t.ice.centered_ice_max]).nice().range([e-s.bottom,s.top]);if("cluster-centers"===r){const n=t.ice.clusters[t.ice.num_clusters],r=null!==(c=null==n?void 0:n.centered_mean_min)&&void 0!==c?c:t.ice.centered_ice_min,i=null!==(u=null==n?void 0:n.centered_mean_max)&&void 0!==u?u:t.ice.centered_ice_max;return en().domain([r,i]).nice().range([e-s.bottom,s.top])}return en().domain([t.ice.centered_ice_min,t.ice.centered_ice_max]).nice().range([n-s.bottom,s.top])}return"lines"===r?en().domain(o).nice().range([e-s.bottom,s.top]):"centered-lines"===r?en().domain(a).nice().range([e-s.bottom,s.top]):"cluster-centers"===r?en().domain(l).nice().range([e-s.bottom,s.top]):en().domain(a).nice().range([n-s.bottom,s.top])}function Ln(t,e,n){const r=n.map((t=>e[t]));if("categorical"===t.kind){const e=bn(r,(t=>t.length),(t=>t)),n=t.distribution.bins.map((t=>{var n;return null!==(n=e.get(t))&&void 0!==n?n:0})),i=$n(n);return{bins:t.distribution.bins,counts:n,percents:i}}{const e=bn(r,(t=>t.length),(e=>_e(t.distribution.bins,e,0,t.distribution.bins.length-1)-1)),n=xn(t.distribution.counts.length).map((t=>{var n;return null!==(n=e.get(t))&&void 0!==n?n:0})),i=$n(n);return{bins:t.distribution.bins,counts:n,percents:i}}}const Sn=["#a6cee3","#fdbf6f","#b2df8a","#fb9a99","#cab2d6"],An=["#67a3cb","#fea13f","#7abf5a","#f4645d","#9c76b7"],Nn=["#1f78b4","#ff7f00","#33a02c","#e31a1c","#6a3d9a"];function zn(t,e,n){const r=t,i=yt(e),o=n.get(r);return void 0!==o&&i.set(o),n.on("change:"+r,(()=>i.set(n.get(r))),null),{set:t=>{i.set(t),n&&(n.set(r,t),n.save_changes())},subscribe:i.subscribe,update:t=>{i.update((e=>{const i=t(e);return n&&(n.set(r,i),n.save_changes()),i}))}}}let Tn,Cn,Bn,jn,qn,Pn,En,On,Dn,Hn,Rn,In,Vn,Fn,Wn,Xn,Yn,Kn,Un,Gn,Zn,Jn,Qn,tr,er,nr;function rr(t){Tn=zn("feature_names",[],t),Cn=zn("feature_info",{},t),Bn=zn("dataset",{},t),jn=zn("num_instances",0,t),qn=zn("one_way_pds",[],t),Pn=zn("two_way_pds",[],t),En=zn("two_way_pdp_extent",[0,0],t),On=zn("two_way_interaction_extent",[0,0],t),Dn=zn("ice_line_extent",[0,0],t),Hn=zn("ice_cluster_center_extent",[0,0],t),Rn=zn("centered_ice_line_extent",[0,0],t),In=zn("height",600,t),Vn=zn("highlighted_indices",[],t),Fn=zn("two_way_to_calculate",[],t),Wn=yt("one-way-plots"),Xn=wt(qn,(t=>new Map(t.map((t=>[t.x_feature,t])))));const e=t.get("one_way_pds"),n=e&&e.length>0?e[0].x_feature:"";Yn=yt(n),Kn=yt(""),Un=yt("lines"),Gn=yt(!1),Zn=yt(!1),Jn=yt(!1),Qn=yt(""),tr=wt([Cn,Bn,Vn],(([t,e,n])=>new Map(Object.entries(t).map((([t,r])=>[t,Ln(r,e[t],n)]))))),er=wt(En,(t=>on().domain(t).interpolator(dn).unknown("black"))),nr=wt(On,(t=>sn().domain([t[0],0,t[1]]).interpolator(hn).unknown("black")))}function ir(t){b(t,"svelte-a3do9k","div.svelte-a3do9k.svelte-a3do9k{display:flex;padding:0.25em;background-color:var(--gray-1)}button.svelte-a3do9k.svelte-a3do9k{border:none;border-radius:0;background-color:transparent}button.tab-selected.svelte-a3do9k.svelte-a3do9k{border-bottom:1px solid black}ul.svelte-a3do9k.svelte-a3do9k{list-style:none}li.svelte-a3do9k.svelte-a3do9k{display:inline-flex}li.svelte-a3do9k+li.svelte-a3do9k{margin-left:0.5em}")}function or(t,e,n){const r=t.slice();return r[4]=e[n].value,r[5]=e[n].title,r}function lr(t){let e,n,r,i,o,l,a=t[5]+"";function s(){return t[3](t[4])}return{c(){e=k("li"),n=k("button"),r=L(a),i=S(),z(n,"class","svelte-a3do9k"),E(n,"tab-selected",t[4]===t[0]),z(e,"class","svelte-a3do9k")},m(t,a){x(t,e,a),w(e,n),w(n,r),w(e,i),o||(l=N(n,"click",s),o=!0)},p(e,r){t=e,3&r&&E(n,"tab-selected",t[4]===t[0])},d(t){t&&$(e),o=!1,l()}}}function ar(t){let e,n,r=t[1],i=[];for(let e=0;e<r.length;e+=1)i[e]=lr(or(t,r,e));return{c(){e=k("div"),n=k("ul");for(let t=0;t<i.length;t+=1)i[t].c();z(n,"class","svelte-a3do9k"),z(e,"class","svelte-a3do9k")},m(t,r){x(t,e,r),w(e,n);for(let t=0;t<i.length;t+=1)i[t].m(n,null)},p(t,[e]){if(7&e){let o;for(r=t[1],o=0;o<r.length;o+=1){const l=or(t,r,o);i[o]?i[o].p(l,e):(i[o]=lr(l),i[o].c(),i[o].m(n,null))}for(;o<i.length;o+=1)i[o].d(1);i.length=r.length}},i:l,o:l,d(t){t&&$(e),_(i,t)}}}function sr(t,e,n){let r;function i(t){m(Wn,r=t,r)}return p(t,Wn,(t=>n(0,r=t))),[r,[{value:"one-way-plots",title:"One-way Plots"},{value:"two-way-plots",title:"Two-way Plots"},{value:"detailed-plot",title:"Detailed Plot"}],i,t=>i(t)]}const cr=class extends mt{constructor(t){super(),gt(this,t,sr,ar,d,{},ir)}},ur=Symbol("implicit");function dr(){var t=new fn,e=[],n=[],r=ur;function i(i){let o=t.get(i);if(void 0===o){if(r!==ur)return r;t.set(i,o=e.push(i)-1)}return n[o%n.length]}return i.domain=function(n){if(!arguments.length)return e.slice();e=[],t=new fn;for(const r of n)t.has(r)||t.set(r,e.push(r)-1);return i},i.range=function(t){return arguments.length?(n=Array.from(t),i):n.slice()},i.unknown=function(t){return arguments.length?(r=t,i):r},i.copy=function(){return dr(e,n).unknown(r)},Be.apply(i,arguments),i}function hr(){var t,e,n=dr().unknown(void 0),r=n.domain,i=n.range,o=0,l=1,a=!1,s=0,c=0,u=.5;function d(){var n=r().length,d=l<o,h=d?l:o,f=d?o:l;t=(f-h)/Math.max(1,n-s+2*c),a&&(t=Math.floor(t)),h+=(f-h-t*(n-s))*u,e=t*(1-s),a&&(h=Math.round(h),e=Math.round(e));var p=xn(n).map((function(e){return h+t*e}));return i(d?p.reverse():p)}return delete n.unknown,n.domain=function(t){return arguments.length?(r(t),d()):r()},n.range=function(t){return arguments.length?([o,l]=t,o=+o,l=+l,d()):[o,l]},n.rangeRound=function(t){return[o,l]=t,o=+o,l=+l,a=!0,d()},n.bandwidth=function(){return e},n.step=function(){return t},n.round=function(t){return arguments.length?(a=!!t,d()):a},n.padding=function(t){return arguments.length?(s=Math.min(1,c=+t),d()):s},n.paddingInner=function(t){return arguments.length?(s=Math.min(1,t),d()):s},n.paddingOuter=function(t){return arguments.length?(c=+t,d()):c},n.align=function(t){return arguments.length?(u=Math.max(0,Math.min(1,t)),d()):u},n.copy=function(){return hr(r(),[o,l]).round(a).paddingInner(s).paddingOuter(c).align(u)},Be.apply(d(),arguments)}function fr(t){var e=t.copy;return t.padding=t.paddingOuter,delete t.paddingInner,delete t.paddingOuter,t.copy=function(){return fr(e())},t}function pr(){return fr(hr.apply(null,arguments).paddingInner(1))}const gr=Math.PI,mr=2*gr,vr=1e-6,yr=mr-vr;function wr(){this._x0=this._y0=this._x1=this._y1=null,this._=""}function br(){return new wr}wr.prototype=br.prototype={constructor:wr,moveTo:function(t,e){this._+="M"+(this._x0=this._x1=+t)+","+(this._y0=this._y1=+e)},closePath:function(){null!==this._x1&&(this._x1=this._x0,this._y1=this._y0,this._+="Z")},lineTo:function(t,e){this._+="L"+(this._x1=+t)+","+(this._y1=+e)},quadraticCurveTo:function(t,e,n,r){this._+="Q"+ +t+","+ +e+","+(this._x1=+n)+","+(this._y1=+r)},bezierCurveTo:function(t,e,n,r,i,o){this._+="C"+ +t+","+ +e+","+ +n+","+ +r+","+(this._x1=+i)+","+(this._y1=+o)},arcTo:function(t,e,n,r,i){t=+t,e=+e,n=+n,r=+r,i=+i;var o=this._x1,l=this._y1,a=n-t,s=r-e,c=o-t,u=l-e,d=c*c+u*u;if(i<0)throw new Error("negative radius: "+i);if(null===this._x1)this._+="M"+(this._x1=t)+","+(this._y1=e);else if(d>vr)if(Math.abs(u*a-s*c)>vr&&i){var h=n-o,f=r-l,p=a*a+s*s,g=h*h+f*f,m=Math.sqrt(p),v=Math.sqrt(d),y=i*Math.tan((gr-Math.acos((p+d-g)/(2*m*v)))/2),w=y/v,b=y/m;Math.abs(w-1)>vr&&(this._+="L"+(t+w*c)+","+(e+w*u)),this._+="A"+i+","+i+",0,0,"+ +(u*h>c*f)+","+(this._x1=t+b*a)+","+(this._y1=e+b*s)}else this._+="L"+(this._x1=t)+","+(this._y1=e)},arc:function(t,e,n,r,i,o){t=+t,e=+e,o=!!o;var l=(n=+n)*Math.cos(r),a=n*Math.sin(r),s=t+l,c=e+a,u=1^o,d=o?r-i:i-r;if(n<0)throw new Error("negative radius: "+n);null===this._x1?this._+="M"+s+","+c:(Math.abs(this._x1-s)>vr||Math.abs(this._y1-c)>vr)&&(this._+="L"+s+","+c),n&&(d<0&&(d=d%mr+mr),d>yr?this._+="A"+n+","+n+",0,1,"+u+","+(t-l)+","+(e-a)+"A"+n+","+n+",0,1,"+u+","+(this._x1=s)+","+(this._y1=c):d>vr&&(this._+="A"+n+","+n+",0,"+ +(d>=gr)+","+u+","+(this._x1=t+n*Math.cos(i))+","+(this._y1=e+n*Math.sin(i))))},rect:function(t,e,n,r){this._+="M"+(this._x0=this._x1=+t)+","+(this._y0=this._y1=+e)+"h"+ +n+"v"+ +r+"h"+-n+"Z"},toString:function(){return this._}};const xr=br;function $r(t){return"object"==typeof t&&"length"in t?t:Array.from(t)}function _r(t){return function(){return t}}function kr(t){this._context=t}function Mr(t){return new kr(t)}function Lr(t){return t[0]}function Sr(t){return t[1]}function Ar(t,e){var n=_r(!0),r=null,i=Mr,o=null;function l(l){var a,s,c,u=(l=$r(l)).length,d=!1;for(null==r&&(o=i(c=xr())),a=0;a<=u;++a)!(a<u&&n(s=l[a],a,l))===d&&((d=!d)?o.lineStart():o.lineEnd()),d&&o.point(+t(s,a,l),+e(s,a,l));if(c)return o=null,c+""||null}return t="function"==typeof t?t:void 0===t?Lr:_r(t),e="function"==typeof e?e:void 0===e?Sr:_r(e),l.x=function(e){return arguments.length?(t="function"==typeof e?e:_r(+e),l):t},l.y=function(t){return arguments.length?(e="function"==typeof t?t:_r(+t),l):e},l.defined=function(t){return arguments.length?(n="function"==typeof t?t:_r(!!t),l):n},l.curve=function(t){return arguments.length?(i=t,null!=r&&(o=i(r)),l):i},l.context=function(t){return arguments.length?(null==t?r=o=null:o=i(r=t),l):r},l}function Nr(t){let e,n,r,i,o,a;return{c(){e=M("text"),n=M("tspan"),r=S(),i=M("title"),o=L(t[6]),z(n,"dominant-baseline","hanging"),z(n,"text-anchor","middle"),z(e,"x",t[2]),z(e,"y",t[3]),z(e,"width",t[0]),z(e,"height",t[1]),z(e,"fill","black"),z(e,"font-size",t[7]),z(e,"transform",a=t[5]?`rotate(270, ${t[2]}, ${t[3]})`:null),E(e,"pdpilot-bold",t[4])},m(l,a){x(l,e,a),w(e,n),t[9](n),w(e,r),w(e,i),w(i,o)},p(t,[n]){64&n&&C(o,t[6]),4&n&&z(e,"x",t[2]),8&n&&z(e,"y",t[3]),1&n&&z(e,"width",t[0]),2&n&&z(e,"height",t[1]),128&n&&z(e,"font-size",t[7]),44&n&&a!==(a=t[5]?`rotate(270, ${t[2]}, ${t[3]})`:null)&&z(e,"transform",a),16&n&&E(e,"pdpilot-bold",t[4])},i:l,o:l,d(n){n&&$(e),t[9](null)}}}function zr(t,e,n){let r,{width:i=0}=e,{height:o=0}=e,{x:l=0}=e,{y:a=0}=e,{bold:s=!1}=e,{rotate:c=!1}=e,{label:u=""}=e,{fontSize:d=14}=e;function h(t,e){if(!r)return;n(8,r.textContent=t,r);let i=t;for(;i.length>0&&r.getComputedTextLength()>e;)i=i.slice(0,-1),n(8,r.textContent=i+"…",r)}return H((()=>{h(u,i)})),t.$$set=t=>{"width"in t&&n(0,i=t.width),"height"in t&&n(1,o=t.height),"x"in t&&n(2,l=t.x),"y"in t&&n(3,a=t.y),"bold"in t&&n(4,s=t.bold),"rotate"in t&&n(5,c=t.rotate),"label"in t&&n(6,u=t.label),"fontSize"in t&&n(7,d=t.fontSize)},t.$$.update=()=>{65&t.$$.dirty&&h(u,i)},[i,o,l,a,s,c,u,d,r,function(t){V[t?"unshift":"push"]((()=>{r=t,n(8,r)}))}]}Array.prototype.slice,kr.prototype={areaStart:function(){this._line=0},areaEnd:function(){this._line=NaN},lineStart:function(){this._point=0},lineEnd:function(){(this._line||0!==this._line&&1===this._point)&&this._context.closePath(),this._line=1-this._line},point:function(t,e){switch(t=+t,e=+e,this._point){case 0:this._point=1,this._line?this._context.lineTo(t,e):this._context.moveTo(t,e);break;case 1:this._point=2;default:this._context.lineTo(t,e)}}};const Tr=class extends mt{constructor(t){super(),gt(this,t,zr,Nr,d,{width:0,height:1,x:2,y:3,bold:4,rotate:5,label:6,fontSize:7})}};function Cr(t,e,n){const r=t.slice();return r[20]=e[n],r}function Br(t,e,n){const r=t.slice();return r[20]=e[n],r}function jr(t){let e,n,r;return{c(){e=M("line"),z(e,"x1",n=t[0].range()[0]),z(e,"x2",r=t[0].range()[1]),z(e,"stroke",t[10])},m(t,n){x(t,e,n)},p(t,i){1&i&&n!==(n=t[0].range()[0])&&z(e,"x1",n),1&i&&r!==(r=t[0].range()[1])&&z(e,"x2",r),1024&i&&z(e,"stroke",t[10])},d(t){t&&$(e)}}}function qr(t){let e,n=t[18](t[0],t[17],t[14]),r=[];for(let e=0;e<n.length;e+=1)r[e]=Or(Cr(t,n,e));return{c(){for(let t=0;t<r.length;t+=1)r[t].c();e=A()},m(t,n){for(let e=0;e<r.length;e+=1)r[e].m(t,n);x(t,e,n)},p(t,i){if(424625&i){let o;for(n=t[18](t[0],t[17],t[14]),o=0;o<n.length;o+=1){const l=Cr(t,n,o);r[o]?r[o].p(l,i):(r[o]=Or(l),r[o].c(),r[o].m(e.parentNode,e))}for(;o<r.length;o+=1)r[o].d(1);r.length=n.length}},i:l,o:l,d(t){_(r,t),t&&$(e)}}}function Pr(t){let e,n,r=t[0].domain(),i=[];for(let e=0;e<r.length;e+=1)i[e]=Rr(Br(t,r,e));const o=t=>at(i[t],1,1,(()=>{i[t]=null}));return{c(){for(let t=0;t<i.length;t+=1)i[t].c();e=A()},m(t,r){for(let e=0;e<i.length;e+=1)i[e].m(t,r);x(t,e,r),n=!0},p(t,n){if(47777&n){let l;for(r=t[0].domain(),l=0;l<r.length;l+=1){const o=Br(t,r,l);i[l]?(i[l].p(o,n),lt(i[l],1)):(i[l]=Rr(o),i[l].c(),lt(i[l],1),i[l].m(e.parentNode,e))}for(it(),l=r.length;l<i.length;l+=1)o(l);ot()}},i(t){if(!n){for(let t=0;t<r.length;t+=1)lt(i[t]);n=!0}},o(t){i=i.filter(Boolean);for(let t=0;t<i.length;t+=1)at(i[t]);n=!1},d(t){_(i,t),t&&$(e)}}}function Er(t){let e,n,r,i,o=t[4](t[20])+"";return{c(){e=M("text"),n=L(o),z(e,"y",r=t[12]+t[13]),z(e,"text-anchor","middle"),z(e,"dominant-baseline","hanging"),z(e,"font-size",t[11]),z(e,"fill","black"),z(e,"stroke-width",i=2),z(e,"paint-order","stroke")},m(t,r){x(t,e,r),w(e,n)},p(t,i){147473&i&&o!==(o=t[4](t[20])+"")&&C(n,o),12288&i&&r!==(r=t[12]+t[13])&&z(e,"y",r),2048&i&&z(e,"font-size",t[11])},d(t){t&&$(e)}}}function Or(t){let e,n,r,i=t[7]&&Er(t);return{c(){e=M("g"),n=M("line"),i&&i.c(),z(n,"y1",t[5]),z(n,"y2",t[12]),z(n,"stroke",t[9]),z(e,"transform",r="translate("+t[0](t[20])+")")},m(t,r){x(t,e,r),w(e,n),i&&i.m(e,null)},p(t,o){32&o&&z(n,"y1",t[5]),4096&o&&z(n,"y2",t[12]),512&o&&z(n,"stroke",t[9]),t[7]?i?i.p(t,o):(i=Er(t),i.c(),i.m(e,null)):i&&(i.d(1),i=null),147457&o&&r!==(r="translate("+t[0](t[20])+")")&&z(e,"transform",r)},d(t){t&&$(e),i&&i.d()}}}function Dr(t){let e,n,r;return{c(){e=M("line"),z(e,"y1",t[5]),z(e,"y2",t[12]),z(e,"x1",n=t[0].bandwidth()/2),z(e,"x2",r=t[0].bandwidth()/2),z(e,"stroke",t[9])},m(t,n){x(t,e,n)},p(t,i){32&i&&z(e,"y1",t[5]),4096&i&&z(e,"y2",t[12]),1&i&&n!==(n=t[0].bandwidth()/2)&&z(e,"x1",n),1&i&&r!==(r=t[0].bandwidth()/2)&&z(e,"x2",r),512&i&&z(e,"stroke",t[9])},d(t){t&&$(e)}}}function Hr(t){let e,n;return e=new Tr({props:{width:t[0].bandwidth()||t[0].step(),height:t[11]*Wr,x:0===t[0].bandwidth()?0:t[0].bandwidth()/2,y:t[12]+t[13],bold:!1,label:t[15][t[20]]??t[20],fontSize:t[11]}}),{c(){ht(e.$$.fragment)},m(t,r){ft(e,t,r),n=!0},p(t,n){const r={};1&n&&(r.width=t[0].bandwidth()||t[0].step()),2048&n&&(r.height=t[11]*Wr),1&n&&(r.x=0===t[0].bandwidth()?0:t[0].bandwidth()/2),12288&n&&(r.y=t[12]+t[13]),32769&n&&(r.label=t[15][t[20]]??t[20]),2048&n&&(r.fontSize=t[11]),e.$set(r)},i(t){n||(lt(e.$$.fragment,t),n=!0)},o(t){at(e.$$.fragment,t),n=!1},d(t){pt(e,t)}}}function Rr(t){let e,n,r,i,o=t[12]>0&&Dr(t),l=t[7]&&Hr(t);return{c(){e=M("g"),o&&o.c(),n=A(),l&&l.c(),z(e,"transform",r="translate("+t[0](t[20])+")")},m(t,r){x(t,e,r),o&&o.m(e,null),w(e,n),l&&l.m(e,null),i=!0},p(t,a){t[12]>0?o?o.p(t,a):(o=Dr(t),o.c(),o.m(e,n)):o&&(o.d(1),o=null),t[7]?l?(l.p(t,a),128&a&&lt(l,1)):(l=Hr(t),l.c(),lt(l,1),l.m(e,null)):l&&(it(),at(l,1,1,(()=>{l=null})),ot()),(!i||1&a&&r!==(r="translate("+t[0](t[20])+")"))&&z(e,"transform",r)},i(t){i||(lt(l),i=!0)},o(t){at(l),i=!1},d(t){t&&$(e),o&&o.d(),l&&l.d()}}}function Ir(t){let e,n;return e=new Tr({props:{width:t[17],height:t[11]*Wr,x:t[17]/2+t[16],y:t[12]+t[13]+t[11]+Fr,bold:!0,label:t[1],fontSize:t[11]}}),{c(){ht(e.$$.fragment)},m(t,r){ft(e,t,r),n=!0},p(t,n){const r={};131072&n&&(r.width=t[17]),2048&n&&(r.height=t[11]*Wr),196608&n&&(r.x=t[17]/2+t[16]),14336&n&&(r.y=t[12]+t[13]+t[11]+Fr),2&n&&(r.label=t[1]),2048&n&&(r.fontSize=t[11]),e.$set(r)},i(t){n||(lt(e.$$.fragment,t),n=!0)},o(t){at(e.$$.fragment,t),n=!1},d(t){pt(e,t)}}}function Vr(t){let e,n,r,i,o,l,a,s=t[8]&&jr(t);const c=[Pr,qr],u=[];function d(t,e){return"bandwidth"in t[0]?0:1}i=d(t),o=u[i]=c[i](t);let h=t[6]&&Ir(t);return{c(){e=M("g"),n=M("g"),s&&s.c(),r=A(),o.c(),h&&h.c(),z(e,"transform",l="translate("+t[2]+","+t[3]+")")},m(t,o){x(t,e,o),w(e,n),s&&s.m(n,null),w(n,r),u[i].m(n,null),h&&h.m(e,null),a=!0},p(t,[f]){t[8]?s?s.p(t,f):(s=jr(t),s.c(),s.m(n,r)):s&&(s.d(1),s=null);let p=i;i=d(t),i===p?u[i].p(t,f):(it(),at(u[p],1,1,(()=>{u[p]=null})),ot(),o=u[i],o?o.p(t,f):(o=u[i]=c[i](t),o.c()),lt(o,1),o.m(n,null)),t[6]?h?(h.p(t,f),64&f&&lt(h,1)):(h=Ir(t),h.c(),lt(h,1),h.m(e,null)):h&&(it(),at(h,1,1,(()=>{h=null})),ot()),(!a||12&f&&l!==(l="translate("+t[2]+","+t[3]+")"))&&z(e,"transform",l)},i(t){a||(lt(o),lt(h),a=!0)},o(t){at(o),at(h),a=!1},d(t){t&&$(e),s&&s.d(),u[i].d(),h&&h.d()}}}const Fr=2,Wr=1.2;function Xr(t,e,n){let r,i,o,{scale:l}=e,{label:a=""}=e,{x:s=0}=e,{y:c=0}=e,{format:u=kn}=e,{gridHeight:d=0}=e,{showAxisLabel:h=!0}=e,{showTickLabels:f=!0}=e,{showBaseline:p=!1}=e,{tickColor:g="black"}=e,{baselineColor:m="black"}=e,{fontSize:v=10}=e,{tickSize:y=5}=e,{gapBetweenTickAndTickLabel:w=2}=e,{integerOnly:b=!1}=e,{value_map:x={}}=e;return t.$$set=t=>{"scale"in t&&n(0,l=t.scale),"label"in t&&n(1,a=t.label),"x"in t&&n(2,s=t.x),"y"in t&&n(3,c=t.y),"format"in t&&n(4,u=t.format),"gridHeight"in t&&n(5,d=t.gridHeight),"showAxisLabel"in t&&n(6,h=t.showAxisLabel),"showTickLabels"in t&&n(7,f=t.showTickLabels),"showBaseline"in t&&n(8,p=t.showBaseline),"tickColor"in t&&n(9,g=t.tickColor),"baselineColor"in t&&n(10,m=t.baselineColor),"fontSize"in t&&n(11,v=t.fontSize),"tickSize"in t&&n(12,y=t.tickSize),"gapBetweenTickAndTickLabel"in t&&n(13,w=t.gapBetweenTickAndTickLabel),"integerOnly"in t&&n(14,b=t.integerOnly),"value_map"in t&&n(15,x=t.value_map)},t.$$.update=()=>{1&t.$$.dirty&&n(16,r=l.range()[0]),1&t.$$.dirty&&n(19,i=l.range()[l.range().length-1]),589824&t.$$.dirty&&n(17,o=i-r)},[l,a,s,c,u,d,h,f,p,g,m,v,y,w,b,x,r,o,function(t,e,n){const r=t.ticks(Math.min(e/50,10));return n?r.filter(Number.isInteger):r},i]}const Yr=class extends mt{constructor(t){super(),gt(this,t,Xr,Vr,d,{scale:0,label:1,x:2,y:3,format:4,gridHeight:5,showAxisLabel:6,showTickLabels:7,showBaseline:8,tickColor:9,baselineColor:10,fontSize:11,tickSize:12,gapBetweenTickAndTickLabel:13,integerOnly:14,value_map:15})}};function Kr(t,e,n){const r=t.slice();return r[20]=e[n],r}function Ur(t,e,n){const r=t.slice();return r[20]=e[n],r}function Gr(t){let e,n,r;return{c(){e=M("line"),z(e,"y1",n=t[0].range()[0]),z(e,"y2",r=t[0].range()[1]),z(e,"stroke",t[10])},m(t,n){x(t,e,n)},p(t,i){1&i&&n!==(n=t[0].range()[0])&&z(e,"y1",n),1&i&&r!==(r=t[0].range()[1])&&z(e,"y2",r),1024&i&&z(e,"stroke",t[10])},d(t){t&&$(e)}}}function Zr(t){let e,n=t[18](t[0],t[17],t[14]),r=[];for(let e=0;e<n.length;e+=1)r[e]=ti(Kr(t,n,e));return{c(){for(let t=0;t<r.length;t+=1)r[t].c();e=A()},m(t,n){for(let e=0;e<r.length;e+=1)r[e].m(t,n);x(t,e,n)},p(t,i){if(424625&i){let o;for(n=t[18](t[0],t[17],t[14]),o=0;o<n.length;o+=1){const l=Kr(t,n,o);r[o]?r[o].p(l,i):(r[o]=ti(l),r[o].c(),r[o].m(e.parentNode,e))}for(;o<r.length;o+=1)r[o].d(1);r.length=n.length}},i:l,o:l,d(t){_(r,t),t&&$(e)}}}function Jr(t){let e,n,r=[],i=new Map,o=t[0].domain();const l=t=>t[20];for(let e=0;e<o.length;e+=1){let n=Ur(t,o,e),a=l(n);i.set(a,r[e]=ri(a,n))}return{c(){for(let t=0;t<r.length;t+=1)r[t].c();e=A()},m(t,i){for(let e=0;e<r.length;e+=1)r[e].m(t,i);x(t,e,i),n=!0},p(t,n){47777&n&&(o=t[0].domain(),it(),r=ut(r,n,l,1,t,o,i,e.parentNode,ct,ri,e,Ur),ot())},i(t){if(!n){for(let t=0;t<o.length;t+=1)lt(r[t]);n=!0}},o(t){for(let t=0;t<r.length;t+=1)at(r[t]);n=!1},d(t){for(let e=0;e<r.length;e+=1)r[e].d(t);t&&$(e)}}}function Qr(t){let e,n,r,i,o=t[4](t[20])+"";return{c(){e=M("text"),n=L(o),z(e,"x",r=-t[12]-t[13]),z(e,"text-anchor","end"),z(e,"dominant-baseline","middle"),z(e,"font-size",t[11]),z(e,"fill","black"),z(e,"stroke-width",i=2),z(e,"paint-order","stroke")},m(t,r){x(t,e,r),w(e,n)},p(t,i){147473&i&&o!==(o=t[4](t[20])+"")&&C(n,o),12288&i&&r!==(r=-t[12]-t[13])&&z(e,"x",r),2048&i&&z(e,"font-size",t[11])},d(t){t&&$(e)}}}function ti(t){let e,n,r,i,o=t[7]&&Qr(t);return{c(){e=M("g"),n=M("line"),o&&o.c(),z(n,"x1",r=-t[12]),z(n,"x2",t[5]),z(n,"stroke",t[9]),z(e,"transform",i="translate(0,"+t[0](t[20])+")")},m(t,r){x(t,e,r),w(e,n),o&&o.m(e,null)},p(t,l){4096&l&&r!==(r=-t[12])&&z(n,"x1",r),32&l&&z(n,"x2",t[5]),512&l&&z(n,"stroke",t[9]),t[7]?o?o.p(t,l):(o=Qr(t),o.c(),o.m(e,null)):o&&(o.d(1),o=null),147457&l&&i!==(i="translate(0,"+t[0](t[20])+")")&&z(e,"transform",i)},d(t){t&&$(e),o&&o.d()}}}function ei(t){let e,n,r,i;return{c(){e=M("line"),z(e,"y1",n=t[0].bandwidth()/2),z(e,"y2",r=t[0].bandwidth()/2),z(e,"x1",i=-t[12]),z(e,"x2",t[5]),z(e,"stroke",t[9])},m(t,n){x(t,e,n)},p(t,o){1&o&&n!==(n=t[0].bandwidth()/2)&&z(e,"y1",n),1&o&&r!==(r=t[0].bandwidth()/2)&&z(e,"y2",r),4096&o&&i!==(i=-t[12])&&z(e,"x1",i),32&o&&z(e,"x2",t[5]),512&o&&z(e,"stroke",t[9])},d(t){t&&$(e)}}}function ni(t){let e,n;return e=new Tr({props:{width:t[0].bandwidth()||t[0].step(),height:t[11]*ai,x:-(t[12]+t[11]+t[13]),y:0===t[0].bandwidth()?0:t[0].bandwidth()/2,bold:!1,label:t[15][t[20]]??t[20],fontSize:t[11],rotate:!0}}),{c(){ht(e.$$.fragment)},m(t,r){ft(e,t,r),n=!0},p(t,n){const r={};1&n&&(r.width=t[0].bandwidth()||t[0].step()),2048&n&&(r.height=t[11]*ai),14336&n&&(r.x=-(t[12]+t[11]+t[13])),1&n&&(r.y=0===t[0].bandwidth()?0:t[0].bandwidth()/2),32769&n&&(r.label=t[15][t[20]]??t[20]),2048&n&&(r.fontSize=t[11]),e.$set(r)},i(t){n||(lt(e.$$.fragment,t),n=!0)},o(t){at(e.$$.fragment,t),n=!1},d(t){pt(e,t)}}}function ri(t,e){let n,r,i,o,l=e[12]>0&&ei(e),a=e[7]&&ni(e);return{key:t,first:null,c(){n=M("g"),l&&l.c(),r=A(),a&&a.c(),z(n,"transform",i="translate(0,"+e[0](e[20])+")"),this.first=n},m(t,e){x(t,n,e),l&&l.m(n,null),w(n,r),a&&a.m(n,null),o=!0},p(t,s){(e=t)[12]>0?l?l.p(e,s):(l=ei(e),l.c(),l.m(n,r)):l&&(l.d(1),l=null),e[7]?a?(a.p(e,s),128&s&&lt(a,1)):(a=ni(e),a.c(),lt(a,1),a.m(n,null)):a&&(it(),at(a,1,1,(()=>{a=null})),ot()),(!o||1&s&&i!==(i="translate(0,"+e[0](e[20])+")"))&&z(n,"transform",i)},i(t){o||(lt(a),o=!0)},o(t){at(a),o=!1},d(t){t&&$(n),l&&l.d(),a&&a.d()}}}function ii(t){let e,n;return e=new Tr({props:{width:t[17],height:t[11]*ai,x:-(t[12]+t[13]+t[11]+li),y:t[17]/2+t[16],bold:!0,label:t[1],rotate:!0,fontSize:t[11]}}),{c(){ht(e.$$.fragment)},m(t,r){ft(e,t,r),n=!0},p(t,n){const r={};131072&n&&(r.width=t[17]),2048&n&&(r.height=t[11]*ai),14336&n&&(r.x=-(t[12]+t[13]+t[11]+li)),196608&n&&(r.y=t[17]/2+t[16]),2&n&&(r.label=t[1]),2048&n&&(r.fontSize=t[11]),e.$set(r)},i(t){n||(lt(e.$$.fragment,t),n=!0)},o(t){at(e.$$.fragment,t),n=!1},d(t){pt(e,t)}}}function oi(t){let e,n,r,i,o,l,a,s=t[8]&&Gr(t);const c=[Jr,Zr],u=[];function d(t,e){return"bandwidth"in t[0]?0:1}i=d(t),o=u[i]=c[i](t);let h=t[6]&&ii(t);return{c(){e=M("g"),n=M("g"),s&&s.c(),r=A(),o.c(),h&&h.c(),z(e,"transform",l="translate("+t[2]+","+t[3]+")")},m(t,o){x(t,e,o),w(e,n),s&&s.m(n,null),w(n,r),u[i].m(n,null),h&&h.m(e,null),a=!0},p(t,[f]){t[8]?s?s.p(t,f):(s=Gr(t),s.c(),s.m(n,r)):s&&(s.d(1),s=null);let p=i;i=d(t),i===p?u[i].p(t,f):(it(),at(u[p],1,1,(()=>{u[p]=null})),ot(),o=u[i],o?o.p(t,f):(o=u[i]=c[i](t),o.c()),lt(o,1),o.m(n,null)),t[6]?h?(h.p(t,f),64&f&&lt(h,1)):(h=ii(t),h.c(),lt(h,1),h.m(e,null)):h&&(it(),at(h,1,1,(()=>{h=null})),ot()),(!a||12&f&&l!==(l="translate("+t[2]+","+t[3]+")"))&&z(e,"transform",l)},i(t){a||(lt(o),lt(h),a=!0)},o(t){at(o),at(h),a=!1},d(t){t&&$(e),s&&s.d(),u[i].d(),h&&h.d()}}}const li=30,ai=1.2;function si(t,e,n){let r,i,o,{scale:l}=e,{label:a=""}=e,{x:s=0}=e,{y:c=0}=e,{format:u=kn}=e,{gridWidth:d=0}=e,{showAxisLabel:h=!0}=e,{showTickLabels:f=!0}=e,{showBaseline:p=!1}=e,{tickColor:g="black"}=e,{baselineColor:m="black"}=e,{fontSize:v=10}=e,{tickSize:y=5}=e,{gapBetweenTickAndTickLabel:w=2}=e,{integerOnly:b=!1}=e,{value_map:x={}}=e;return t.$$set=t=>{"scale"in t&&n(0,l=t.scale),"label"in t&&n(1,a=t.label),"x"in t&&n(2,s=t.x),"y"in t&&n(3,c=t.y),"format"in t&&n(4,u=t.format),"gridWidth"in t&&n(5,d=t.gridWidth),"showAxisLabel"in t&&n(6,h=t.showAxisLabel),"showTickLabels"in t&&n(7,f=t.showTickLabels),"showBaseline"in t&&n(8,p=t.showBaseline),"tickColor"in t&&n(9,g=t.tickColor),"baselineColor"in t&&n(10,m=t.baselineColor),"fontSize"in t&&n(11,v=t.fontSize),"tickSize"in t&&n(12,y=t.tickSize),"gapBetweenTickAndTickLabel"in t&&n(13,w=t.gapBetweenTickAndTickLabel),"integerOnly"in t&&n(14,b=t.integerOnly),"value_map"in t&&n(15,x=t.value_map)},t.$$.update=()=>{1&t.$$.dirty&&n(16,r=Math.min(l.range()[0],l.range()[l.range().length-1])),1&t.$$.dirty&&n(19,i=Math.max(l.range()[0],l.range()[l.range().length-1])),589824&t.$$.dirty&&n(17,o=i-r)},[l,a,s,c,u,d,h,f,p,g,m,v,y,w,b,x,r,o,function(t,e,n){const r=t.ticks(Math.min(e/30,10));return n?r.filter(Number.isInteger):r},i]}const ci=class extends mt{constructor(t){super(),gt(this,t,si,oi,d,{scale:0,label:1,x:2,y:3,format:4,gridWidth:5,showAxisLabel:6,showTickLabels:7,showBaseline:8,tickColor:9,baselineColor:10,fontSize:11,tickSize:12,gapBetweenTickAndTickLabel:13,integerOnly:14,value_map:15})}};function ui(t,e,n){const r=t.slice();return r[13]=e[n],r}function di(t,e,n){const r=t.slice();return r[13]=e[n],r}function hi(t){let e,n,r,i,o,l=t[8],a=[];for(let e=0;e<l.length;e+=1)a[e]=pi(ui(t,l,e));return{c(){for(let t=0;t<a.length;t+=1)a[t].c();e=M("line"),z(e,"x1",n=0),z(e,"x2",r=0),z(e,"y1",i=t[3].range()[0]),z(e,"y2",o=t[3].range()[1]),z(e,"stroke","var(--gray-1)")},m(t,n){for(let e=0;e<a.length;e+=1)a[e].m(t,n);x(t,e,n)},p(t,n){if(1001&n){let r;for(l=t[8],r=0;r<l.length;r+=1){const i=ui(t,l,r);a[r]?a[r].p(i,n):(a[r]=pi(i),a[r].c(),a[r].m(e.parentNode,e))}for(;r<a.length;r+=1)a[r].d(1);a.length=l.length}8&n&&i!==(i=t[3].range()[0])&&z(e,"y1",i),8&n&&o!==(o=t[3].range()[1])&&z(e,"y2",o)},d(t){_(a,t),t&&$(e)}}}function fi(t){let e,n,r,i=t[8],o=[];for(let e=0;e<i.length;e+=1)o[e]=gi(di(t,i,e));return{c(){for(let t=0;t<o.length;t+=1)o[t].c();e=M("line"),z(e,"x1",n=t[3].range()[0]),z(e,"x2",r=t[3].range()[1]),z(e,"y1",t[1]),z(e,"y2",t[1]),z(e,"stroke","var(--gray-1)")},m(t,n){for(let e=0;e<o.length;e+=1)o[e].m(t,n);x(t,e,n)},p(t,l){if(1001&l){let n;for(i=t[8],n=0;n<i.length;n+=1){const r=di(t,i,n);o[n]?o[n].p(r,l):(o[n]=gi(r),o[n].c(),o[n].m(e.parentNode,e))}for(;n<o.length;n+=1)o[n].d(1);o.length=i.length}8&l&&n!==(n=t[3].range()[0])&&z(e,"x1",n),8&l&&r!==(r=t[3].range()[1])&&z(e,"x2",r),2&l&&z(e,"y1",t[1]),2&l&&z(e,"y2",t[1])},d(t){_(o,t),t&&$(e)}}}function pi(t){let e,n,r,i,o;return{c(){e=M("rect"),z(e,"x",n=0),z(e,"y",r=t[3](t[0].bins[t[13]+1])+1),z(e,"width",i=t[7](t[9](t[0],t[13]))),z(e,"height",o=t[3](t[0].bins[t[13]])-t[3](t[0].bins[t[13]+1])-2),z(e,"fill",t[5]),z(e,"stroke",t[6])},m(t,n){x(t,e,n)},p(t,n){265&n&&r!==(r=t[3](t[0].bins[t[13]+1])+1)&&z(e,"y",r),897&n&&i!==(i=t[7](t[9](t[0],t[13])))&&z(e,"width",i),265&n&&o!==(o=t[3](t[0].bins[t[13]])-t[3](t[0].bins[t[13]+1])-2)&&z(e,"height",o),32&n&&z(e,"fill",t[5]),64&n&&z(e,"stroke",t[6])},d(t){t&&$(e)}}}function gi(t){let e,n,r,i,o;return{c(){e=M("rect"),z(e,"x",n=t[3](t[0].bins[t[13]])+1),z(e,"y",r=t[7](t[9](t[0],t[13]))),z(e,"width",i=t[3](t[0].bins[t[13]+1])-t[3](t[0].bins[t[13]])-2),z(e,"height",o=t[7](0)-t[7](t[9](t[0],t[13]))),z(e,"fill",t[5]),z(e,"stroke",t[6])},m(t,n){x(t,e,n)},p(t,l){265&l&&n!==(n=t[3](t[0].bins[t[13]])+1)&&z(e,"x",n),897&l&&r!==(r=t[7](t[9](t[0],t[13])))&&z(e,"y",r),265&l&&i!==(i=t[3](t[0].bins[t[13]+1])-t[3](t[0].bins[t[13]])-2)&&z(e,"width",i),897&l&&o!==(o=t[7](0)-t[7](t[9](t[0],t[13])))&&z(e,"height",o),32&l&&z(e,"fill",t[5]),64&l&&z(e,"stroke",t[6])},d(t){t&&$(e)}}}function mi(t){let e,n;function r(t,e){return"horizontal"===t[2]?fi:hi}let i=r(t),o=i(t);return{c(){e=M("g"),o.c(),z(e,"transform",n="translate("+t[4]+")")},m(t,n){x(t,e,n),o.m(e,null)},p(t,[l]){i===(i=r(t))&&o?o.p(t,l):(o.d(1),o=i(t),o&&(o.c(),o.m(e,null))),16&l&&n!==(n="translate("+t[4]+")")&&z(e,"transform",n)},i:l,o:l,d(t){t&&$(e),o.d()}}}function vi(t,e){return t.counts[e]}function yi(t,e){return t.percents[e]}function wi(t,e,n){let r,i,o,l,{data:a}=e,{height:s}=e,{direction:c}=e,{x:u}=e,{translate:d=[0,0]}=e,{fill:h="var(--gray-3)"}=e,{stroke:f="none"}=e,{unit:p="count"}=e,{maxValue:g=0}=e;return t.$$set=t=>{"data"in t&&n(0,a=t.data),"height"in t&&n(1,s=t.height),"direction"in t&&n(2,c=t.direction),"x"in t&&n(3,u=t.x),"translate"in t&&n(4,d=t.translate),"fill"in t&&n(5,h=t.fill),"stroke"in t&&n(6,f=t.stroke),"unit"in t&&n(10,p=t.unit),"maxValue"in t&&n(11,g=t.maxValue)},t.$$.update=()=>{3073&t.$$.dirty&&n(12,r=g||("count"===p?Math.max(...a.counts):Math.max(...a.percents))),1024&t.$$.dirty&&n(9,i="count"===p?vi:yi),1&t.$$.dirty&&n(8,o=xn(a.counts.length)),4102&t.$$.dirty&&n(7,l=en().domain([0,r]).range("horizontal"===c?[s,0]:[0,s]))},[a,s,c,u,d,h,f,l,o,i,p,g,r]}const bi=class extends mt{constructor(t){super(),gt(this,t,wi,mi,d,{data:0,height:1,direction:2,x:3,translate:4,fill:5,stroke:6,unit:10,maxValue:11})}};function xi(t,e,n){const r=t.slice();return r[15]=e[n],r}function $i(t,e,n){const r=t.slice();return r[15]=e[n],r}function _i(t){let e,n,r,i,o,l=t[10],a=[];for(let e=0;e<l.length;e+=1)a[e]=Mi(xi(t,l,e));return{c(){for(let t=0;t<a.length;t+=1)a[t].c();e=M("line"),z(e,"x1",n=0),z(e,"x2",r=0),z(e,"y1",i=t[3].range()[0]),z(e,"y2",o=t[3].range()[1]),z(e,"stroke","var(--gray-1)")},m(t,n){for(let e=0;e<a.length;e+=1)a[e].m(t,n);x(t,e,n)},p(t,n){if(4073&n){let r;for(l=t[10],r=0;r<l.length;r+=1){const i=xi(t,l,r);a[r]?a[r].p(i,n):(a[r]=Mi(i),a[r].c(),a[r].m(e.parentNode,e))}for(;r<a.length;r+=1)a[r].d(1);a.length=l.length}8&n&&i!==(i=t[3].range()[0])&&z(e,"y1",i),8&n&&o!==(o=t[3].range()[1])&&z(e,"y2",o)},d(t){_(a,t),t&&$(e)}}}function ki(t){let e,n,r,i=t[10],o=[];for(let e=0;e<i.length;e+=1)o[e]=Li($i(t,i,e));return{c(){for(let t=0;t<o.length;t+=1)o[t].c();e=M("line"),z(e,"x1",n=t[3].range()[0]),z(e,"x2",r=t[3].range()[1]),z(e,"y1",t[1]),z(e,"y2",t[1]),z(e,"stroke","var(--gray-1)")},m(t,n){for(let e=0;e<o.length;e+=1)o[e].m(t,n);x(t,e,n)},p(t,l){if(4073&l){let n;for(i=t[10],n=0;n<i.length;n+=1){const r=$i(t,i,n);o[n]?o[n].p(r,l):(o[n]=Li(r),o[n].c(),o[n].m(e.parentNode,e))}for(;n<o.length;n+=1)o[n].d(1);o.length=i.length}8&l&&n!==(n=t[3].range()[0])&&z(e,"x1",n),8&l&&r!==(r=t[3].range()[1])&&z(e,"x2",r),2&l&&z(e,"y1",t[1]),2&l&&z(e,"y2",t[1])},d(t){_(o,t),t&&$(e)}}}function Mi(t){let e,n,r,i;return{c(){e=M("rect"),z(e,"x",n=0),z(e,"y",r=(t[3](t[0].bins[t[15]])??0)-t[8]),z(e,"width",i=t[9](t[11](t[0],t[15]))),z(e,"height",t[7]),z(e,"fill",t[5]),z(e,"stroke",t[6])},m(t,n){x(t,e,n)},p(t,n){1289&n&&r!==(r=(t[3](t[0].bins[t[15]])??0)-t[8])&&z(e,"y",r),3585&n&&i!==(i=t[9](t[11](t[0],t[15])))&&z(e,"width",i),128&n&&z(e,"height",t[7]),32&n&&z(e,"fill",t[5]),64&n&&z(e,"stroke",t[6])},d(t){t&&$(e)}}}function Li(t){let e,n,r,i;return{c(){e=M("rect"),z(e,"x",n=(t[3](t[0].bins[t[15]])??0)-t[8]),z(e,"y",r=t[9](t[11](t[0],t[15]))),z(e,"width",t[7]),z(e,"height",i=t[9](0)-t[9](t[11](t[0],t[15]))),z(e,"fill",t[5]),z(e,"stroke",t[6])},m(t,n){x(t,e,n)},p(t,o){1289&o&&n!==(n=(t[3](t[0].bins[t[15]])??0)-t[8])&&z(e,"x",n),3585&o&&r!==(r=t[9](t[11](t[0],t[15])))&&z(e,"y",r),128&o&&z(e,"width",t[7]),3585&o&&i!==(i=t[9](0)-t[9](t[11](t[0],t[15])))&&z(e,"height",i),32&o&&z(e,"fill",t[5]),64&o&&z(e,"stroke",t[6])},d(t){t&&$(e)}}}function Si(t){let e,n;function r(t,e){return"horizontal"===t[2]?ki:_i}let i=r(t),o=i(t);return{c(){e=M("g"),o.c(),z(e,"transform",n="translate("+t[4]+")")},m(t,n){x(t,e,n),o.m(e,null)},p(t,[l]){i===(i=r(t))&&o?o.p(t,l):(o.d(1),o=i(t),o&&(o.c(),o.m(e,null))),16&l&&n!==(n="translate("+t[4]+")")&&z(e,"transform",n)},i:l,o:l,d(t){t&&$(e),o.d()}}}function Ai(t,e){return t.counts[e]}function Ni(t,e){return t.percents[e]}function zi(t,e,n){let r,i,o,l,a,s,{data:c}=e,{height:u}=e,{direction:d}=e,{x:h}=e,{translate:f=[0,0]}=e,{fill:p="var(--gray-3)"}=e,{stroke:g="none"}=e,{unit:m="count"}=e,{maxValue:v=0}=e;return t.$$set=t=>{"data"in t&&n(0,c=t.data),"height"in t&&n(1,u=t.height),"direction"in t&&n(2,d=t.direction),"x"in t&&n(3,h=t.x),"translate"in t&&n(4,f=t.translate),"fill"in t&&n(5,p=t.fill),"stroke"in t&&n(6,g=t.stroke),"unit"in t&&n(12,m=t.unit),"maxValue"in t&&n(13,v=t.maxValue)},t.$$.update=()=>{12289&t.$$.dirty&&n(14,r=v||("count"===m?Math.max(...c.counts):Math.max(...c.percents))),4096&t.$$.dirty&&n(11,i="count"===m?Ai:Ni),1&t.$$.dirty&&n(10,o=xn(c.counts.length)),16390&t.$$.dirty&&n(9,l=en().domain([0,r]).range("horizontal"===d?[u,0]:[0,u])),8&t.$$.dirty&&n(7,a=(h.bandwidth()||h.step()*h.padding())-2),136&t.$$.dirty&&n(8,s=(0===h.bandwidth()?a/2:0)-1)},[c,u,d,h,f,p,g,a,s,l,o,i,m,v,r]}const Ti=class extends mt{constructor(t){super(),gt(this,t,zi,Si,d,{data:0,height:1,direction:2,x:3,translate:4,fill:5,stroke:6,unit:12,maxValue:13})}};function Ci(t){b(t,"svelte-y91ye",".cluster-lines-container.svelte-y91ye{width:100%;height:100%;display:flex;flex-direction:column}.cluster-lines-header.svelte-y91ye{margin-bottom:0.5em}.cluster-lines-settings.svelte-y91ye{display:flex;align-items:center;gap:0.5em}.cluster-lines-chart.svelte-y91ye{position:relative;width:100%;flex:1}.num-cluster-change.svelte-y91ye{display:flex;align-items:center;gap:0.25em}.svg-for-clusters.svelte-y91ye,canvas.svelte-y91ye{position:absolute;top:0;left:0}")}function Bi(t,e,n){const r=t.slice();return r[37]=e[n],r}function ji(t){let e;return{c(){e=k("div"),e.textContent="ICE Clusters",z(e,"class","cluster-lines-title pdpilot-bold")},m(t,n){x(t,e,n)},d(t){t&&$(e)}}}function qi(t){let e,n,r,i;const o=[Ei,Pi],l=[];function a(t,e){return"bandwidth"in t[10]?0:1}return n=a(t),r=l[n]=o[n](t),{c(){e=M("svg"),r.c(),z(e,"width",t[1]),z(e,"height",t[3])},m(t,r){x(t,e,r),l[n].m(e,null),i=!0},p(t,s){let c=n;n=a(t),n===c?l[n].p(t,s):(it(),at(l[c],1,1,(()=>{l[c]=null})),ot(),r=l[n],r?r.p(t,s):(r=l[n]=o[n](t),r.c()),lt(r,1),r.m(e,null)),(!i||2&s[0])&&z(e,"width",t[1]),(!i||8&s[0])&&z(e,"height",t[3])},i(t){i||(lt(r),i=!0)},o(t){at(r),i=!1},d(t){t&&$(e),l[n].d()}}}function Pi(t){let e,n;return e=new bi({props:{data:t[15][t[0].x_feature].distribution,x:t[10],height:t[4],direction:"horizontal",translate:[0,t[3]-t[4]]}}),{c(){ht(e.$$.fragment)},m(t,r){ft(e,t,r),n=!0},p(t,n){const r={};32769&n[0]&&(r.data=t[15][t[0].x_feature].distribution),1024&n[0]&&(r.x=t[10]),16&n[0]&&(r.height=t[4]),24&n[0]&&(r.translate=[0,t[3]-t[4]]),e.$set(r)},i(t){n||(lt(e.$$.fragment,t),n=!0)},o(t){at(e.$$.fragment,t),n=!1},d(t){pt(e,t)}}}function Ei(t){let e,n;return e=new Ti({props:{data:t[15][t[0].x_feature].distribution,x:t[10],height:t[4],direction:"horizontal",translate:[0,t[3]-t[4]]}}),{c(){ht(e.$$.fragment)},m(t,r){ft(e,t,r),n=!0},p(t,n){const r={};32769&n[0]&&(r.data=t[15][t[0].x_feature].distribution),1024&n[0]&&(r.x=t[10]),16&n[0]&&(r.height=t[4]),24&n[0]&&(r.translate=[0,t[3]-t[4]]),e.$set(r)},i(t){n||(lt(e.$$.fragment,t),n=!0)},o(t){at(e.$$.fragment,t),n=!1},d(t){pt(e,t)}}}function Oi(t){let e,n,r,i,o;return n=new ci({props:{scale:t[9],x:t[12].left,label:"centered prediction"}}),r=new Yr({props:{scale:t[10],y:t[13]-t[12].bottom,showTickLabels:t[37].id===t[11][t[11].length-1],showAxisLabel:t[37].id===t[11][t[11].length-1],label:t[0].x_feature,integerOnly:"discrete"===t[14].subkind,value_map:"value_map"in t[14]?t[14].value_map:{}}}),{c(){e=M("g"),ht(n.$$.fragment),ht(r.$$.fragment),z(e,"transform",i="translate(0,"+(t[8](t[37].id)??0)+")")},m(t,i){x(t,e,i),ft(n,e,null),ft(r,e,null),o=!0},p(t,l){const a={};512&l[0]&&(a.scale=t[9]),4096&l[0]&&(a.x=t[12].left),n.$set(a);const s={};1024&l[0]&&(s.scale=t[10]),12288&l[0]&&(s.y=t[13]-t[12].bottom),133120&l[0]&&(s.showTickLabels=t[37].id===t[11][t[11].length-1]),133120&l[0]&&(s.showAxisLabel=t[37].id===t[11][t[11].length-1]),1&l[0]&&(s.label=t[0].x_feature),16384&l[0]&&(s.integerOnly="discrete"===t[14].subkind),16384&l[0]&&(s.value_map="value_map"in t[14]?t[14].value_map:{}),r.$set(s),(!o||131328&l[0]&&i!==(i="translate(0,"+(t[8](t[37].id)??0)+")"))&&z(e,"transform",i)},i(t){o||(lt(n.$$.fragment,t),lt(r.$$.fragment,t),o=!0)},o(t){at(n.$$.fragment,t),at(r.$$.fragment,t),o=!1},d(t){t&&$(e),pt(n),pt(r)}}}function Di(t){let e,n,r,i,o,l,a,s,u,d,h,f,p,g,m,v,y,b,A,T,B,j,q,P,E,O,D,H,R,I,V,F=t[0].ice.num_clusters+"",W=t[5]&&ji(),X=t[2]&&qi(t),Y=t[17],K=[];for(let e=0;e<Y.length;e+=1)K[e]=Oi(Bi(t,Y,e));const U=t=>at(K[t],1,1,(()=>{K[t]=null}));return{c(){e=k("div"),n=k("div"),W&&W.c(),r=S(),i=k("div"),o=k("div"),o.textContent="Number of clusters:",l=S(),a=k("div"),s=k("button"),u=M("svg"),d=M("path"),h=M("path"),p=S(),g=k("div"),m=L(F),v=S(),y=k("button"),b=M("svg"),A=M("path"),T=M("path"),B=M("path"),q=S(),X&&X.c(),P=S(),E=k("div"),O=k("canvas"),D=S(),H=M("svg");for(let t=0;t<K.length;t+=1)K[t].c();z(d,"stroke","none"),z(d,"d","M0 0h24v24H0z"),z(d,"fill","none"),z(h,"d","M5 12l14 0"),z(u,"xmlns","http://www.w3.org/2000/svg"),z(u,"class","pdpilot-icon icon-tabler icon-tabler-minus"),z(u,"width","24"),z(u,"height","24"),z(u,"viewBox","0 0 24 24"),z(u,"stroke-width","2"),z(u,"stroke","currentColor"),z(u,"fill","none"),z(u,"stroke-linecap","round"),z(u,"stroke-linejoin","round"),s.disabled=f=t[0].ice.num_clusters<=2,z(s,"title","Decrement number of clusters"),z(g,"class","current-num-clusters"),z(A,"stroke","none"),z(A,"d","M0 0h24v24H0z"),z(A,"fill","none"),z(T,"d","M12 5l0 14"),z(B,"d","M5 12l14 0"),z(b,"xmlns","http://www.w3.org/2000/svg"),z(b,"class","pdpilot-icon icon-tabler icon-tabler-plus"),z(b,"width","24"),z(b,"height","24"),z(b,"viewBox","0 0 24 24"),z(b,"stroke-width","2"),z(b,"stroke","currentColor"),z(b,"fill","none"),z(b,"stroke-linecap","round"),z(b,"stroke-linejoin","round"),y.disabled=j=1===t[0].ice.num_clusters||t[0].ice.num_clusters>=5,z(y,"title","Increment number of clusters"),z(a,"class","num-cluster-change svelte-y91ye"),z(i,"class","cluster-lines-settings svelte-y91ye"),z(n,"class","cluster-lines-header svelte-y91ye"),z(O,"class","svelte-y91ye"),z(H,"class","svg-for-clusters svelte-y91ye"),z(H,"height",t[7]),z(H,"width",t[1]),z(E,"class","cluster-lines-chart svelte-y91ye"),z(e,"class","cluster-lines-container svelte-y91ye")},m(c,f){x(c,e,f),w(e,n),W&&W.m(n,null),w(n,r),w(n,i),w(i,o),w(i,l),w(i,a),w(a,s),w(s,u),w(u,d),w(u,h),w(a,p),w(a,g),w(g,m),w(a,v),w(a,y),w(y,b),w(b,A),w(b,T),w(b,B),w(e,q),X&&X.m(e,null),w(e,P),w(e,E),w(E,O),t[29](O),w(E,D),w(E,H);for(let t=0;t<K.length;t+=1)K[t].m(H,null);t[30](E),R=!0,I||(V=[N(s,"click",t[27]),N(y,"click",t[28])],I=!0)},p(t,i){if(t[5]?W||(W=ji(),W.c(),W.m(n,r)):W&&(W.d(1),W=null),(!R||1&i[0]&&f!==(f=t[0].ice.num_clusters<=2))&&(s.disabled=f),(!R||1&i[0])&&F!==(F=t[0].ice.num_clusters+"")&&C(m,F),(!R||1&i[0]&&j!==(j=1===t[0].ice.num_clusters||t[0].ice.num_clusters>=5))&&(y.disabled=j),t[2]?X?(X.p(t,i),4&i[0]&&lt(X,1)):(X=qi(t),X.c(),lt(X,1),X.m(e,P)):X&&(it(),at(X,1,1,(()=>{X=null})),ot()),163585&i[0]){let e;for(Y=t[17],e=0;e<Y.length;e+=1){const n=Bi(t,Y,e);K[e]?(K[e].p(n,i),lt(K[e],1)):(K[e]=Oi(n),K[e].c(),lt(K[e],1),K[e].m(H,null))}for(it(),e=Y.length;e<K.length;e+=1)U(e);ot()}(!R||128&i[0])&&z(H,"height",t[7]),(!R||2&i[0])&&z(H,"width",t[1])},i(t){if(!R){lt(X);for(let t=0;t<Y.length;t+=1)lt(K[t]);R=!0}},o(t){at(X),K=K.filter(Boolean);for(let t=0;t<K.length;t+=1)at(K[t]);R=!1},d(n){n&&$(e),W&&W.d(),X&&X.d(),t[29](null),_(K,n),t[30](null),I=!1,c(V)}}}function Hi(t,e,n){let r,i,o,l,a,s,c,u,d,h,f,g,v,y,w,b,x,$;p(t,Hn,(t=>n(24,v=t))),p(t,qn,(t=>n(33,y=t))),p(t,Yn,(t=>n(34,w=t))),p(t,Rn,(t=>n(25,b=t))),p(t,Dn,(t=>n(26,x=t))),p(t,Cn,(t=>n(15,$=t)));let _,k,M,{pd:L}=e,{width:S}=e,{height:A}=e,{scaleLocally:N}=e,{showMarginalDistribution:z}=e,{indices:T}=e,{marginTop:C}=e,{distributionHeight:B}=e,{showTitle:j}=e;function q(t,e,n,r,i,o,l){null!=e&&null!=n&&(e.save(),e.clearRect(0,0,o,l),a.forEach((o=>{var l,a;e.translate(0,null!==(l=i(o.id))&&void 0!==l?l:0),e.lineWidth=1,e.strokeStyle=f(o.id),e.globalAlpha=.25,o.indices.forEach((i=>{(null===r||r.includes(i))&&(e.beginPath(),n(t.ice.centered_ice_lines[i]),e.stroke())})),e.lineWidth=1,e.strokeStyle="black",e.globalAlpha=1,e.beginPath(),n(t.ice.centered_pdp),e.stroke(),e.lineWidth=2,e.strokeStyle=h(o.id),e.globalAlpha=1,e.beginPath(),n(o.centered_mean),e.stroke(),e.translate(0,-(null!==(a=i(o.id))&&void 0!==a?a:0))})),e.restore())}function P(t){if(t<2||t>5)return;Object.assign(L.ice,{num_clusters:t}),qn.set(y),m(Yn,w="",w),m(Yn,w=L.x_feature,w);let e=1/0,n=-1/0;for(const t of y){const r=t.ice.clusters,i=t.ice.num_clusters;if(i in r){const t=r[i];t.centered_mean_min<e&&(e=t.centered_mean_min),t.centered_mean_max>n&&(n=t.centered_mean_max)}}m(Hn,v=[e,n],v)}return H((()=>{const t=new ResizeObserver((t=>{if(1!==t.length)return;const e=t[0];if(e.contentBoxSize){const t=Array.isArray(e.contentBoxSize)?e.contentBoxSize[0]:e.contentBoxSize;n(7,o=t.blockSize)}else n(7,o=e.contentRect.height)}));return t.observe(M),()=>t.unobserve(M)})),H((()=>{n(22,k=_.getContext("2d"))})),t.$$set=t=>{"pd"in t&&n(0,L=t.pd),"width"in t&&n(1,S=t.width),"height"in t&&n(19,A=t.height),"scaleLocally"in t&&n(20,N=t.scaleLocally),"showMarginalDistribution"in t&&n(2,z=t.showMarginalDistribution),"indices"in t&&n(21,T=t.indices),"marginTop"in t&&n(3,C=t.marginTop),"distributionHeight"in t&&n(4,B=t.distributionHeight),"showTitle"in t&&n(5,j=t.showTitle)},t.$$.update=()=>{32769&t.$$.dirty[0]&&n(14,r=$[L.x_feature]),524296&t.$$.dirty[0]&&n(7,o=A-C),1&t.$$.dirty[0]&&n(11,l=xn(L.ice.num_clusters)),1&t.$$.dirty[0]&&n(17,a=L.ice.clusters[L.ice.num_clusters].clusters),2176&t.$$.dirty[0]&&n(8,s=hr().domain(l).range([0,o])),256&t.$$.dirty[0]&&n(13,c=s.bandwidth()),20483&t.$$.dirty[0]&&n(10,u="quantitative"===r.kind?en().domain([L.x_values[0],L.x_values[L.x_values.length-1]]).range([i.left,S-i.right]):pr().domain(L.x_values).range([i.left,S-i.right]).padding(.5)),118501505&t.$$.dirty[0]&&n(9,d=Mn(L,o,c,"cluster-lines",N,x,v,b,i)),2048&t.$$.dirty[0]&&(h=dr().domain(l).range(Nn)),2048&t.$$.dirty[0]&&(f=dr().domain(l).range(Sn)),4195841&t.$$.dirty[0]&&n(23,g=Ar().x(((t,e)=>{var n;return null!==(n=u(L.x_values[e]))&&void 0!==n?n:0})).y((t=>d(t))).context(k)),4194498&t.$$.dirty[0]&&k&&(_n(_,k,S,o),q(L,k,g,T,s,S,o)),14680451&t.$$.dirty[0]&&q(L,k,g,T,s,S,o)},n(12,i={top:5,right:10,bottom:35,left:50}),[L,S,z,C,B,j,_,o,s,d,u,l,i,c,r,$,M,a,P,A,N,T,k,g,v,b,x,()=>P(L.ice.num_clusters-1),()=>P(L.ice.num_clusters+1),function(t){V[t?"unshift":"push"]((()=>{_=t,n(6,_)}))},function(t){V[t?"unshift":"push"]((()=>{M=t,n(16,M)}))}]}const Ri=class extends mt{constructor(t){super(),gt(this,t,Hi,Di,d,{pd:0,width:1,height:19,scaleLocally:20,showMarginalDistribution:2,indices:21,marginTop:3,distributionHeight:4,showTitle:5},Ci,[-1,-1])}};function Ii(t,e,n){const r=t.slice();return r[19]=e[n],r}function Vi(t,e,n){const r=t.slice();return r[22]=e[n],r}function Fi(t,e,n){const r=t.slice();return r[19]=e[n],r}function Wi(t){let e,n=t[0].ice.clusters[t[0].ice.num_clusters].clusters,r=[];for(let e=0;e<n.length;e+=1)r[e]=Ki(Vi(t,n,e));return{c(){e=M("g");for(let t=0;t<r.length;t+=1)r[t].c()},m(t,n){x(t,e,n);for(let t=0;t<r.length;t+=1)r[t].m(e,null)},p(t,i){if(14945&i){let o;for(n=t[0].ice.clusters[t[0].ice.num_clusters].clusters,o=0;o<n.length;o+=1){const l=Vi(t,n,o);r[o]?r[o].p(l,i):(r[o]=Ki(l),r[o].c(),r[o].m(e,null))}for(;o<r.length;o+=1)r[o].d(1);r.length=n.length}},d(t){t&&$(e),_(r,t)}}}function Xi(t){let e,n=t[12],r=[];for(let e=0;e<n.length;e+=1)r[e]=Yi(Fi(t,n,e));return{c(){e=M("g");for(let t=0;t<r.length;t+=1)r[t].c()},m(t,n){x(t,e,n);for(let t=0;t<r.length;t+=1)r[t].m(e,null)},p(t,i){if(12385&i){let o;for(n=t[12],o=0;o<n.length;o+=1){const l=Fi(t,n,o);r[o]?r[o].p(l,i):(r[o]=Yi(l),r[o].c(),r[o].m(e,null))}for(;o<r.length;o+=1)r[o].d(1);r.length=n.length}},d(t){t&&$(e),_(r,t)}}}function Yi(t){let e,n,r,i;return{c(){e=M("circle"),z(e,"cx",n=t[6](t[0].x_values[t[19]])),z(e,"cy",r=t[5](t[22].centered_mean[t[19]])),z(e,"r",t[13]),z(e,"fill",i="var(--gray-2)")},m(t,n){x(t,e,n)},p(t,i){4161&i&&n!==(n=t[6](t[0].x_values[t[19]]))&&z(e,"cx",n),4129&i&&r!==(r=t[5](t[22].centered_mean[t[19]]))&&z(e,"cy",r),8192&i&&z(e,"r",t[13])},d(t){t&&$(e)}}}function Ki(t){let e,n,r,i,o="categorical"===t[9].kind&&Xi(t);return{c(){e=M("path"),o&&o.c(),i=A(),z(e,"d",n=t[11](t[22].centered_mean)),z(e,"stroke",r="var(--gray-2)"),z(e,"stroke-width","2"),z(e,"fill","none")},m(t,n){x(t,e,n),o&&o.m(t,n),x(t,i,n)},p(t,r){2049&r&&n!==(n=t[11](t[22].centered_mean))&&z(e,"d",n),"categorical"===t[9].kind?o?o.p(t,r):(o=Xi(t),o.c(),o.m(i.parentNode,i)):o&&(o.d(1),o=null)},d(t){t&&$(e),o&&o.d(t),t&&$(i)}}}function Ui(t){let e,n=t[12],r=[];for(let e=0;e<n.length;e+=1)r[e]=Gi(Ii(t,n,e));return{c(){for(let t=0;t<r.length;t+=1)r[t].c();e=A()},m(t,n){for(let e=0;e<r.length;e+=1)r[e].m(t,n);x(t,e,n)},p(t,i){if(12385&i){let o;for(n=t[12],o=0;o<n.length;o+=1){const l=Ii(t,n,o);r[o]?r[o].p(l,i):(r[o]=Gi(l),r[o].c(),r[o].m(e.parentNode,e))}for(;o<r.length;o+=1)r[o].d(1);r.length=n.length}},d(t){_(r,t),t&&$(e)}}}function Gi(t){let e,n,r;return{c(){e=M("circle"),z(e,"cx",n=t[6](t[0].x_values[t[19]])),z(e,"cy",r=t[5](t[0].ice.centered_pdp[t[19]])),z(e,"r",t[13]),z(e,"fill","var(--black)")},m(t,n){x(t,e,n)},p(t,i){4161&i&&n!==(n=t[6](t[0].x_values[t[19]]))&&z(e,"cx",n),4129&i&&r!==(r=t[5](t[0].ice.centered_pdp[t[19]]))&&z(e,"cy",r),8192&i&&z(e,"r",t[13])},d(t){t&&$(e)}}}function Zi(t){let e,n,r,i;const o=[Qi,Ji],l=[];function a(t,e){return"bandwidth"in t[6]?0:1}return e=a(t),n=l[e]=o[e](t),{c(){n.c(),r=A()},m(t,n){l[e].m(t,n),x(t,r,n),i=!0},p(t,i){let s=e;e=a(t),e===s?l[e].p(t,i):(it(),at(l[s],1,1,(()=>{l[s]=null})),ot(),n=l[e],n?n.p(t,i):(n=l[e]=o[e](t),n.c()),lt(n,1),n.m(r.parentNode,r))},i(t){i||(lt(n),i=!0)},o(t){at(n),i=!1},d(t){l[e].d(t),t&&$(r)}}}function Ji(t){let e,n;return e=new bi({props:{data:t[10][t[0].x_feature].distribution,x:t[6],height:t[4],direction:"horizontal",translate:[0,t[7].top-t[4]]}}),{c(){ht(e.$$.fragment)},m(t,r){ft(e,t,r),n=!0},p(t,n){const r={};1025&n&&(r.data=t[10][t[0].x_feature].distribution),64&n&&(r.x=t[6]),16&n&&(r.height=t[4]),144&n&&(r.translate=[0,t[7].top-t[4]]),e.$set(r)},i(t){n||(lt(e.$$.fragment,t),n=!0)},o(t){at(e.$$.fragment,t),n=!1},d(t){pt(e,t)}}}function Qi(t){let e,n;return e=new Ti({props:{data:t[10][t[0].x_feature].distribution,x:t[6],height:t[4],direction:"horizontal",translate:[0,t[7].top-t[4]]}}),{c(){ht(e.$$.fragment)},m(t,r){ft(e,t,r),n=!0},p(t,n){const r={};1025&n&&(r.data=t[10][t[0].x_feature].distribution),64&n&&(r.x=t[6]),16&n&&(r.height=t[4]),144&n&&(r.translate=[0,t[7].top-t[4]]),e.$set(r)},i(t){n||(lt(e.$$.fragment,t),n=!0)},o(t){at(e.$$.fragment,t),n=!1},d(t){pt(e,t)}}}function to(t){let e,n,r,i,o,l,a,s=1!==t[0].ice.num_clusters&&Wi(t),c="categorical"===t[9].kind&&Ui(t);o=new Yr({props:{scale:t[6],y:t[8]-t[7].bottom,label:t[0].x_feature,integerOnly:"discrete"===t[9].subkind,value_map:"value_map"in t[9]?t[9].value_map:{}}}),l=new ci({props:{scale:t[5],x:t[7].left,label:"centered prediction"}});let u=t[3]&&Zi(t);return{c(){e=M("svg"),s&&s.c(),n=M("path"),c&&c.c(),i=A(),ht(o.$$.fragment),ht(l.$$.fragment),u&&u.c(),z(n,"d",r=t[11](t[0].ice.centered_pdp)),z(n,"stroke","var(--black)"),z(n,"stroke-width","2"),z(n,"fill","none"),z(e,"width",t[1]),z(e,"height",t[2])},m(t,r){x(t,e,r),s&&s.m(e,null),w(e,n),c&&c.m(e,null),w(e,i),ft(o,e,null),ft(l,e,null),u&&u.m(e,null),a=!0},p(t,[d]){1!==t[0].ice.num_clusters?s?s.p(t,d):(s=Wi(t),s.c(),s.m(e,n)):s&&(s.d(1),s=null),(!a||2049&d&&r!==(r=t[11](t[0].ice.centered_pdp)))&&z(n,"d",r),"categorical"===t[9].kind?c?c.p(t,d):(c=Ui(t),c.c(),c.m(e,i)):c&&(c.d(1),c=null);const h={};64&d&&(h.scale=t[6]),384&d&&(h.y=t[8]-t[7].bottom),1&d&&(h.label=t[0].x_feature),512&d&&(h.integerOnly="discrete"===t[9].subkind),512&d&&(h.value_map="value_map"in t[9]?t[9].value_map:{}),o.$set(h);const f={};32&d&&(f.scale=t[5]),128&d&&(f.x=t[7].left),l.$set(f),t[3]?u?(u.p(t,d),8&d&&lt(u,1)):(u=Zi(t),u.c(),lt(u,1),u.m(e,null)):u&&(it(),at(u,1,1,(()=>{u=null})),ot()),(!a||2&d)&&z(e,"width",t[1]),(!a||4&d)&&z(e,"height",t[2])},i(t){a||(lt(o.$$.fragment,t),lt(l.$$.fragment,t),lt(u),a=!0)},o(t){at(o.$$.fragment,t),at(l.$$.fragment,t),at(u),a=!1},d(t){t&&$(e),s&&s.d(),c&&c.d(),pt(o),pt(l),u&&u.d()}}}function eo(t,e,n){let r,i,o,l,a,s,c,u,d,h,f,g;p(t,Rn,(t=>n(16,d=t))),p(t,Hn,(t=>n(17,h=t))),p(t,Dn,(t=>n(18,f=t))),p(t,Cn,(t=>n(10,g=t)));let{pd:m}=e,{width:v}=e,{height:y}=e,{scaleLocally:w}=e,{showMarginalDistribution:b}=e,{marginTop:x}=e,{distributionHeight:$}=e;return t.$$set=t=>{"pd"in t&&n(0,m=t.pd),"width"in t&&n(1,v=t.width),"height"in t&&n(2,y=t.height),"scaleLocally"in t&&n(14,w=t.scaleLocally),"showMarginalDistribution"in t&&n(3,b=t.showMarginalDistribution),"marginTop"in t&&n(15,x=t.marginTop),"distributionHeight"in t&&n(4,$=t.distributionHeight)},t.$$.update=()=>{1025&t.$$.dirty&&n(9,r=g[m.x_feature]),32768&t.$$.dirty&&n(7,i={top:x,right:10,bottom:35,left:50}),4&t.$$.dirty&&n(8,o=y),643&t.$$.dirty&&n(6,l="quantitative"===r.kind?en().domain([m.x_values[0],m.x_values[m.x_values.length-1]]).range([i.left,v-i.right]):pr().domain(m.x_values).range([i.left,v-i.right]).padding(.5)),64&t.$$.dirty&&n(13,a="step"in l?Math.min(3,l.step()/2-1):0),475521&t.$$.dirty&&n(5,s=Mn(m,o,0,"cluster-centers",w,f,h,d,i)),1&t.$$.dirty&&n(12,c=xn(m.x_values.length)),97&t.$$.dirty&&n(11,u=Ar().x(((t,e)=>{var n;return null!==(n=l(m.x_values[e]))&&void 0!==n?n:0})).y((t=>s(t))))},[m,v,y,b,$,s,l,i,o,r,g,u,c,a,w,x,d,h,f]}const no=class extends mt{constructor(t){super(),gt(this,t,eo,to,d,{pd:0,width:1,height:2,scaleLocally:14,showMarginalDistribution:3,marginTop:15,distributionHeight:4})}};function ro(){}function io(t){return null==t?ro:function(){return this.querySelector(t)}}function oo(t){return null==t?[]:Array.isArray(t)?t:Array.from(t)}function lo(){return[]}function ao(t){return null==t?lo:function(){return this.querySelectorAll(t)}}function so(t){return function(){return this.matches(t)}}function co(t){return function(e){return e.matches(t)}}var uo=Array.prototype.find;function ho(){return this.firstElementChild}var fo=Array.prototype.filter;function po(){return Array.from(this.children)}function go(t){return new Array(t.length)}function mo(t,e){this.ownerDocument=t.ownerDocument,this.namespaceURI=t.namespaceURI,this._next=null,this._parent=t,this.__data__=e}function vo(t){return function(){return t}}function yo(t,e,n,r,i,o){for(var l,a=0,s=e.length,c=o.length;a<c;++a)(l=e[a])?(l.__data__=o[a],r[a]=l):n[a]=new mo(t,o[a]);for(;a<s;++a)(l=e[a])&&(i[a]=l)}function wo(t,e,n,r,i,o,l){var a,s,c,u=new Map,d=e.length,h=o.length,f=new Array(d);for(a=0;a<d;++a)(s=e[a])&&(f[a]=c=l.call(s,s.__data__,a,e)+"",u.has(c)?i[a]=s:u.set(c,s));for(a=0;a<h;++a)c=l.call(t,o[a],a,o)+"",(s=u.get(c))?(r[a]=s,s.__data__=o[a],u.delete(c)):n[a]=new mo(t,o[a]);for(a=0;a<d;++a)(s=e[a])&&u.get(f[a])===s&&(i[a]=s)}function bo(t){return t.__data__}function xo(t){return"object"==typeof t&&"length"in t?t:Array.from(t)}function $o(t,e){return t<e?-1:t>e?1:t>=e?0:NaN}mo.prototype={constructor:mo,appendChild:function(t){return this._parent.insertBefore(t,this._next)},insertBefore:function(t,e){return this._parent.insertBefore(t,e)},querySelector:function(t){return this._parent.querySelector(t)},querySelectorAll:function(t){return this._parent.querySelectorAll(t)}};var _o="http://www.w3.org/1999/xhtml";const ko={svg:"http://www.w3.org/2000/svg",xhtml:_o,xlink:"http://www.w3.org/1999/xlink",xml:"http://www.w3.org/XML/1998/namespace",xmlns:"http://www.w3.org/2000/xmlns/"};function Mo(t){var e=t+="",n=e.indexOf(":");return n>=0&&"xmlns"!==(e=t.slice(0,n))&&(t=t.slice(n+1)),ko.hasOwnProperty(e)?{space:ko[e],local:t}:t}function Lo(t){return function(){this.removeAttribute(t)}}function So(t){return function(){this.removeAttributeNS(t.space,t.local)}}function Ao(t,e){return function(){this.setAttribute(t,e)}}function No(t,e){return function(){this.setAttributeNS(t.space,t.local,e)}}function zo(t,e){return function(){var n=e.apply(this,arguments);null==n?this.removeAttribute(t):this.setAttribute(t,n)}}function To(t,e){return function(){var n=e.apply(this,arguments);null==n?this.removeAttributeNS(t.space,t.local):this.setAttributeNS(t.space,t.local,n)}}function Co(t){return t.ownerDocument&&t.ownerDocument.defaultView||t.document&&t||t.defaultView}function Bo(t){return function(){this.style.removeProperty(t)}}function jo(t,e,n){return function(){this.style.setProperty(t,e,n)}}function qo(t,e,n){return function(){var r=e.apply(this,arguments);null==r?this.style.removeProperty(t):this.style.setProperty(t,r,n)}}function Po(t,e){return t.style.getPropertyValue(e)||Co(t).getComputedStyle(t,null).getPropertyValue(e)}function Eo(t){return function(){delete this[t]}}function Oo(t,e){return function(){this[t]=e}}function Do(t,e){return function(){var n=e.apply(this,arguments);null==n?delete this[t]:this[t]=n}}function Ho(t){return t.trim().split(/^|\s+/)}function Ro(t){return t.classList||new Io(t)}function Io(t){this._node=t,this._names=Ho(t.getAttribute("class")||"")}function Vo(t,e){for(var n=Ro(t),r=-1,i=e.length;++r<i;)n.add(e[r])}function Fo(t,e){for(var n=Ro(t),r=-1,i=e.length;++r<i;)n.remove(e[r])}function Wo(t){return function(){Vo(this,t)}}function Xo(t){return function(){Fo(this,t)}}function Yo(t,e){return function(){(e.apply(this,arguments)?Vo:Fo)(this,t)}}function Ko(){this.textContent=""}function Uo(t){return function(){this.textContent=t}}function Go(t){return function(){var e=t.apply(this,arguments);this.textContent=null==e?"":e}}function Zo(){this.innerHTML=""}function Jo(t){return function(){this.innerHTML=t}}function Qo(t){return function(){var e=t.apply(this,arguments);this.innerHTML=null==e?"":e}}function tl(){this.nextSibling&&this.parentNode.appendChild(this)}function el(){this.previousSibling&&this.parentNode.insertBefore(this,this.parentNode.firstChild)}function nl(t){return function(){var e=this.ownerDocument,n=this.namespaceURI;return n===_o&&e.documentElement.namespaceURI===_o?e.createElement(t):e.createElementNS(n,t)}}function rl(t){return function(){return this.ownerDocument.createElementNS(t.space,t.local)}}function il(t){var e=Mo(t);return(e.local?rl:nl)(e)}function ol(){return null}function ll(){var t=this.parentNode;t&&t.removeChild(this)}function al(){var t=this.cloneNode(!1),e=this.parentNode;return e?e.insertBefore(t,this.nextSibling):t}function sl(){var t=this.cloneNode(!0),e=this.parentNode;return e?e.insertBefore(t,this.nextSibling):t}function cl(t){return t.trim().split(/^|\s+/).map((function(t){var e="",n=t.indexOf(".");return n>=0&&(e=t.slice(n+1),t=t.slice(0,n)),{type:t,name:e}}))}function ul(t){return function(){var e=this.__on;if(e){for(var n,r=0,i=-1,o=e.length;r<o;++r)n=e[r],t.type&&n.type!==t.type||n.name!==t.name?e[++i]=n:this.removeEventListener(n.type,n.listener,n.options);++i?e.length=i:delete this.__on}}}function dl(t,e,n){return function(){var r,i=this.__on,o=function(t){return function(e){t.call(this,e,this.__data__)}}(e);if(i)for(var l=0,a=i.length;l<a;++l)if((r=i[l]).type===t.type&&r.name===t.name)return this.removeEventListener(r.type,r.listener,r.options),this.addEventListener(r.type,r.listener=o,r.options=n),void(r.value=e);this.addEventListener(t.type,o,n),r={type:t.type,name:t.name,value:e,listener:o,options:n},i?i.push(r):this.__on=[r]}}function hl(t,e,n){var r=Co(t),i=r.CustomEvent;"function"==typeof i?i=new i(e,n):(i=r.document.createEvent("Event"),n?(i.initEvent(e,n.bubbles,n.cancelable),i.detail=n.detail):i.initEvent(e,!1,!1)),t.dispatchEvent(i)}function fl(t,e){return function(){return hl(this,t,e)}}function pl(t,e){return function(){return hl(this,t,e.apply(this,arguments))}}Io.prototype={add:function(t){this._names.indexOf(t)<0&&(this._names.push(t),this._node.setAttribute("class",this._names.join(" ")))},remove:function(t){var e=this._names.indexOf(t);e>=0&&(this._names.splice(e,1),this._node.setAttribute("class",this._names.join(" ")))},contains:function(t){return this._names.indexOf(t)>=0}};var gl=[null];function ml(t,e){this._groups=t,this._parents=e}function vl(){return new ml([[document.documentElement]],gl)}ml.prototype=vl.prototype={constructor:ml,select:function(t){"function"!=typeof t&&(t=io(t));for(var e=this._groups,n=e.length,r=new Array(n),i=0;i<n;++i)for(var o,l,a=e[i],s=a.length,c=r[i]=new Array(s),u=0;u<s;++u)(o=a[u])&&(l=t.call(o,o.__data__,u,a))&&("__data__"in o&&(l.__data__=o.__data__),c[u]=l);return new ml(r,this._parents)},selectAll:function(t){t="function"==typeof t?function(t){return function(){return oo(t.apply(this,arguments))}}(t):ao(t);for(var e=this._groups,n=e.length,r=[],i=[],o=0;o<n;++o)for(var l,a=e[o],s=a.length,c=0;c<s;++c)(l=a[c])&&(r.push(t.call(l,l.__data__,c,a)),i.push(l));return new ml(r,i)},selectChild:function(t){return this.select(null==t?ho:function(t){return function(){return uo.call(this.children,t)}}("function"==typeof t?t:co(t)))},selectChildren:function(t){return this.selectAll(null==t?po:function(t){return function(){return fo.call(this.children,t)}}("function"==typeof t?t:co(t)))},filter:function(t){"function"!=typeof t&&(t=so(t));for(var e=this._groups,n=e.length,r=new Array(n),i=0;i<n;++i)for(var o,l=e[i],a=l.length,s=r[i]=[],c=0;c<a;++c)(o=l[c])&&t.call(o,o.__data__,c,l)&&s.push(o);return new ml(r,this._parents)},data:function(t,e){if(!arguments.length)return Array.from(this,bo);var n=e?wo:yo,r=this._parents,i=this._groups;"function"!=typeof t&&(t=vo(t));for(var o=i.length,l=new Array(o),a=new Array(o),s=new Array(o),c=0;c<o;++c){var u=r[c],d=i[c],h=d.length,f=xo(t.call(u,u&&u.__data__,c,r)),p=f.length,g=a[c]=new Array(p),m=l[c]=new Array(p),v=s[c]=new Array(h);n(u,d,g,m,v,f,e);for(var y,w,b=0,x=0;b<p;++b)if(y=g[b]){for(b>=x&&(x=b+1);!(w=m[x])&&++x<p;);y._next=w||null}}return(l=new ml(l,r))._enter=a,l._exit=s,l},enter:function(){return new ml(this._enter||this._groups.map(go),this._parents)},exit:function(){return new ml(this._exit||this._groups.map(go),this._parents)},join:function(t,e,n){var r=this.enter(),i=this,o=this.exit();return"function"==typeof t?(r=t(r))&&(r=r.selection()):r=r.append(t+""),null!=e&&(i=e(i))&&(i=i.selection()),null==n?o.remove():n(o),r&&i?r.merge(i).order():i},merge:function(t){for(var e=t.selection?t.selection():t,n=this._groups,r=e._groups,i=n.length,o=r.length,l=Math.min(i,o),a=new Array(i),s=0;s<l;++s)for(var c,u=n[s],d=r[s],h=u.length,f=a[s]=new Array(h),p=0;p<h;++p)(c=u[p]||d[p])&&(f[p]=c);for(;s<i;++s)a[s]=n[s];return new ml(a,this._parents)},selection:function(){return this},order:function(){for(var t=this._groups,e=-1,n=t.length;++e<n;)for(var r,i=t[e],o=i.length-1,l=i[o];--o>=0;)(r=i[o])&&(l&&4^r.compareDocumentPosition(l)&&l.parentNode.insertBefore(r,l),l=r);return this},sort:function(t){function e(e,n){return e&&n?t(e.__data__,n.__data__):!e-!n}t||(t=$o);for(var n=this._groups,r=n.length,i=new Array(r),o=0;o<r;++o){for(var l,a=n[o],s=a.length,c=i[o]=new Array(s),u=0;u<s;++u)(l=a[u])&&(c[u]=l);c.sort(e)}return new ml(i,this._parents).order()},call:function(){var t=arguments[0];return arguments[0]=this,t.apply(null,arguments),this},nodes:function(){return Array.from(this)},node:function(){for(var t=this._groups,e=0,n=t.length;e<n;++e)for(var r=t[e],i=0,o=r.length;i<o;++i){var l=r[i];if(l)return l}return null},size:function(){let t=0;for(const e of this)++t;return t},empty:function(){return!this.node()},each:function(t){for(var e=this._groups,n=0,r=e.length;n<r;++n)for(var i,o=e[n],l=0,a=o.length;l<a;++l)(i=o[l])&&t.call(i,i.__data__,l,o);return this},attr:function(t,e){var n=Mo(t);if(arguments.length<2){var r=this.node();return n.local?r.getAttributeNS(n.space,n.local):r.getAttribute(n)}return this.each((null==e?n.local?So:Lo:"function"==typeof e?n.local?To:zo:n.local?No:Ao)(n,e))},style:function(t,e,n){return arguments.length>1?this.each((null==e?Bo:"function"==typeof e?qo:jo)(t,e,null==n?"":n)):Po(this.node(),t)},property:function(t,e){return arguments.length>1?this.each((null==e?Eo:"function"==typeof e?Do:Oo)(t,e)):this.node()[t]},classed:function(t,e){var n=Ho(t+"");if(arguments.length<2){for(var r=Ro(this.node()),i=-1,o=n.length;++i<o;)if(!r.contains(n[i]))return!1;return!0}return this.each(("function"==typeof e?Yo:e?Wo:Xo)(n,e))},text:function(t){return arguments.length?this.each(null==t?Ko:("function"==typeof t?Go:Uo)(t)):this.node().textContent},html:function(t){return arguments.length?this.each(null==t?Zo:("function"==typeof t?Qo:Jo)(t)):this.node().innerHTML},raise:function(){return this.each(tl)},lower:function(){return this.each(el)},append:function(t){var e="function"==typeof t?t:il(t);return this.select((function(){return this.appendChild(e.apply(this,arguments))}))},insert:function(t,e){var n="function"==typeof t?t:il(t),r=null==e?ol:"function"==typeof e?e:io(e);return this.select((function(){return this.insertBefore(n.apply(this,arguments),r.apply(this,arguments)||null)}))},remove:function(){return this.each(ll)},clone:function(t){return this.select(t?sl:al)},datum:function(t){return arguments.length?this.property("__data__",t):this.node().__data__},on:function(t,e,n){var r,i,o=cl(t+""),l=o.length;if(!(arguments.length<2)){for(a=e?dl:ul,r=0;r<l;++r)this.each(a(o[r],e,n));return this}var a=this.node().__on;if(a)for(var s,c=0,u=a.length;c<u;++c)for(r=0,s=a[c];r<l;++r)if((i=o[r]).type===s.type&&i.name===s.name)return s.value},dispatch:function(t,e){return this.each(("function"==typeof e?pl:fl)(t,e))},[Symbol.iterator]:function*(){for(var t=this._groups,e=0,n=t.length;e<n;++e)for(var r,i=t[e],o=0,l=i.length;o<l;++o)(r=i[o])&&(yield r)}};const yl=vl;function wl(t){return"string"==typeof t?new ml([[document.querySelector(t)]],[document.documentElement]):new ml([[t]],gl)}var bl={value:()=>{}};function xl(){for(var t,e=0,n=arguments.length,r={};e<n;++e){if(!(t=arguments[e]+"")||t in r||/[\s.]/.test(t))throw new Error("illegal type: "+t);r[t]=[]}return new $l(r)}function $l(t){this._=t}function _l(t,e){return t.trim().split(/^|\s+/).map((function(t){var n="",r=t.indexOf(".");if(r>=0&&(n=t.slice(r+1),t=t.slice(0,r)),t&&!e.hasOwnProperty(t))throw new Error("unknown type: "+t);return{type:t,name:n}}))}function kl(t,e){for(var n,r=0,i=t.length;r<i;++r)if((n=t[r]).name===e)return n.value}function Ml(t,e,n){for(var r=0,i=t.length;r<i;++r)if(t[r].name===e){t[r]=bl,t=t.slice(0,r).concat(t.slice(r+1));break}return null!=n&&t.push({name:e,value:n}),t}$l.prototype=xl.prototype={constructor:$l,on:function(t,e){var n,r=this._,i=_l(t+"",r),o=-1,l=i.length;if(!(arguments.length<2)){if(null!=e&&"function"!=typeof e)throw new Error("invalid callback: "+e);for(;++o<l;)if(n=(t=i[o]).type)r[n]=Ml(r[n],t.name,e);else if(null==e)for(n in r)r[n]=Ml(r[n],t.name,null);return this}for(;++o<l;)if((n=(t=i[o]).type)&&(n=kl(r[n],t.name)))return n},copy:function(){var t={},e=this._;for(var n in e)t[n]=e[n].slice();return new $l(t)},call:function(t,e){if((n=arguments.length-2)>0)for(var n,r,i=new Array(n),o=0;o<n;++o)i[o]=arguments[o+2];if(!this._.hasOwnProperty(t))throw new Error("unknown type: "+t);for(o=0,n=(r=this._[t]).length;o<n;++o)r[o].value.apply(e,i)},apply:function(t,e,n){if(!this._.hasOwnProperty(t))throw new Error("unknown type: "+t);for(var r=this._[t],i=0,o=r.length;i<o;++i)r[i].value.apply(e,n)}};const Ll=xl,Sl={capture:!0,passive:!1};function Al(t){t.preventDefault(),t.stopImmediatePropagation()}function Nl(t){var e=t.document.documentElement,n=wl(t).on("dragstart.drag",Al,Sl);"onselectstart"in e?n.on("selectstart.drag",Al,Sl):(e.__noselect=e.style.MozUserSelect,e.style.MozUserSelect="none")}function zl(t,e){var n=t.document.documentElement,r=wl(t).on("dragstart.drag",null);e&&(r.on("click.drag",Al,Sl),setTimeout((function(){r.on("click.drag",null)}),0)),"onselectstart"in n?r.on("selectstart.drag",null):(n.style.MozUserSelect=n.__noselect,delete n.__noselect)}function Tl(t,e){if(t=function(t){let e;for(;e=t.sourceEvent;)t=e;return t}(t),void 0===e&&(e=t.currentTarget),e){var n=e.ownerSVGElement||e;if(n.createSVGPoint){var r=n.createSVGPoint();return r.x=t.clientX,r.y=t.clientY,[(r=r.matrixTransform(e.getScreenCTM().inverse())).x,r.y]}if(e.getBoundingClientRect){var i=e.getBoundingClientRect();return[t.clientX-i.left-e.clientLeft,t.clientY-i.top-e.clientTop]}}return[t.pageX,t.pageY]}var Cl,Bl,jl=0,ql=0,Pl=0,El=0,Ol=0,Dl=0,Hl="object"==typeof performance&&performance.now?performance:Date,Rl="object"==typeof window&&window.requestAnimationFrame?window.requestAnimationFrame.bind(window):function(t){setTimeout(t,17)};function Il(){return Ol||(Rl(Vl),Ol=Hl.now()+Dl)}function Vl(){Ol=0}function Fl(){this._call=this._time=this._next=null}function Wl(t,e,n){var r=new Fl;return r.restart(t,e,n),r}function Xl(){Ol=(El=Hl.now())+Dl,jl=ql=0;try{!function(){Il(),++jl;for(var t,e=Cl;e;)(t=Ol-e._time)>=0&&e._call.call(void 0,t),e=e._next;--jl}()}finally{jl=0,function(){for(var t,e,n=Cl,r=1/0;n;)n._call?(r>n._time&&(r=n._time),t=n,n=n._next):(e=n._next,n._next=null,n=t?t._next=e:Cl=e);Bl=t,Kl(r)}(),Ol=0}}function Yl(){var t=Hl.now(),e=t-El;e>1e3&&(Dl-=e,El=t)}function Kl(t){jl||(ql&&(ql=clearTimeout(ql)),t-Ol>24?(t<1/0&&(ql=setTimeout(Xl,t-Hl.now()-Dl)),Pl&&(Pl=clearInterval(Pl))):(Pl||(El=Hl.now(),Pl=setInterval(Yl,1e3)),jl=1,Rl(Xl)))}function Ul(t,e,n){var r=new Fl;return e=null==e?0:+e,r.restart((n=>{r.stop(),t(n+e)}),e,n),r}Fl.prototype=Wl.prototype={constructor:Fl,restart:function(t,e,n){if("function"!=typeof t)throw new TypeError("callback is not a function");n=(null==n?Il():+n)+(null==e?0:+e),this._next||Bl===this||(Bl?Bl._next=this:Cl=this,Bl=this),this._call=t,this._time=n,Kl()},stop:function(){this._call&&(this._call=null,this._time=1/0,Kl())}};var Gl=Ll("start","end","cancel","interrupt"),Zl=[];function Jl(t,e,n,r,i,o){var l=t.__transition;if(l){if(n in l)return}else t.__transition={};!function(t,e,n){var r,i=t.__transition;function o(s){var c,u,d,h;if(1!==n.state)return a();for(c in i)if((h=i[c]).name===n.name){if(3===h.state)return Ul(o);4===h.state?(h.state=6,h.timer.stop(),h.on.call("interrupt",t,t.__data__,h.index,h.group),delete i[c]):+c<e&&(h.state=6,h.timer.stop(),h.on.call("cancel",t,t.__data__,h.index,h.group),delete i[c])}if(Ul((function(){3===n.state&&(n.state=4,n.timer.restart(l,n.delay,n.time),l(s))})),n.state=2,n.on.call("start",t,t.__data__,n.index,n.group),2===n.state){for(n.state=3,r=new Array(d=n.tween.length),c=0,u=-1;c<d;++c)(h=n.tween[c].value.call(t,t.__data__,n.index,n.group))&&(r[++u]=h);r.length=u+1}}function l(e){for(var i=e<n.duration?n.ease.call(null,e/n.duration):(n.timer.restart(a),n.state=5,1),o=-1,l=r.length;++o<l;)r[o].call(t,i);5===n.state&&(n.on.call("end",t,t.__data__,n.index,n.group),a())}function a(){for(var r in n.state=6,n.timer.stop(),delete i[e],i)return;delete t.__transition}i[e]=n,n.timer=Wl((function(t){n.state=1,n.timer.restart(o,n.delay,n.time),n.delay<=t&&o(t-n.delay)}),0,n.time)}(t,n,{name:e,index:r,group:i,on:Gl,tween:Zl,time:o.time,delay:o.delay,duration:o.duration,ease:o.ease,timer:null,state:0})}function Ql(t,e){var n=ea(t,e);if(n.state>0)throw new Error("too late; already scheduled");return n}function ta(t,e){var n=ea(t,e);if(n.state>3)throw new Error("too late; already running");return n}function ea(t,e){var n=t.__transition;if(!n||!(n=n[e]))throw new Error("transition not found");return n}function na(t,e){var n,r,i,o=t.__transition,l=!0;if(o){for(i in e=null==e?null:e+"",o)(n=o[i]).name===e?(r=n.state>2&&n.state<5,n.state=6,n.timer.stop(),n.on.call(r?"interrupt":"cancel",t,t.__data__,n.index,n.group),delete o[i]):l=!1;l&&delete t.__transition}}var ra,ia=180/Math.PI,oa={translateX:0,translateY:0,rotate:0,skewX:0,scaleX:1,scaleY:1};function la(t,e,n,r,i,o){var l,a,s;return(l=Math.sqrt(t*t+e*e))&&(t/=l,e/=l),(s=t*n+e*r)&&(n-=t*s,r-=e*s),(a=Math.sqrt(n*n+r*r))&&(n/=a,r/=a,s/=a),t*r<e*n&&(t=-t,e=-e,s=-s,l=-l),{translateX:i,translateY:o,rotate:Math.atan2(e,t)*ia,skewX:Math.atan(s)*ia,scaleX:l,scaleY:a}}function aa(t,e,n,r){function i(t){return t.length?t.pop()+" ":""}return function(o,l){var a=[],s=[];return o=t(o),l=t(l),function(t,r,i,o,l,a){if(t!==i||r!==o){var s=l.push("translate(",null,e,null,n);a.push({i:s-4,x:ce(t,i)},{i:s-2,x:ce(r,o)})}else(i||o)&&l.push("translate("+i+e+o+n)}(o.translateX,o.translateY,l.translateX,l.translateY,a,s),function(t,e,n,o){t!==e?(t-e>180?e+=360:e-t>180&&(t+=360),o.push({i:n.push(i(n)+"rotate(",null,r)-2,x:ce(t,e)})):e&&n.push(i(n)+"rotate("+e+r)}(o.rotate,l.rotate,a,s),function(t,e,n,o){t!==e?o.push({i:n.push(i(n)+"skewX(",null,r)-2,x:ce(t,e)}):e&&n.push(i(n)+"skewX("+e+r)}(o.skewX,l.skewX,a,s),function(t,e,n,r,o,l){if(t!==n||e!==r){var a=o.push(i(o)+"scale(",null,",",null,")");l.push({i:a-4,x:ce(t,n)},{i:a-2,x:ce(e,r)})}else 1===n&&1===r||o.push(i(o)+"scale("+n+","+r+")")}(o.scaleX,o.scaleY,l.scaleX,l.scaleY,a,s),o=l=null,function(t){for(var e,n=-1,r=s.length;++n<r;)a[(e=s[n]).i]=e.x(t);return a.join("")}}}var sa=aa((function(t){const e=new("function"==typeof DOMMatrix?DOMMatrix:WebKitCSSMatrix)(t+"");return e.isIdentity?oa:la(e.a,e.b,e.c,e.d,e.e,e.f)}),"px, ","px)","deg)"),ca=aa((function(t){return null==t?oa:(ra||(ra=document.createElementNS("http://www.w3.org/2000/svg","g")),ra.setAttribute("transform",t),(t=ra.transform.baseVal.consolidate())?la((t=t.matrix).a,t.b,t.c,t.d,t.e,t.f):oa)}),", ",")",")");function ua(t,e){var n,r;return function(){var i=ta(this,t),o=i.tween;if(o!==n)for(var l=0,a=(r=n=o).length;l<a;++l)if(r[l].name===e){(r=r.slice()).splice(l,1);break}i.tween=r}}function da(t,e,n){var r,i;if("function"!=typeof n)throw new Error;return function(){var o=ta(this,t),l=o.tween;if(l!==r){i=(r=l).slice();for(var a={name:e,value:n},s=0,c=i.length;s<c;++s)if(i[s].name===e){i[s]=a;break}s===c&&i.push(a)}o.tween=i}}function ha(t,e,n){var r=t._id;return t.each((function(){var t=ta(this,r);(t.value||(t.value={}))[e]=n.apply(this,arguments)})),function(t){return ea(t,r).value[e]}}function fa(t,e){var n;return("number"==typeof e?ce:e instanceof Ot?ie:(n=Ot(e))?(e=n,ie):fe)(t,e)}function pa(t){return function(){this.removeAttribute(t)}}function ga(t){return function(){this.removeAttributeNS(t.space,t.local)}}function ma(t,e,n){var r,i,o=n+"";return function(){var l=this.getAttribute(t);return l===o?null:l===r?i:i=e(r=l,n)}}function va(t,e,n){var r,i,o=n+"";return function(){var l=this.getAttributeNS(t.space,t.local);return l===o?null:l===r?i:i=e(r=l,n)}}function ya(t,e,n){var r,i,o;return function(){var l,a,s=n(this);if(null!=s)return(l=this.getAttribute(t))===(a=s+"")?null:l===r&&a===i?o:(i=a,o=e(r=l,s));this.removeAttribute(t)}}function wa(t,e,n){var r,i,o;return function(){var l,a,s=n(this);if(null!=s)return(l=this.getAttributeNS(t.space,t.local))===(a=s+"")?null:l===r&&a===i?o:(i=a,o=e(r=l,s));this.removeAttributeNS(t.space,t.local)}}function ba(t,e){return function(n){this.setAttribute(t,e.call(this,n))}}function xa(t,e){return function(n){this.setAttributeNS(t.space,t.local,e.call(this,n))}}function $a(t,e){var n,r;function i(){var i=e.apply(this,arguments);return i!==r&&(n=(r=i)&&xa(t,i)),n}return i._value=e,i}function _a(t,e){var n,r;function i(){var i=e.apply(this,arguments);return i!==r&&(n=(r=i)&&ba(t,i)),n}return i._value=e,i}function ka(t,e){return function(){Ql(this,t).delay=+e.apply(this,arguments)}}function Ma(t,e){return e=+e,function(){Ql(this,t).delay=e}}function La(t,e){return function(){ta(this,t).duration=+e.apply(this,arguments)}}function Sa(t,e){return e=+e,function(){ta(this,t).duration=e}}function Aa(t,e){if("function"!=typeof e)throw new Error;return function(){ta(this,t).ease=e}}function Na(t,e,n){var r,i,o=function(t){return(t+"").trim().split(/^|\s+/).every((function(t){var e=t.indexOf(".");return e>=0&&(t=t.slice(0,e)),!t||"start"===t}))}(e)?Ql:ta;return function(){var l=o(this,t),a=l.on;a!==r&&(i=(r=a).copy()).on(e,n),l.on=i}}var za=yl.prototype.constructor;function Ta(t){return function(){this.style.removeProperty(t)}}function Ca(t,e,n){return function(r){this.style.setProperty(t,e.call(this,r),n)}}function Ba(t,e,n){var r,i;function o(){var o=e.apply(this,arguments);return o!==i&&(r=(i=o)&&Ca(t,o,n)),r}return o._value=e,o}function ja(t){return function(e){this.textContent=t.call(this,e)}}function qa(t){var e,n;function r(){var r=t.apply(this,arguments);return r!==n&&(e=(n=r)&&ja(r)),e}return r._value=t,r}var Pa=0;function Ea(t,e,n,r){this._groups=t,this._parents=e,this._name=n,this._id=r}function Oa(){return++Pa}var Da=yl.prototype;Ea.prototype=function(t){return yl().transition(t)}.prototype={constructor:Ea,select:function(t){var e=this._name,n=this._id;"function"!=typeof t&&(t=io(t));for(var r=this._groups,i=r.length,o=new Array(i),l=0;l<i;++l)for(var a,s,c=r[l],u=c.length,d=o[l]=new Array(u),h=0;h<u;++h)(a=c[h])&&(s=t.call(a,a.__data__,h,c))&&("__data__"in a&&(s.__data__=a.__data__),d[h]=s,Jl(d[h],e,n,h,d,ea(a,n)));return new Ea(o,this._parents,e,n)},selectAll:function(t){var e=this._name,n=this._id;"function"!=typeof t&&(t=ao(t));for(var r=this._groups,i=r.length,o=[],l=[],a=0;a<i;++a)for(var s,c=r[a],u=c.length,d=0;d<u;++d)if(s=c[d]){for(var h,f=t.call(s,s.__data__,d,c),p=ea(s,n),g=0,m=f.length;g<m;++g)(h=f[g])&&Jl(h,e,n,g,f,p);o.push(f),l.push(s)}return new Ea(o,l,e,n)},selectChild:Da.selectChild,selectChildren:Da.selectChildren,filter:function(t){"function"!=typeof t&&(t=so(t));for(var e=this._groups,n=e.length,r=new Array(n),i=0;i<n;++i)for(var o,l=e[i],a=l.length,s=r[i]=[],c=0;c<a;++c)(o=l[c])&&t.call(o,o.__data__,c,l)&&s.push(o);return new Ea(r,this._parents,this._name,this._id)},merge:function(t){if(t._id!==this._id)throw new Error;for(var e=this._groups,n=t._groups,r=e.length,i=n.length,o=Math.min(r,i),l=new Array(r),a=0;a<o;++a)for(var s,c=e[a],u=n[a],d=c.length,h=l[a]=new Array(d),f=0;f<d;++f)(s=c[f]||u[f])&&(h[f]=s);for(;a<r;++a)l[a]=e[a];return new Ea(l,this._parents,this._name,this._id)},selection:function(){return new za(this._groups,this._parents)},transition:function(){for(var t=this._name,e=this._id,n=Oa(),r=this._groups,i=r.length,o=0;o<i;++o)for(var l,a=r[o],s=a.length,c=0;c<s;++c)if(l=a[c]){var u=ea(l,e);Jl(l,t,n,c,a,{time:u.time+u.delay+u.duration,delay:0,duration:u.duration,ease:u.ease})}return new Ea(r,this._parents,t,n)},call:Da.call,nodes:Da.nodes,node:Da.node,size:Da.size,empty:Da.empty,each:Da.each,on:function(t,e){var n=this._id;return arguments.length<2?ea(this.node(),n).on.on(t):this.each(Na(n,t,e))},attr:function(t,e){var n=Mo(t),r="transform"===n?ca:fa;return this.attrTween(t,"function"==typeof e?(n.local?wa:ya)(n,r,ha(this,"attr."+t,e)):null==e?(n.local?ga:pa)(n):(n.local?va:ma)(n,r,e))},attrTween:function(t,e){var n="attr."+t;if(arguments.length<2)return(n=this.tween(n))&&n._value;if(null==e)return this.tween(n,null);if("function"!=typeof e)throw new Error;var r=Mo(t);return this.tween(n,(r.local?$a:_a)(r,e))},style:function(t,e,n){var r="transform"==(t+="")?sa:fa;return null==e?this.styleTween(t,function(t,e){var n,r,i;return function(){var o=Po(this,t),l=(this.style.removeProperty(t),Po(this,t));return o===l?null:o===n&&l===r?i:i=e(n=o,r=l)}}(t,r)).on("end.style."+t,Ta(t)):"function"==typeof e?this.styleTween(t,function(t,e,n){var r,i,o;return function(){var l=Po(this,t),a=n(this),s=a+"";return null==a&&(this.style.removeProperty(t),s=a=Po(this,t)),l===s?null:l===r&&s===i?o:(i=s,o=e(r=l,a))}}(t,r,ha(this,"style."+t,e))).each(function(t,e){var n,r,i,o,l="style."+e,a="end."+l;return function(){var s=ta(this,t),c=s.on,u=null==s.value[l]?o||(o=Ta(e)):void 0;c===n&&i===u||(r=(n=c).copy()).on(a,i=u),s.on=r}}(this._id,t)):this.styleTween(t,function(t,e,n){var r,i,o=n+"";return function(){var l=Po(this,t);return l===o?null:l===r?i:i=e(r=l,n)}}(t,r,e),n).on("end.style."+t,null)},styleTween:function(t,e,n){var r="style."+(t+="");if(arguments.length<2)return(r=this.tween(r))&&r._value;if(null==e)return this.tween(r,null);if("function"!=typeof e)throw new Error;return this.tween(r,Ba(t,e,null==n?"":n))},text:function(t){return this.tween("text","function"==typeof t?function(t){return function(){var e=t(this);this.textContent=null==e?"":e}}(ha(this,"text",t)):function(t){return function(){this.textContent=t}}(null==t?"":t+""))},textTween:function(t){var e="text";if(arguments.length<1)return(e=this.tween(e))&&e._value;if(null==t)return this.tween(e,null);if("function"!=typeof t)throw new Error;return this.tween(e,qa(t))},remove:function(){return this.on("end.remove",function(t){return function(){var e=this.parentNode;for(var n in this.__transition)if(+n!==t)return;e&&e.removeChild(this)}}(this._id))},tween:function(t,e){var n=this._id;if(t+="",arguments.length<2){for(var r,i=ea(this.node(),n).tween,o=0,l=i.length;o<l;++o)if((r=i[o]).name===t)return r.value;return null}return this.each((null==e?ua:da)(n,t,e))},delay:function(t){var e=this._id;return arguments.length?this.each(("function"==typeof t?ka:Ma)(e,t)):ea(this.node(),e).delay},duration:function(t){var e=this._id;return arguments.length?this.each(("function"==typeof t?La:Sa)(e,t)):ea(this.node(),e).duration},ease:function(t){var e=this._id;return arguments.length?this.each(Aa(e,t)):ea(this.node(),e).ease},easeVarying:function(t){if("function"!=typeof t)throw new Error;return this.each(function(t,e){return function(){var n=e.apply(this,arguments);if("function"!=typeof n)throw new Error;ta(this,t).ease=n}}(this._id,t))},end:function(){var t,e,n=this,r=n._id,i=n.size();return new Promise((function(o,l){var a={value:l},s={value:function(){0==--i&&o()}};n.each((function(){var n=ta(this,r),i=n.on;i!==t&&((e=(t=i).copy())._.cancel.push(a),e._.interrupt.push(a),e._.end.push(s)),n.on=e})),0===i&&o()}))},[Symbol.iterator]:Da[Symbol.iterator]};var Ha={time:null,delay:0,duration:250,ease:function(t){return((t*=2)<=1?t*t*t:(t-=2)*t*t+2)/2}};function Ra(t,e){for(var n;!(n=t.__transition)||!(n=n[e]);)if(!(t=t.parentNode))throw new Error(`transition ${e} not found`);return n}yl.prototype.interrupt=function(t){return this.each((function(){na(this,t)}))},yl.prototype.transition=function(t){var e,n;t instanceof Ea?(e=t._id,t=t._name):(e=Oa(),(n=Ha).time=Il(),t=null==t?null:t+"");for(var r=this._groups,i=r.length,o=0;o<i;++o)for(var l,a=r[o],s=a.length,c=0;c<s;++c)(l=a[c])&&Jl(l,t,e,c,a,n||Ra(l,e));return new Ea(r,this._parents,t,e)};const Ia=t=>()=>t;function Va(t,{sourceEvent:e,target:n,selection:r,mode:i,dispatch:o}){Object.defineProperties(this,{type:{value:t,enumerable:!0,configurable:!0},sourceEvent:{value:e,enumerable:!0,configurable:!0},target:{value:n,enumerable:!0,configurable:!0},selection:{value:r,enumerable:!0,configurable:!0},mode:{value:i,enumerable:!0,configurable:!0},_:{value:o}})}function Fa(t){t.stopImmediatePropagation()}function Wa(t){t.preventDefault(),t.stopImmediatePropagation()}var Xa={name:"drag"},Ya={name:"space"},Ka={name:"handle"},Ua={name:"center"};const{abs:Ga,max:Za,min:Ja}=Math;function Qa(t){return[+t[0],+t[1]]}function ts(t){return[Qa(t[0]),Qa(t[1])]}var es={name:"x",handles:["w","e"].map(cs),input:function(t,e){return null==t?null:[[+t[0],e[0][1]],[+t[1],e[1][1]]]},output:function(t){return t&&[t[0][0],t[1][0]]}},ns={name:"y",handles:["n","s"].map(cs),input:function(t,e){return null==t?null:[[e[0][0],+t[0]],[e[1][0],+t[1]]]},output:function(t){return t&&[t[0][1],t[1][1]]}},rs={name:"xy",handles:["n","w","e","s","nw","ne","sw","se"].map(cs),input:function(t){return null==t?null:ts(t)},output:function(t){return t}},is={overlay:"crosshair",selection:"move",n:"ns-resize",e:"ew-resize",s:"ns-resize",w:"ew-resize",nw:"nwse-resize",ne:"nesw-resize",se:"nwse-resize",sw:"nesw-resize"},os={e:"w",w:"e",nw:"ne",ne:"nw",se:"sw",sw:"se"},ls={n:"s",s:"n",nw:"sw",ne:"se",se:"ne",sw:"nw"},as={overlay:1,selection:1,n:null,e:1,s:null,w:-1,nw:-1,ne:1,se:1,sw:-1},ss={overlay:1,selection:1,n:-1,e:null,s:1,w:null,nw:-1,ne:-1,se:1,sw:1};function cs(t){return{type:t}}function us(t){return!t.ctrlKey&&!t.button}function ds(){var t=this.ownerSVGElement||this;return t.hasAttribute("viewBox")?[[(t=t.viewBox.baseVal).x,t.y],[t.x+t.width,t.y+t.height]]:[[0,0],[t.width.baseVal.value,t.height.baseVal.value]]}function hs(){return navigator.maxTouchPoints||"ontouchstart"in this}function fs(t){for(;!t.__brush;)if(!(t=t.parentNode))return;return t.__brush}function ps(t){return t[0][0]===t[1][0]||t[0][1]===t[1][1]}function gs(){return vs(es)}function ms(){return vs(rs)}function vs(t){var e,n=ds,r=us,i=hs,o=!0,l=Ll("start","brush","end"),a=6;function s(e){var n=e.property("__brush",g).selectAll(".overlay").data([cs("overlay")]);n.enter().append("rect").attr("class","overlay").attr("pointer-events","all").attr("cursor",is.overlay).merge(n).each((function(){var t=fs(this).extent;wl(this).attr("x",t[0][0]).attr("y",t[0][1]).attr("width",t[1][0]-t[0][0]).attr("height",t[1][1]-t[0][1])})),e.selectAll(".selection").data([cs("selection")]).enter().append("rect").attr("class","selection").attr("cursor",is.selection).attr("fill","#777").attr("fill-opacity",.3).attr("stroke","#fff").attr("shape-rendering","crispEdges");var r=e.selectAll(".handle").data(t.handles,(function(t){return t.type}));r.exit().remove(),r.enter().append("rect").attr("class",(function(t){return"handle handle--"+t.type})).attr("cursor",(function(t){return is[t.type]})),e.each(c).attr("fill","none").attr("pointer-events","all").on("mousedown.brush",h).filter(i).on("touchstart.brush",h).on("touchmove.brush",f).on("touchend.brush touchcancel.brush",p).style("touch-action","none").style("-webkit-tap-highlight-color","rgba(0,0,0,0)")}function c(){var t=wl(this),e=fs(this).selection;e?(t.selectAll(".selection").style("display",null).attr("x",e[0][0]).attr("y",e[0][1]).attr("width",e[1][0]-e[0][0]).attr("height",e[1][1]-e[0][1]),t.selectAll(".handle").style("display",null).attr("x",(function(t){return"e"===t.type[t.type.length-1]?e[1][0]-a/2:e[0][0]-a/2})).attr("y",(function(t){return"s"===t.type[0]?e[1][1]-a/2:e[0][1]-a/2})).attr("width",(function(t){return"n"===t.type||"s"===t.type?e[1][0]-e[0][0]+a:a})).attr("height",(function(t){return"e"===t.type||"w"===t.type?e[1][1]-e[0][1]+a:a}))):t.selectAll(".selection,.handle").style("display","none").attr("x",null).attr("y",null).attr("width",null).attr("height",null)}function u(t,e,n){var r=t.__brush.emitter;return!r||n&&r.clean?new d(t,e,n):r}function d(t,e,n){this.that=t,this.args=e,this.state=t.__brush,this.active=0,this.clean=n}function h(n){if((!e||n.touches)&&r.apply(this,arguments)){var i,l,a,s,d,h,f,p,g,m,v,y=this,w=n.target.__data__.type,b="selection"===(o&&n.metaKey?w="overlay":w)?Xa:o&&n.altKey?Ua:Ka,x=t===ns?null:as[w],$=t===es?null:ss[w],_=fs(y),k=_.extent,M=_.selection,L=k[0][0],S=k[0][1],A=k[1][0],N=k[1][1],z=0,T=0,C=x&&$&&o&&n.shiftKey,B=Array.from(n.touches||[n],(t=>{const e=t.identifier;return(t=Tl(t,y)).point0=t.slice(),t.identifier=e,t}));na(y);var j=u(y,arguments,!0).beforestart();if("overlay"===w){M&&(g=!0);const e=[B[0],B[1]||B[0]];_.selection=M=[[i=t===ns?L:Ja(e[0][0],e[1][0]),a=t===es?S:Ja(e[0][1],e[1][1])],[d=t===ns?A:Za(e[0][0],e[1][0]),f=t===es?N:Za(e[0][1],e[1][1])]],B.length>1&&D(n)}else i=M[0][0],a=M[0][1],d=M[1][0],f=M[1][1];l=i,s=a,h=d,p=f;var q=wl(y).attr("pointer-events","none"),P=q.selectAll(".overlay").attr("cursor",is[w]);if(n.touches)j.moved=O,j.ended=H;else{var E=wl(n.view).on("mousemove.brush",O,!0).on("mouseup.brush",H,!0);o&&E.on("keydown.brush",R,!0).on("keyup.brush",I,!0),Nl(n.view)}c.call(y),j.start(n,b.name)}function O(t){for(const e of t.changedTouches||[t])for(const t of B)t.identifier===e.identifier&&(t.cur=Tl(e,y));if(C&&!m&&!v&&1===B.length){const t=B[0];Ga(t.cur[0]-t[0])>Ga(t.cur[1]-t[1])?v=!0:m=!0}for(const t of B)t.cur&&(t[0]=t.cur[0],t[1]=t.cur[1]);g=!0,Wa(t),D(t)}function D(t){const e=B[0],n=e.point0;var r;switch(z=e[0]-n[0],T=e[1]-n[1],b){case Ya:case Xa:x&&(z=Za(L-i,Ja(A-d,z)),l=i+z,h=d+z),$&&(T=Za(S-a,Ja(N-f,T)),s=a+T,p=f+T);break;case Ka:B[1]?(x&&(l=Za(L,Ja(A,B[0][0])),h=Za(L,Ja(A,B[1][0])),x=1),$&&(s=Za(S,Ja(N,B[0][1])),p=Za(S,Ja(N,B[1][1])),$=1)):(x<0?(z=Za(L-i,Ja(A-i,z)),l=i+z,h=d):x>0&&(z=Za(L-d,Ja(A-d,z)),l=i,h=d+z),$<0?(T=Za(S-a,Ja(N-a,T)),s=a+T,p=f):$>0&&(T=Za(S-f,Ja(N-f,T)),s=a,p=f+T));break;case Ua:x&&(l=Za(L,Ja(A,i-z*x)),h=Za(L,Ja(A,d+z*x))),$&&(s=Za(S,Ja(N,a-T*$)),p=Za(S,Ja(N,f+T*$)))}h<l&&(x*=-1,r=i,i=d,d=r,r=l,l=h,h=r,w in os&&P.attr("cursor",is[w=os[w]])),p<s&&($*=-1,r=a,a=f,f=r,r=s,s=p,p=r,w in ls&&P.attr("cursor",is[w=ls[w]])),_.selection&&(M=_.selection),m&&(l=M[0][0],h=M[1][0]),v&&(s=M[0][1],p=M[1][1]),M[0][0]===l&&M[0][1]===s&&M[1][0]===h&&M[1][1]===p||(_.selection=[[l,s],[h,p]],c.call(y),j.brush(t,b.name))}function H(t){if(Fa(t),t.touches){if(t.touches.length)return;e&&clearTimeout(e),e=setTimeout((function(){e=null}),500)}else zl(t.view,g),E.on("keydown.brush keyup.brush mousemove.brush mouseup.brush",null);q.attr("pointer-events","all"),P.attr("cursor",is.overlay),_.selection&&(M=_.selection),ps(M)&&(_.selection=null,c.call(y)),j.end(t,b.name)}function R(t){switch(t.keyCode){case 16:C=x&&$;break;case 18:b===Ka&&(x&&(d=h-z*x,i=l+z*x),$&&(f=p-T*$,a=s+T*$),b=Ua,D(t));break;case 32:b!==Ka&&b!==Ua||(x<0?d=h-z:x>0&&(i=l-z),$<0?f=p-T:$>0&&(a=s-T),b=Ya,P.attr("cursor",is.selection),D(t));break;default:return}Wa(t)}function I(t){switch(t.keyCode){case 16:C&&(m=v=C=!1,D(t));break;case 18:b===Ua&&(x<0?d=h:x>0&&(i=l),$<0?f=p:$>0&&(a=s),b=Ka,D(t));break;case 32:b===Ya&&(t.altKey?(x&&(d=h-z*x,i=l+z*x),$&&(f=p-T*$,a=s+T*$),b=Ua):(x<0?d=h:x>0&&(i=l),$<0?f=p:$>0&&(a=s),b=Ka),P.attr("cursor",is[w]),D(t));break;default:return}Wa(t)}}function f(t){u(this,arguments).moved(t)}function p(t){u(this,arguments).ended(t)}function g(){var e=this.__brush||{selection:null};return e.extent=ts(n.apply(this,arguments)),e.dim=t,e}return s.move=function(e,n,r){e.tween?e.on("start.brush",(function(t){u(this,arguments).beforestart().start(t)})).on("interrupt.brush end.brush",(function(t){u(this,arguments).end(t)})).tween("brush",(function(){var e=this,r=e.__brush,i=u(e,arguments),o=r.selection,l=t.input("function"==typeof n?n.apply(this,arguments):n,r.extent),a=ge(o,l);function s(t){r.selection=1===t&&null===l?null:a(t),c.call(e),i.brush()}return null!==o&&null!==l?s:s(1)})):e.each((function(){var e=this,i=arguments,o=e.__brush,l=t.input("function"==typeof n?n.apply(e,i):n,o.extent),a=u(e,i).beforestart();na(e),o.selection=null===l?null:l,c.call(e),a.start(r).brush(r).end(r)}))},s.clear=function(t,e){s.move(t,null,e)},d.prototype={beforestart:function(){return 1==++this.active&&(this.state.emitter=this,this.starting=!0),this},start:function(t,e){return this.starting?(this.starting=!1,this.emit("start",t,e)):this.emit("brush",t),this},brush:function(t,e){return this.emit("brush",t,e),this},end:function(t,e){return 0==--this.active&&(delete this.state.emitter,this.emit("end",t,e)),this},emit:function(e,n,r){var i=wl(this.that).datum();l.call(e,this.that,new Va(e,{sourceEvent:n,target:s,selection:t.output(this.state.selection),mode:r,dispatch:l}),i)}},s.extent=function(t){return arguments.length?(n="function"==typeof t?t:Ia(ts(t)),s):n},s.filter=function(t){return arguments.length?(r="function"==typeof t?t:Ia(!!t),s):r},s.touchable=function(t){return arguments.length?(i="function"==typeof t?t:Ia(!!t),s):i},s.handleSize=function(t){return arguments.length?(a=+t,s):a},s.keyModifiers=function(t){return arguments.length?(o=!!t,s):o},s.on=function(){var t=l.on.apply(l,arguments);return t===l?s:t},s}function ys(t){b(t,"svelte-1sazhg0","div.svelte-1sazhg0{position:relative;width:100%;height:100%}svg.svelte-1sazhg0,canvas.svelte-1sazhg0{position:absolute;top:0;left:0}")}function ws(t){let e,n,r,i,o,l=t[5]&&t[10]&&t[16].length>0&&bs(t);const a=[ks,_s],s=[];function c(t,e){return"bandwidth"in t[14]?0:1}return n=c(t),r=s[n]=a[n](t),{c(){l&&l.c(),e=A(),r.c(),i=A()},m(t,r){l&&l.m(t,r),x(t,e,r),s[n].m(t,r),x(t,i,r),o=!0},p(t,o){t[5]&&t[10]&&t[16].length>0?l?(l.p(t,o),66592&o[0]&&lt(l,1)):(l=bs(t),l.c(),lt(l,1),l.m(e.parentNode,e)):l&&(it(),at(l,1,1,(()=>{l=null})),ot());let u=n;n=c(t),n===u?s[n].p(t,o):(it(),at(s[u],1,1,(()=>{s[u]=null})),ot(),r=s[n],r?r.p(t,o):(r=s[n]=a[n](t),r.c()),lt(r,1),r.m(i.parentNode,i))},i(t){o||(lt(l),lt(r),o=!0)},o(t){at(l),at(r),o=!1},d(t){l&&l.d(t),t&&$(e),s[n].d(t),t&&$(i)}}}function bs(t){let e,n,r,i;const o=[$s,xs],l=[];function a(t,e){return"bandwidth"in t[14]?0:1}return e=a(t),n=l[e]=o[e](t),{c(){n.c(),r=A()},m(t,n){l[e].m(t,n),x(t,r,n),i=!0},p(t,i){let s=e;e=a(t),e===s?l[e].p(t,i):(it(),at(l[s],1,1,(()=>{l[s]=null})),ot(),n=l[e],n?n.p(t,i):(n=l[e]=o[e](t),n.c()),lt(n,1),n.m(r.parentNode,r))},i(t){i||(lt(n),i=!0)},o(t){at(n),i=!1},d(t){l[e].d(t),t&&$(r)}}}function xs(t){let e,n;return e=new bi({props:{data:t[10],fill:Ss,x:t[14],height:t[4],direction:"horizontal",translate:[0,t[12].top-t[4]],unit:"percent",maxValue:t[17]}}),{c(){ht(e.$$.fragment)},m(t,r){ft(e,t,r),n=!0},p(t,n){const r={};1024&n[0]&&(r.data=t[10]),16384&n[0]&&(r.x=t[14]),16&n[0]&&(r.height=t[4]),4112&n[0]&&(r.translate=[0,t[12].top-t[4]]),131072&n[0]&&(r.maxValue=t[17]),e.$set(r)},i(t){n||(lt(e.$$.fragment,t),n=!0)},o(t){at(e.$$.fragment,t),n=!1},d(t){pt(e,t)}}}function $s(t){let e,n;return e=new Ti({props:{data:t[10],fill:Ss,x:t[14],height:t[4],direction:"horizontal",translate:[0,t[12].top-t[4]],unit:"percent",maxValue:t[17]}}),{c(){ht(e.$$.fragment)},m(t,r){ft(e,t,r),n=!0},p(t,n){const r={};1024&n[0]&&(r.data=t[10]),16384&n[0]&&(r.x=t[14]),16&n[0]&&(r.height=t[4]),4112&n[0]&&(r.translate=[0,t[12].top-t[4]]),131072&n[0]&&(r.maxValue=t[17]),e.$set(r)},i(t){n||(lt(e.$$.fragment,t),n=!0)},o(t){at(e.$$.fragment,t),n=!1},d(t){pt(e,t)}}}function _s(t){let e,n;return e=new bi({props:{data:t[11].distribution,fill:t[18]?"none":"var(--gray-3)",stroke:t[18]?"var(--black)":"none",x:t[14],height:t[4],direction:"horizontal",translate:[0,t[12].top-t[4]],unit:"percent",maxValue:t[17]}}),{c(){ht(e.$$.fragment)},m(t,r){ft(e,t,r),n=!0},p(t,n){const r={};2048&n[0]&&(r.data=t[11].distribution),262144&n[0]&&(r.fill=t[18]?"none":"var(--gray-3)"),262144&n[0]&&(r.stroke=t[18]?"var(--black)":"none"),16384&n[0]&&(r.x=t[14]),16&n[0]&&(r.height=t[4]),4112&n[0]&&(r.translate=[0,t[12].top-t[4]]),131072&n[0]&&(r.maxValue=t[17]),e.$set(r)},i(t){n||(lt(e.$$.fragment,t),n=!0)},o(t){at(e.$$.fragment,t),n=!1},d(t){pt(e,t)}}}function ks(t){let e,n;return e=new Ti({props:{data:t[11].distribution,fill:t[18]?"none":"var(--gray-3)",stroke:t[18]?"var(--black)":"none",x:t[14],height:t[4],direction:"horizontal",translate:[0,t[12].top-t[4]],unit:"percent",maxValue:t[17]}}),{c(){ht(e.$$.fragment)},m(t,r){ft(e,t,r),n=!0},p(t,n){const r={};2048&n[0]&&(r.data=t[11].distribution),262144&n[0]&&(r.fill=t[18]?"none":"var(--gray-3)"),262144&n[0]&&(r.stroke=t[18]?"var(--black)":"none"),16384&n[0]&&(r.x=t[14]),16&n[0]&&(r.height=t[4]),4112&n[0]&&(r.translate=[0,t[12].top-t[4]]),131072&n[0]&&(r.maxValue=t[17]),e.$set(r)},i(t){n||(lt(e.$$.fragment,t),n=!0)},o(t){at(e.$$.fragment,t),n=!1},d(t){pt(e,t)}}}function Ms(t){let e,n,r,i,o;return{c(){e=M("rect"),z(e,"x",n=t[12].left),z(e,"y",r=t[12].top),z(e,"width",i=t[1]-t[12].left-t[12].right),z(e,"height",o=t[2]-t[12].top-t[12].bottom),z(e,"stroke","var(--gray-2)"),z(e,"fill","none"),z(e,"pointer-events","none")},m(t,n){x(t,e,n)},p(t,l){4096&l[0]&&n!==(n=t[12].left)&&z(e,"x",n),4096&l[0]&&r!==(r=t[12].top)&&z(e,"y",r),4098&l[0]&&i!==(i=t[1]-t[12].left-t[12].right)&&z(e,"width",i),4100&l[0]&&o!==(o=t[2]-t[12].top-t[12].bottom)&&z(e,"height",o)},d(t){t&&$(e)}}}function Ls(t){let e,n,r,i,o,l,a,s,c;l=new Yr({props:{scale:t[14],y:t[15]-t[12].bottom,label:t[0].x_feature,integerOnly:"discrete"===t[11].subkind,value_map:"value_map"in t[11]?t[11].value_map:{}}}),a=new ci({props:{scale:t[13],x:t[12].left,label:t[7]?"centered prediction":"prediction"}});let u=t[3]&&ws(t),d=t[6]&&t[19]===t[0].x_feature&&Ms(t);return{c(){e=k("div"),n=k("canvas"),r=S(),i=M("svg"),o=M("g"),ht(l.$$.fragment),ht(a.$$.fragment),u&&u.c(),s=A(),d&&d.c(),z(n,"class","svelte-1sazhg0"),z(i,"width",t[1]),z(i,"height",t[2]),z(i,"class","svelte-1sazhg0"),z(e,"class","svelte-1sazhg0")},m(h,f){x(h,e,f),w(e,n),t[37](n),w(e,r),w(e,i),w(i,o),ft(l,o,null),ft(a,o,null),u&&u.m(o,null),w(o,s),d&&d.m(o,null),t[38](o),c=!0},p(t,e){const n={};16384&e[0]&&(n.scale=t[14]),36864&e[0]&&(n.y=t[15]-t[12].bottom),1&e[0]&&(n.label=t[0].x_feature),2048&e[0]&&(n.integerOnly="discrete"===t[11].subkind),2048&e[0]&&(n.value_map="value_map"in t[11]?t[11].value_map:{}),l.$set(n);const r={};8192&e[0]&&(r.scale=t[13]),4096&e[0]&&(r.x=t[12].left),128&e[0]&&(r.label=t[7]?"centered prediction":"prediction"),a.$set(r),t[3]?u?(u.p(t,e),8&e[0]&&lt(u,1)):(u=ws(t),u.c(),lt(u,1),u.m(o,s)):u&&(it(),at(u,1,1,(()=>{u=null})),ot()),t[6]&&t[19]===t[0].x_feature?d?d.p(t,e):(d=Ms(t),d.c(),d.m(o,null)):d&&(d.d(1),d=null),(!c||2&e[0])&&z(i,"width",t[1]),(!c||4&e[0])&&z(i,"height",t[2])},i(t){c||(lt(l.$$.fragment,t),lt(a.$$.fragment,t),lt(u),c=!0)},o(t){at(l.$$.fragment,t),at(a.$$.fragment,t),at(u),c=!1},d(n){n&&$(e),t[37](null),pt(l),pt(a),u&&u.d(),d&&d.d(),t[38](null)}}}const Ss="#4EBA72";function As(t,e,n){let r,i,o,l,a,s,c,u,d,h,f,g,v,y,w,b,x,$,_;p(t,Vn,(t=>n(16,g=t))),p(t,tr,(t=>n(31,v=t))),p(t,Jn,(t=>n(32,y=t))),p(t,Qn,(t=>n(19,w=t))),p(t,Rn,(t=>n(33,b=t))),p(t,Hn,(t=>n(34,x=t))),p(t,Dn,(t=>n(35,$=t))),p(t,Cn,(t=>n(36,_=t)));let k,M,{pd:L}=e,{width:S}=e,{height:A}=e,{scaleLocally:N}=e,{showMarginalDistribution:z}=e,{marginTop:T}=e,{distributionHeight:C}=e,{allowBrushing:B=!1}=e,{showBrushedBorder:j=!1}=e,{iceLineWidth:q}=e,{center:P=!1}=e;function E(t,e,n,r,i,o,l,a,s,c,u,d){var h;if(null==e||null==n)return;e.save(),e.clearRect(0,0,c,u),e.lineWidth=l,e.strokeStyle="rgb(198, 198, 198)",e.globalAlpha=.15;const f=d?t.ice.centered_ice_lines:t.ice.ice_lines;if(f.forEach((t=>{e.beginPath(),n(t),e.stroke()})),s&&(e.strokeStyle="#4EBA72",e.globalAlpha=.3,r.forEach((t=>{e.beginPath(),n(f[t]),e.stroke()}))),e.lineWidth=2,e.strokeStyle="black",e.fillStyle="black",e.globalAlpha=1,e.beginPath(),n(d?t.ice.centered_pdp:t.mean_predictions),e.stroke(),"step"in i)for(let n=0;n<t.x_values.length;n++){const r=null!==(h=i(t.x_values[n]))&&void 0!==h?h:0,l=o(d?t.ice.centered_pdp[n]:t.mean_predictions[n]);e.beginPath(),e.arc(r,l,a,0,2*Math.PI),e.fill()}e.restore()}H((()=>{n(23,M=k.getContext("2d"))}));let O,D,R,I=!1,F=!1;function W(t){n(24,I=!0),m(Jn,y=!0,y),n(25,F=!0)}function X({selection:t}){if(!t)return void m(Vn,g=[],g);m(Qn,w=L.x_feature,w);const[[e,n],[r,i]]=t,o=L.x_values.map((t=>{var e;return null!==(e=l(t))&&void 0!==e?e:0})),a=P?L.ice.centered_ice_lines:L.ice.ice_lines;m(Vn,g=a.map(((t,e)=>({lines:t,index:e}))).filter((({lines:t})=>t.some(((t,l)=>{const a=s(t),c=o[l];return c>=e&&c<=r&&a>=n&&a<=i})))).map((({index:t})=>t)),g)}function Y({selection:t}){null===t&&(n(24,I=!1),m(Vn,g=[],g),m(Qn,w="",w)),m(Jn,y=!1,y),n(25,F=!1)}return t.$$set=t=>{"pd"in t&&n(0,L=t.pd),"width"in t&&n(1,S=t.width),"height"in t&&n(2,A=t.height),"scaleLocally"in t&&n(20,N=t.scaleLocally),"showMarginalDistribution"in t&&n(3,z=t.showMarginalDistribution),"marginTop"in t&&n(21,T=t.marginTop),"distributionHeight"in t&&n(4,C=t.distributionHeight),"allowBrushing"in t&&n(5,B=t.allowBrushing),"showBrushedBorder"in t&&n(6,j=t.showBrushedBorder),"iceLineWidth"in t&&n(22,q=t.iceLineWidth),"center"in t&&n(7,P=t.center)},t.$$.update=()=>{1&t.$$.dirty[0]|32&t.$$.dirty[1]&&n(11,r=_[L.x_feature]),2097152&t.$$.dirty[0]&&n(12,i={top:T,right:10,bottom:35,left:50}),4&t.$$.dirty[0]&&n(15,o=A),6147&t.$$.dirty[0]&&n(14,l="quantitative"===r.kind?en().domain([L.x_values[0],L.x_values[L.x_values.length-1]]).range([i.left,S-i.right]):pr().domain(L.x_values).range([i.left,S-i.right]).padding(.5)),16384&t.$$.dirty[0]&&n(29,a="step"in l?Math.min(3,l.step()/2-1):0),1085569&t.$$.dirty[0]|28&t.$$.dirty[1]&&n(13,s=Mn(L,o,0,P?"centered-lines":"lines",N,$,x,b,i)),8413185&t.$$.dirty[0]&&n(30,c=Ar().x(((t,e)=>{var n;return null!==(n=l(L.x_values[e]))&&void 0!==n?n:0})).y((t=>s(t))).context(M)),65568&t.$$.dirty[0]&&n(28,u=B&&g.length>0),8388870&t.$$.dirty[0]&&M&&(_n(k,M,S,A),E(L,M,c,g,l,s,q,a,u,S,A,P)),1891721351&t.$$.dirty[0]&&E(L,M,c,g,l,s,q,a,u,S,A,P),4102&t.$$.dirty[0]&&n(27,d=ms().extent([[i.left,i.top],[S-i.right,A-i.bottom]]).on("start",W).on("brush",X).on("end",Y)),201327136&t.$$.dirty[0]&&O&&B&&(n(26,D=wl(O)),D.call(d)),251658240&t.$$.dirty[0]|2&t.$$.dirty[1]&&y&&I&&!F&&D.call(d.clear),1&t.$$.dirty[0]|1&t.$$.dirty[1]&&n(10,R=v.get(L.x_feature)),66592&t.$$.dirty[0]&&n(18,h=B&&R&&g.length>0),3072&t.$$.dirty[0]&&n(17,f=function(t,e){const n=Math.max(...t.percents);if(!e)return n;const r=Math.max(...e.percents);return Math.max(n,r)}(r.distribution,R))},[L,S,A,z,C,B,j,P,k,O,R,r,i,s,l,o,g,f,h,w,N,T,q,M,I,F,D,d,u,a,c,v,y,b,x,$,_,function(t){V[t?"unshift":"push"]((()=>{k=t,n(8,k)}))},function(t){V[t?"unshift":"push"]((()=>{O=t,n(9,O)}))}]}const Ns=class extends mt{constructor(t){super(),gt(this,t,As,Ls,d,{pd:0,width:1,height:2,scaleLocally:20,showMarginalDistribution:3,marginTop:21,distributionHeight:4,allowBrushing:5,showBrushedBorder:6,iceLineWidth:22,center:7},ys,[-1,-1])}};function zs(t){let e,n;return e=new Ri({props:{pd:t[0],width:t[1],height:t[2],scaleLocally:t[3],showMarginalDistribution:t[5],marginTop:t[6],distributionHeight:t[7],indices:t[8],showTitle:t[12]}}),{c(){ht(e.$$.fragment)},m(t,r){ft(e,t,r),n=!0},p(t,n){const r={};1&n&&(r.pd=t[0]),2&n&&(r.width=t[1]),4&n&&(r.height=t[2]),8&n&&(r.scaleLocally=t[3]),32&n&&(r.showMarginalDistribution=t[5]),64&n&&(r.marginTop=t[6]),128&n&&(r.distributionHeight=t[7]),256&n&&(r.indices=t[8]),4096&n&&(r.showTitle=t[12]),e.$set(r)},i(t){n||(lt(e.$$.fragment,t),n=!0)},o(t){at(e.$$.fragment,t),n=!1},d(t){pt(e,t)}}}function Ts(t){let e,n;return e=new no({props:{pd:t[0],width:t[1],height:t[2],scaleLocally:t[3],showMarginalDistribution:t[5],marginTop:t[6],distributionHeight:t[7]}}),{c(){ht(e.$$.fragment)},m(t,r){ft(e,t,r),n=!0},p(t,n){const r={};1&n&&(r.pd=t[0]),2&n&&(r.width=t[1]),4&n&&(r.height=t[2]),8&n&&(r.scaleLocally=t[3]),32&n&&(r.showMarginalDistribution=t[5]),64&n&&(r.marginTop=t[6]),128&n&&(r.distributionHeight=t[7]),e.$set(r)},i(t){n||(lt(e.$$.fragment,t),n=!0)},o(t){at(e.$$.fragment,t),n=!1},d(t){pt(e,t)}}}function Cs(t){let e,n;return e=new Ns({props:{pd:t[0],width:t[1],height:t[2],scaleLocally:t[3],showMarginalDistribution:t[5],marginTop:t[6],distributionHeight:t[7],allowBrushing:t[9],showBrushedBorder:t[10],iceLineWidth:t[11],center:"centered-lines"===t[4]}}),{c(){ht(e.$$.fragment)},m(t,r){ft(e,t,r),n=!0},p(t,n){const r={};1&n&&(r.pd=t[0]),2&n&&(r.width=t[1]),4&n&&(r.height=t[2]),8&n&&(r.scaleLocally=t[3]),32&n&&(r.showMarginalDistribution=t[5]),64&n&&(r.marginTop=t[6]),128&n&&(r.distributionHeight=t[7]),512&n&&(r.allowBrushing=t[9]),1024&n&&(r.showBrushedBorder=t[10]),2048&n&&(r.iceLineWidth=t[11]),16&n&&(r.center="centered-lines"===t[4]),e.$set(r)},i(t){n||(lt(e.$$.fragment,t),n=!0)},o(t){at(e.$$.fragment,t),n=!1},d(t){pt(e,t)}}}function Bs(t){let e,n,r,i;const o=[Cs,Ts,zs],l=[];function a(t,e){return"lines"===t[4]||"centered-lines"===t[4]?0:"cluster-centers"===t[4]?1:2}return e=a(t),n=l[e]=o[e](t),{c(){n.c(),r=A()},m(t,n){l[e].m(t,n),x(t,r,n),i=!0},p(t,[i]){let s=e;e=a(t),e===s?l[e].p(t,i):(it(),at(l[s],1,1,(()=>{l[s]=null})),ot(),n=l[e],n?n.p(t,i):(n=l[e]=o[e](t),n.c()),lt(n,1),n.m(r.parentNode,r))},i(t){i||(lt(n),i=!0)},o(t){at(n),i=!1},d(t){l[e].d(t),t&&$(r)}}}function js(t,e,n){let{pd:r}=e,{width:i}=e,{height:o}=e,{scaleLocally:l}=e,{iceLevel:a}=e,{showMarginalDistribution:s}=e,{marginTop:c}=e,{distributionHeight:u}=e,{indices:d}=e,{allowBrushing:h}=e,{showBrushedBorder:f}=e,{iceLineWidth:p}=e,{showTitle:g=!1}=e;return t.$$set=t=>{"pd"in t&&n(0,r=t.pd),"width"in t&&n(1,i=t.width),"height"in t&&n(2,o=t.height),"scaleLocally"in t&&n(3,l=t.scaleLocally),"iceLevel"in t&&n(4,a=t.iceLevel),"showMarginalDistribution"in t&&n(5,s=t.showMarginalDistribution),"marginTop"in t&&n(6,c=t.marginTop),"distributionHeight"in t&&n(7,u=t.distributionHeight),"indices"in t&&n(8,d=t.indices),"allowBrushing"in t&&n(9,h=t.allowBrushing),"showBrushedBorder"in t&&n(10,f=t.showBrushedBorder),"iceLineWidth"in t&&n(11,p=t.iceLineWidth),"showTitle"in t&&n(12,g=t.showTitle)},[r,i,o,l,a,s,c,u,d,h,f,p,g]}const qs=class extends mt{constructor(t){super(),gt(this,t,js,Bs,d,{pd:0,width:1,height:2,scaleLocally:3,iceLevel:4,showMarginalDistribution:5,marginTop:6,distributionHeight:7,indices:8,allowBrushing:9,showBrushedBorder:10,iceLineWidth:11,showTitle:12})}};function Ps(t,e,n,r,i,o,l,a,s,c){var u,d;e.save(),e.clearRect(0,0,n,r);for(let n=0;n<t.x_values.length;n++){const r=t.x_values[n],h=t.y_values[n],f=t.mean_predictions[n],p=t.interactions[n];e.fillStyle=l("interactions"===a?p:f);const g="bandwidth"in i?(null!==(u=i(r))&&void 0!==u?u:0)+1:i(r)-s/2,m="bandwidth"in o?(null!==(d=o(h))&&void 0!==d?d:0)+1:o(h)-c/2;e.fillRect(g,m,s,c)}e.restore()}function Es(t){b(t,"svelte-sh84n1",".color-container.svelte-sh84n1{position:relative}svg.svelte-sh84n1{position:absolute;left:0;top:0}")}function Os(t,e,n){const r=t.slice();return r[16]=e[n],r}function Ds(t){let e,n,r,i,o,l,a,s=kn(t[16])+"";return{c(){e=M("g"),n=M("line"),i=M("text"),o=L(s),z(n,"y1",r=0),z(n,"y2",t[5]),z(n,"stroke","black"),z(i,"y",l=t[5]+Rs),z(i,"dominant-baseline","hanging"),z(i,"text-anchor","middle"),z(i,"font-size",Is),z(e,"transform",a="translate("+t[4](t[16])+","+t[2]+")")},m(t,r){x(t,e,r),w(e,n),w(e,i),w(i,o)},p(t,r){32&r&&z(n,"y2",t[5]),64&r&&s!==(s=kn(t[16])+"")&&C(o,s),32&r&&l!==(l=t[5]+Rs)&&z(i,"y",l),84&r&&a!==(a="translate("+t[4](t[16])+","+t[2]+")")&&z(e,"transform",a)},d(t){t&&$(e)}}}function Hs(t){let e,n,r,i,o=t[6],a=[];for(let e=0;e<o.length;e+=1)a[e]=Ds(Os(t,o,e));return{c(){e=k("div"),n=k("canvas"),r=S(),i=M("svg");for(let t=0;t<a.length;t+=1)a[t].c();z(i,"width",t[0]),z(i,"height",t[1]),z(i,"class","svelte-sh84n1"),z(e,"class","color-container svelte-sh84n1"),j(e,"height",t[1]+"px")},m(o,l){x(o,e,l),w(e,n),t[14](n),w(e,r),w(e,i);for(let t=0;t<a.length;t+=1)a[t].m(i,null)},p(t,[n]){if(116&n){let e;for(o=t[6],e=0;e<o.length;e+=1){const r=Os(t,o,e);a[e]?a[e].p(r,n):(a[e]=Ds(r),a[e].c(),a[e].m(i,null))}for(;e<a.length;e+=1)a[e].d(1);a.length=o.length}1&n&&z(i,"width",t[0]),2&n&&z(i,"height",t[1]),2&n&&j(e,"height",t[1]+"px")},i:l,o:l,d(n){n&&$(e),t[14](null),_(a,n)}}}const Rs=2,Is=10;function Vs(t,e,n){let r,i,o,l,a,s,c,{width:u}=e,{height:d}=e,{color:h}=e,{marginTop:f=0}=e,{marginRight:p=0}=e,{marginBottom:g=0}=e,{marginLeft:m=0}=e;return H((()=>{n(11,c=s.getContext("2d"))})),t.$$set=t=>{"width"in t&&n(0,u=t.width),"height"in t&&n(1,d=t.height),"color"in t&&n(7,h=t.color),"marginTop"in t&&n(2,f=t.marginTop),"marginRight"in t&&n(8,p=t.marginRight),"marginBottom"in t&&n(9,g=t.marginBottom),"marginLeft"in t&&n(10,m=t.marginLeft)},t.$$.update=()=>{1281&t.$$.dirty&&n(13,r=u-m-p),518&t.$$.dirty&&n(5,i=d-f-g-Is-Rs),2059&t.$$.dirty&&c&&_n(s,c,u,d),11431&t.$$.dirty&&c&&function(t,e,n,r,i,o,l,a){t.clearRect(0,0,n,r);for(let n=0;n<i;n++)t.fillStyle=e(n/i),t.fillRect(n+l,a,1,o)}(c,h.interpolator(),u,d,r,i,m,f),1409&t.$$.dirty&&n(4,o=en().domain([h.domain()[0],h.domain()[h.domain().length-1]]).range([m,u-p])),128&t.$$.dirty&&n(12,l=h.domain().length),12304&t.$$.dirty&&n(6,a=o.ticks(Math.max(r/50,l)))},[u,d,f,s,o,i,a,h,p,g,m,c,l,r,function(t){V[t?"unshift":"push"]((()=>{s=t,n(3,s)}))}]}const Fs=class extends mt{constructor(t){super(),gt(this,t,Vs,Hs,d,{width:0,height:1,color:7,marginTop:2,marginRight:8,marginBottom:9,marginLeft:10},Es)}};function Ws(t,e=Xs){const n=[];let r,i=!1;for(const o of t)i&&n.push(e(r,o)),r=o,i=!0;return n}function Xs(t,e){return[t,e]}function Ys(t){b(t,"svelte-1fhirhh","div.svelte-1fhirhh{position:relative;width:100%;height:100%}svg.svelte-1fhirhh,canvas.svelte-1fhirhh{position:absolute;top:var(--top);left:0}")}function Ks(t){let e,n;return e=new Fs({props:{width:t[1],height:t[13],color:t[6],marginLeft:t[10].left,marginRight:t[10].right}}),{c(){ht(e.$$.fragment)},m(t,r){ft(e,t,r),n=!0},p(t,n){const r={};2&n[0]&&(r.width=t[1]),8192&n[0]&&(r.height=t[13]),64&n[0]&&(r.color=t[6]),1024&n[0]&&(r.marginLeft=t[10].left),1024&n[0]&&(r.marginRight=t[10].right),e.$set(r)},i(t){n||(lt(e.$$.fragment,t),n=!0)},o(t){at(e.$$.fragment,t),n=!1},d(t){pt(e,t)}}}function Us(t){let e,n,r,i,o,l,a;const s=[Zs,Gs],c=[];function u(t,e){return"bandwidth"in t[8]?0:1}e=u(t),n=c[e]=s[e](t);const d=[Qs,Js],h=[];function f(t,e){return"bandwidth"in t[7]?0:1}return i=f(t),o=h[i]=d[i](t),{c(){n.c(),r=A(),o.c(),l=A()},m(t,n){c[e].m(t,n),x(t,r,n),h[i].m(t,n),x(t,l,n),a=!0},p(t,a){let p=e;e=u(t),e===p?c[e].p(t,a):(it(),at(c[p],1,1,(()=>{c[p]=null})),ot(),n=c[e],n?n.p(t,a):(n=c[e]=s[e](t),n.c()),lt(n,1),n.m(r.parentNode,r));let g=i;i=f(t),i===g?h[i].p(t,a):(it(),at(h[g],1,1,(()=>{h[g]=null})),ot(),o=h[i],o?o.p(t,a):(o=h[i]=d[i](t),o.c()),lt(o,1),o.m(l.parentNode,l))},i(t){a||(lt(n),lt(o),a=!0)},o(t){at(n),at(o),a=!1},d(t){c[e].d(t),t&&$(r),h[i].d(t),t&&$(l)}}}function Gs(t){let e,n;return e=new bi({props:{data:t[12].distribution,x:t[8],height:t[4],direction:"horizontal",translate:[0,t[10].top-t[4]]}}),{c(){ht(e.$$.fragment)},m(t,r){ft(e,t,r),n=!0},p(t,n){const r={};4096&n[0]&&(r.data=t[12].distribution),256&n[0]&&(r.x=t[8]),16&n[0]&&(r.height=t[4]),1040&n[0]&&(r.translate=[0,t[10].top-t[4]]),e.$set(r)},i(t){n||(lt(e.$$.fragment,t),n=!0)},o(t){at(e.$$.fragment,t),n=!1},d(t){pt(e,t)}}}function Zs(t){let e,n;return e=new Ti({props:{data:t[12].distribution,x:t[8],height:t[4],direction:"horizontal",translate:[0,t[10].top-t[4]]}}),{c(){ht(e.$$.fragment)},m(t,r){ft(e,t,r),n=!0},p(t,n){const r={};4096&n[0]&&(r.data=t[12].distribution),256&n[0]&&(r.x=t[8]),16&n[0]&&(r.height=t[4]),1040&n[0]&&(r.translate=[0,t[10].top-t[4]]),e.$set(r)},i(t){n||(lt(e.$$.fragment,t),n=!0)},o(t){at(e.$$.fragment,t),n=!1},d(t){pt(e,t)}}}function Js(t){let e,n;return e=new bi({props:{data:t[11].distribution,x:t[7],height:t[4],direction:"vertical",translate:[t[1]-t[10].right,0]}}),{c(){ht(e.$$.fragment)},m(t,r){ft(e,t,r),n=!0},p(t,n){const r={};2048&n[0]&&(r.data=t[11].distribution),128&n[0]&&(r.x=t[7]),16&n[0]&&(r.height=t[4]),1026&n[0]&&(r.translate=[t[1]-t[10].right,0]),e.$set(r)},i(t){n||(lt(e.$$.fragment,t),n=!0)},o(t){at(e.$$.fragment,t),n=!1},d(t){pt(e,t)}}}function Qs(t){let e,n;return e=new Ti({props:{data:t[11].distribution,x:t[7],height:t[4],direction:"vertical",translate:[t[1]-t[10].right,0]}}),{c(){ht(e.$$.fragment)},m(t,r){ft(e,t,r),n=!0},p(t,n){const r={};2048&n[0]&&(r.data=t[11].distribution),128&n[0]&&(r.x=t[7]),16&n[0]&&(r.height=t[4]),1026&n[0]&&(r.translate=[t[1]-t[10].right,0]),e.$set(r)},i(t){n||(lt(e.$$.fragment,t),n=!0)},o(t){at(e.$$.fragment,t),n=!1},d(t){pt(e,t)}}}function tc(t){let e,n,r,i,o,l,a,s,c=t[3]&&Ks(t);l=new Yr({props:{scale:t[8],y:t[9]-t[10].bottom,label:t[0].x_feature,integerOnly:"discrete"===t[12].subkind,value_map:"value_map"in t[12]?t[12].value_map:{}}}),a=new ci({props:{scale:t[7],x:t[10].left,label:t[0].y_feature,integerOnly:"discrete"===t[11].subkind,value_map:"value_map"in t[11]?t[11].value_map:{}}});let u=t[2]&&Us(t);return{c(){e=k("div"),c&&c.c(),n=S(),r=k("canvas"),i=S(),o=M("svg"),ht(l.$$.fragment),ht(a.$$.fragment),u&&u.c(),z(r,"class","svelte-1fhirhh"),z(o,"width",t[1]),z(o,"height",t[9]),z(o,"class","svelte-1fhirhh"),z(e,"class","svelte-1fhirhh"),j(e,"--top",t[13])},m(d,h){x(d,e,h),c&&c.m(e,null),w(e,n),w(e,r),t[37](r),w(e,i),w(e,o),ft(l,o,null),ft(a,o,null),u&&u.m(o,null),s=!0},p(t,r){t[3]?c?(c.p(t,r),8&r[0]&&lt(c,1)):(c=Ks(t),c.c(),lt(c,1),c.m(e,n)):c&&(it(),at(c,1,1,(()=>{c=null})),ot());const i={};256&r[0]&&(i.scale=t[8]),1536&r[0]&&(i.y=t[9]-t[10].bottom),1&r[0]&&(i.label=t[0].x_feature),4096&r[0]&&(i.integerOnly="discrete"===t[12].subkind),4096&r[0]&&(i.value_map="value_map"in t[12]?t[12].value_map:{}),l.$set(i);const d={};128&r[0]&&(d.scale=t[7]),1024&r[0]&&(d.x=t[10].left),1&r[0]&&(d.label=t[0].y_feature),2048&r[0]&&(d.integerOnly="discrete"===t[11].subkind),2048&r[0]&&(d.value_map="value_map"in t[11]?t[11].value_map:{}),a.$set(d),t[2]?u?(u.p(t,r),4&r[0]&&lt(u,1)):(u=Us(t),u.c(),lt(u,1),u.m(o,null)):u&&(it(),at(u,1,1,(()=>{u=null})),ot()),(!s||2&r[0])&&z(o,"width",t[1]),(!s||512&r[0])&&z(o,"height",t[9]),8192&r[0]&&j(e,"--top",t[13])},i(t){s||(lt(c),lt(l.$$.fragment,t),lt(a.$$.fragment,t),lt(u),s=!0)},o(t){at(c),at(l.$$.fragment,t),at(a.$$.fragment,t),at(u),s=!1},d(n){n&&$(e),c&&c.d(),t[37](null),pt(l),pt(a),u&&u.d()}}}function ec(t,e,n){let r,i,o,l,a,s,c,u,d,h,f,g,m,v,y,w,b,x,$,_,k,M,L,S,A;p(t,er,(t=>n(34,L=t))),p(t,nr,(t=>n(35,S=t))),p(t,Cn,(t=>n(36,A=t)));let N,z,{pd:T}=e,{width:C}=e,{height:B}=e,{scaleLocally:j}=e,{showMarginalDistribution:q}=e,{colorShows:P}=e,{showColorLegend:E}=e,{marginTop:O=0}=e,{marginRight:D=0}=e,{distributionHeight:R}=e;return H((()=>{n(19,z=N.getContext("2d"))})),t.$$set=t=>{"pd"in t&&n(0,T=t.pd),"width"in t&&n(1,C=t.width),"height"in t&&n(14,B=t.height),"scaleLocally"in t&&n(15,j=t.scaleLocally),"showMarginalDistribution"in t&&n(2,q=t.showMarginalDistribution),"colorShows"in t&&n(16,P=t.colorShows),"showColorLegend"in t&&n(3,E=t.showColorLegend),"marginTop"in t&&n(17,O=t.marginTop),"marginRight"in t&&n(18,D=t.marginRight),"distributionHeight"in t&&n(4,R=t.distributionHeight)},t.$$.update=()=>{8&t.$$.dirty[0]&&n(13,r=E?24:0),24576&t.$$.dirty[0]&&n(9,i=B-r),393216&t.$$.dirty[0]&&n(31,o={top:O,right:D,bottom:35,left:50}),514&t.$$.dirty[0]|1&t.$$.dirty[1]&&n(33,l=Math.min(C-o.left-o.right,i-o.top-o.bottom)),2&t.$$.dirty[0]|5&t.$$.dirty[1]&&n(30,a=(C-l-o.left-o.right)/2),512&t.$$.dirty[0]|5&t.$$.dirty[1]&&n(32,s=(i-l-o.top-o.bottom)/2),1073741824&t.$$.dirty[0]|3&t.$$.dirty[1]&&n(10,c={top:o.top+s,right:o.right+a,bottom:o.bottom+s,left:o.left+a}),1&t.$$.dirty[0]|32&t.$$.dirty[1]&&n(12,u=A[T.x_feature]),1&t.$$.dirty[0]|32&t.$$.dirty[1]&&n(11,d=A[T.y_feature]),1&t.$$.dirty[0]|8&t.$$.dirty[1]&&n(28,h=L.copy().domain([T.pdp_min,T.pdp_max])),1&t.$$.dirty[0]|16&t.$$.dirty[1]&&n(29,f=S.copy().domain([T.interaction_min,0,T.interaction_max])),805404672&t.$$.dirty[0]|24&t.$$.dirty[1]&&n(6,g="interactions"===P?j?f:S:j?h:L),1&t.$$.dirty[0]&&n(25,m=Math.min(...Ws(T.x_axis,((t,e)=>e-t)))),1&t.$$.dirty[0]&&n(22,v=Math.min(...Ws(T.y_axis,((t,e)=>e-t)))),33554433&t.$$.dirty[0]&&n(24,y=T.x_axis[0]-m/2),33554433&t.$$.dirty[0]&&n(27,w=T.x_axis[T.x_axis.length-1]+m/2),4194305&t.$$.dirty[0]&&n(23,b=T.y_axis[0]-v/2),4194305&t.$$.dirty[0]&&n(26,x=T.y_axis[T.y_axis.length-1]+v/2),151000067&t.$$.dirty[0]&&n(8,$="quantitative"===u.kind?en().domain([y,w]).range([c.left,C-c.right]):hr().domain(T.x_axis).range([c.left,C-c.right])),75501057&t.$$.dirty[0]&&n(7,_="quantitative"===d.kind?en().domain([b,x]).range([i-c.bottom,c.top]):hr().domain(T.y_axis).range([i-c.bottom,c.top])),50331904&t.$$.dirty[0]&&n(21,k="bandwidth"in $?$.bandwidth()-2:$(y+m)-$(y)),12583040&t.$$.dirty[0]&&n(20,M="bandwidth"in _?_.bandwidth()-2:_(b)-_(b+v)),524834&t.$$.dirty[0]&&z&&(_n(N,z,C,i),z&&null!=$&&null!=_&&Ps(T,z,C,i,$,_,g,P,k,M)),3736515&t.$$.dirty[0]&&z&&null!=$&&null!=_&&Ps(T,z,C,i,$,_,g,P,k,M)},[T,C,q,E,R,N,g,_,$,i,c,d,u,r,B,j,P,O,D,z,M,k,v,b,y,m,x,w,h,f,a,o,s,l,L,S,A,function(t){V[t?"unshift":"push"]((()=>{N=t,n(5,N)}))}]}const nc=class extends mt{constructor(t){super(),gt(this,t,ec,tc,d,{pd:0,width:1,height:14,scaleLocally:15,showMarginalDistribution:2,colorShows:16,showColorLegend:3,marginTop:17,marginRight:18,distributionHeight:4},Ys,[-1,-1])}};function rc(t){let e,n,r,i;const o=[oc,ic],l=[];function a(t,e){return 1===t[0].num_features?0:2===t[0].num_features?1:-1}return~(e=a(t))&&(n=l[e]=o[e](t)),{c(){n&&n.c(),r=A()},m(t,n){~e&&l[e].m(t,n),x(t,r,n),i=!0},p(t,i){let s=e;e=a(t),e===s?~e&&l[e].p(t,i):(n&&(it(),at(l[s],1,1,(()=>{l[s]=null})),ot()),~e?(n=l[e],n?n.p(t,i):(n=l[e]=o[e](t),n.c()),lt(n,1),n.m(r.parentNode,r)):n=null)},i(t){i||(lt(n),i=!0)},o(t){at(n),i=!1},d(t){~e&&l[e].d(t),t&&$(r)}}}function ic(t){let e,n;return e=new nc({props:{width:t[1],height:t[2],pd:t[0],scaleLocally:t[3],colorShows:t[4],showColorLegend:t[5],marginTop:t[9],marginRight:t[10],distributionHeight:t[11],showMarginalDistribution:t[8]}}),{c(){ht(e.$$.fragment)},m(t,r){ft(e,t,r),n=!0},p(t,n){const r={};2&n&&(r.width=t[1]),4&n&&(r.height=t[2]),1&n&&(r.pd=t[0]),8&n&&(r.scaleLocally=t[3]),16&n&&(r.colorShows=t[4]),32&n&&(r.showColorLegend=t[5]),512&n&&(r.marginTop=t[9]),1024&n&&(r.marginRight=t[10]),2048&n&&(r.distributionHeight=t[11]),256&n&&(r.showMarginalDistribution=t[8]),e.$set(r)},i(t){n||(lt(e.$$.fragment,t),n=!0)},o(t){at(e.$$.fragment,t),n=!1},d(t){pt(e,t)}}}function oc(t){let e,n;return e=new qs({props:{width:t[1],height:t[2],pd:t[0],scaleLocally:t[3],iceLevel:t[6],showMarginalDistribution:t[8],marginTop:t[9],distributionHeight:t[11],indices:t[7],allowBrushing:t[12],showBrushedBorder:t[13],iceLineWidth:t[14],showTitle:t[15]}}),{c(){ht(e.$$.fragment)},m(t,r){ft(e,t,r),n=!0},p(t,n){const r={};2&n&&(r.width=t[1]),4&n&&(r.height=t[2]),1&n&&(r.pd=t[0]),8&n&&(r.scaleLocally=t[3]),64&n&&(r.iceLevel=t[6]),256&n&&(r.showMarginalDistribution=t[8]),512&n&&(r.marginTop=t[9]),2048&n&&(r.distributionHeight=t[11]),128&n&&(r.indices=t[7]),4096&n&&(r.allowBrushing=t[12]),8192&n&&(r.showBrushedBorder=t[13]),16384&n&&(r.iceLineWidth=t[14]),32768&n&&(r.showTitle=t[15]),e.$set(r)},i(t){n||(lt(e.$$.fragment,t),n=!0)},o(t){at(e.$$.fragment,t),n=!1},d(t){pt(e,t)}}}function lc(t){let e,n,r=t[1]>0&&t[2]>0&&rc(t);return{c(){r&&r.c(),e=A()},m(t,i){r&&r.m(t,i),x(t,e,i),n=!0},p(t,[n]){t[1]>0&&t[2]>0?r?(r.p(t,n),6&n&&lt(r,1)):(r=rc(t),r.c(),lt(r,1),r.m(e.parentNode,e)):r&&(it(),at(r,1,1,(()=>{r=null})),ot())},i(t){n||(lt(r),n=!0)},o(t){at(r),n=!1},d(t){r&&r.d(t),t&&$(e)}}}function ac(t,e,n){let{pd:r}=e,{width:i}=e,{height:o}=e,{scaleLocally:l}=e,{colorShows:a="predictions"}=e,{showColorLegend:s=!1}=e,{iceLevel:c}=e,{indices:u=null}=e,{showMarginalDistribution:d=!1}=e,{marginTop:h=0}=e,{marginRight:f=0}=e,{distributionHeight:p=0}=e,{allowBrushing:g=!1}=e,{showBrushedBorder:m=!1}=e,{iceLineWidth:v=1}=e,{showTitle:y=!1}=e;return t.$$set=t=>{"pd"in t&&n(0,r=t.pd),"width"in t&&n(1,i=t.width),"height"in t&&n(2,o=t.height),"scaleLocally"in t&&n(3,l=t.scaleLocally),"colorShows"in t&&n(4,a=t.colorShows),"showColorLegend"in t&&n(5,s=t.showColorLegend),"iceLevel"in t&&n(6,c=t.iceLevel),"indices"in t&&n(7,u=t.indices),"showMarginalDistribution"in t&&n(8,d=t.showMarginalDistribution),"marginTop"in t&&n(9,h=t.marginTop),"marginRight"in t&&n(10,f=t.marginRight),"distributionHeight"in t&&n(11,p=t.distributionHeight),"allowBrushing"in t&&n(12,g=t.allowBrushing),"showBrushedBorder"in t&&n(13,m=t.showBrushedBorder),"iceLineWidth"in t&&n(14,v=t.iceLineWidth),"showTitle"in t&&n(15,y=t.showTitle)},[r,i,o,l,a,s,c,u,d,h,f,p,g,m,v,y]}const sc=class extends mt{constructor(t){super(),gt(this,t,ac,lc,d,{pd:0,width:1,height:2,scaleLocally:3,colorShows:4,showColorLegend:5,iceLevel:6,indices:7,showMarginalDistribution:8,marginTop:9,marginRight:10,distributionHeight:11,allowBrushing:12,showBrushedBorder:13,iceLineWidth:14,showTitle:15})}};function cc(t,e){let n;if(void 0===e)for(const e of t)null!=e&&(n<e||void 0===n&&e>=e)&&(n=e);else{let r=-1;for(let i of t)null!=(i=e(i,++r,t))&&(n<i||void 0===n&&i>=i)&&(n=i)}return n}function uc(t,e,n=xe){if(r=t.length){if((e=+e)<=0||r<2)return+n(t[0],0,t);if(e>=1)return+n(t[r-1],r-1,t);var r,i=(r-1)*e,o=Math.floor(i),l=+n(t[o],o,t);return l+(+n(t[o+1],o+1,t)-l)*(i-o)}}function dc(t,e){let n;if(void 0===e)for(const e of t)null!=e&&(n>e||void 0===n&&e>=e)&&(n=e);else{let r=-1;for(let i of t)null!=(i=e(i,++r,t))&&(n>i||void 0===n&&i>=i)&&(n=i)}return n}function hc(t,e){if((i=t.length)>1)for(var n,r,i,o=1,l=t[e[0]],a=l.length;o<i;++o)for(r=l,l=t[e[o]],n=0;n<a;++n)l[n][1]+=l[n][0]=isNaN(r[n][1])?r[n][0]:r[n][1]}function fc(t){for(var e=t.length,n=new Array(e);--e>=0;)n[e]=e;return n}function pc(t,e){return t[e]}function gc(t){const e=[];return e.key=t,e}function mc(t,e){if((r=t.length)>0){for(var n,r,i,o=0,l=t[0].length;o<l;++o){for(i=n=0;n<r;++n)i+=t[n][o][1]||0;if(i)for(n=0;n<r;++n)t[n][o][1]/=i}hc(t,e)}}function vc(t){return fc(t).reverse()}function yc(t,e){var n,r,i=function(t){if(0===t.length)throw new Error("mean requires at least one data point");return function(t){if(0===t.length)return 0;var e,n=t[0],r=0;if("number"!=typeof n)return NaN;for(var i=1;i<t.length;i++){if("number"!=typeof t[i])return NaN;e=n+t[i],Math.abs(n)>=Math.abs(t[i])?r+=n-e+t[i]:r+=t[i]-e+n,n=e}return n+r}(t)/t.length}(t),o=0;if(2===e)for(r=0;r<t.length;r++)o+=(n=t[r]-i)*n;else for(r=0;r<t.length;r++)o+=Math.pow(t[r]-i,e);return o}function wc(t,e){var n=t.length*e;if(0===t.length)throw new Error("quantile requires at least one data point.");if(e<0||e>1)throw new Error("quantiles must be between 0 and 1");return 1===e?t[t.length-1]:0===e?t[0]:n%1!=0?t[Math.ceil(n)-1]:t.length%2==0?(t[n-1]+t[n])/2:t[n]}function bc(t,e,n,r){for(n=n||0,r=r||t.length-1;r>n;){if(r-n>600){var i=r-n+1,o=e-n+1,l=Math.log(i),a=.5*Math.exp(2*l/3),s=.5*Math.sqrt(l*a*(i-a)/i);o-i/2<0&&(s*=-1),bc(t,e,Math.max(n,Math.floor(e-o*a/i+s)),Math.min(r,Math.floor(e+(i-o)*a/i+s)))}var c=t[e],u=n,d=r;for(xc(t,n,e),t[r]>c&&xc(t,n,r);u<d;){for(xc(t,u,d),u++,d--;t[u]<c;)u++;for(;t[d]>c;)d--}t[n]===c?xc(t,n,d):xc(t,++d,r),d<=e&&(n=d+1),e<=d&&(r=d-1)}}function xc(t,e,n){var r=t[e];t[e]=t[n],t[n]=r}function $c(t,e){var n=t.slice();if(Array.isArray(e)){!function(t,e){for(var n=[0],r=0;r<e.length;r++)n.push(Mc(t.length,e[r]));n.push(t.length-1),n.sort(kc);for(var i=[0,n.length-1];i.length;){var o=Math.ceil(i.pop()),l=Math.floor(i.pop());if(!(o-l<=1)){var a=Math.floor((l+o)/2);_c(t,n[a],Math.floor(n[l]),Math.ceil(n[o])),i.push(l,a,a,o)}}}(n,e);for(var r=[],i=0;i<e.length;i++)r[i]=wc(n,e[i]);return r}return _c(n,Mc(n.length,e),0,n.length-1),wc(n,e)}function _c(t,e,n,r){e%1==0?bc(t,e,n,r):(bc(t,e=Math.floor(e),n,r),bc(t,e+1,e+1,r))}function kc(t,e){return t-e}function Mc(t,e){var n=t*e;return 1===e?t-1:0===e?0:n%1!=0?Math.ceil(n)-1:t%2==0?n-.5:n}function Lc(t){var e=function(t){if(t.length<2)throw new Error("sampleVariance requires at least two data points");return yc(t,2)/(t.length-1)}(t);return Math.sqrt(e)}var Sc=function(){this.totalCount=0,this.data={}};Sc.prototype.train=function(t,e){for(var n in this.data[e]||(this.data[e]={}),t){var r=t[n];void 0===this.data[e][n]&&(this.data[e][n]={}),void 0===this.data[e][n][r]&&(this.data[e][n][r]=0),this.data[e][n][r]++}this.totalCount++},Sc.prototype.score=function(t){var e,n={};for(var r in t){var i=t[r];for(e in this.data)n[e]={},this.data[e][r]?n[e][r+"_"+i]=(this.data[e][r][i]||0)/this.totalCount:n[e][r+"_"+i]=0}var o={};for(e in n)for(var l in o[e]=0,n[e])o[e]+=n[e][l];return o};var Ac=function(){this.weights=[],this.bias=0};Ac.prototype.predict=function(t){if(t.length!==this.weights.length)return null;for(var e=0,n=0;n<this.weights.length;n++)e+=this.weights[n]*t[n];return(e+=this.bias)>0?1:0},Ac.prototype.train=function(t,e){if(0!==e&&1!==e)return null;t.length!==this.weights.length&&(this.weights=t,this.bias=1);var n=this.predict(t);if("number"==typeof n&&n!==e){for(var r=e-n,i=0;i<this.weights.length;i++)this.weights[i]+=r*t[i];this.bias+=r}return this},Math.log(Math.sqrt(2*Math.PI));var Nc=Math.sqrt(2*Math.PI),zc={gaussian:function(t){return Math.exp(-.5*t*t)/Nc}},Tc={nrd:function(t){var e=Lc(t),n=function(t){var e=$c(t,.75),n=$c(t,.25);if("number"==typeof e&&"number"==typeof n)return e-n}(t);return"number"==typeof n&&(e=Math.min(e,n/1.34)),1.06*e*Math.pow(t.length,-.2)}},Cc=Math.sqrt(2*Math.PI);function Bc(t){for(var e=t,n=t,r=1;r<15;r++)e+=n*=t*t/(2*r+1);return Math.round(1e4*(.5+e/Cc*Math.exp(-t*t/2)))/1e4}for(var jc=[],qc=0;qc<=3.09;qc+=.01)jc.push(Bc(qc));function Pc(t){b(t,"svelte-1bbr6a4",".distributions-container.svelte-1bbr6a4{width:100%;height:100%;display:flex;flex-direction:column}.distributions-header.svelte-1bbr6a4{margin-bottom:0.5em}.distributions-settings.svelte-1bbr6a4{display:flex;align-items:center;gap:1em}.distribution-plots.svelte-1bbr6a4{flex:1;overflow-y:auto}.label-and-input.svelte-1bbr6a4{display:flex;align-items:center;gap:0.25em}")}function Ec(t,e,n){const r=t.slice();return r[35]=e[n],r}function Oc(t,e,n){const r=t.slice();return r[44]=e[n].cluster,r[45]=e[n].box,r}function Dc(t,e,n){const r=t.slice();return r[38]=e[n],r[40]=n,r}function Hc(t,e,n){const r=t.slice();return r[41]=e[n],r}function Rc(t){let e,n,r,i,o;return{c(){e=k("label"),n=k("input"),r=L("Normalize bar charts"),z(n,"type","checkbox"),z(e,"class","label-and-input svelte-1bbr6a4")},m(l,a){x(l,e,a),w(e,n),n.checked=t[1],w(e,r),i||(o=N(n,"change",t[25]),i=!0)},p(t,e){2&e[0]&&(n.checked=t[1])},d(t){t&&$(e),i=!1,o()}}}function Ic(t){let e,n=t[35].data,r=[];for(let e=0;e<n.length;e+=1)r[e]=Fc(Oc(t,n,e));return{c(){e=M("g");for(let t=0;t<r.length;t+=1)r[t].c()},m(t,n){x(t,e,n);for(let t=0;t<r.length;t+=1)r[t].m(e,null)},p(t,i){if(37956&i[0]){let o;for(n=t[35].data,o=0;o<n.length;o+=1){const l=Oc(t,n,o);r[o]?r[o].p(l,i):(r[o]=Fc(l),r[o].c(),r[o].m(e,null))}for(;o<r.length;o+=1)r[o].d(1);r.length=n.length}},i:l,o:l,d(t){t&&$(e),_(r,t)}}}function Vc(t){let e,n,r,i=t[35].data,o=[];for(let e=0;e<i.length;e+=1)o[e]=Yc(Dc(t,i,e));return n=new ci({props:{scale:t[11],x:t[14].left,label:t[1]?"percent":"count",format:t[1]?Ge("~%"):kn}}),{c(){e=M("g");for(let t=0;t<o.length;t+=1)o[t].c();ht(n.$$.fragment)},m(t,i){x(t,e,i);for(let t=0;t<o.length;t+=1)o[t].m(e,null);ft(n,t,i),r=!0},p(t,r){if(6212&r[0]){let n;for(i=t[35].data,n=0;n<i.length;n+=1){const l=Dc(t,i,n);o[n]?o[n].p(l,r):(o[n]=Yc(l),o[n].c(),o[n].m(e,null))}for(;n<o.length;n+=1)o[n].d(1);o.length=i.length}const l={};2048&r[0]&&(l.scale=t[11]),2&r[0]&&(l.label=t[1]?"percent":"count"),2&r[0]&&(l.format=t[1]?Ge("~%"):kn),n.$set(l)},i(t){r||(lt(n.$$.fragment,t),r=!0)},o(t){at(n.$$.fragment,t),r=!1},d(t){t&&$(e),_(o,t),pt(n,t)}}}function Fc(t){let e,n,r,i,o,l,a,s,c,u,d,h,f,p,g,m,v,y,b,_,k,L,S,A;return{c(){e=M("g"),n=M("path"),o=M("rect"),c=M("line"),m=M("line"),_=M("line"),z(n,"d",r=t[15](t[6][t[35].feature],t[45].densities)),z(n,"fill",i=t[12](t[44])),z(o,"x",l=t[6][t[35].feature](t[45].q1)??0),z(o,"width",a=(t[6][t[35].feature](t[45].q3)??0)-(t[6][t[35].feature](t[45].q1)??0)),z(o,"y",s=-Gc/2),z(o,"height",Gc),z(o,"fill","var(--gray-1)"),z(c,"x1",u=t[6][t[35].feature](t[45].median)??0),z(c,"x2",d=t[6][t[35].feature](t[45].median)??0),z(c,"stroke-width",h=2),z(c,"y1",f=-Gc/2),z(c,"y2",p=Gc/2),z(c,"stroke",g="black"),z(m,"x1",v=t[6][t[35].feature](t[45].low)??0),z(m,"x2",y=t[6][t[35].feature](t[45].q1)??0),z(m,"stroke-width",b=1),z(m,"stroke","var(--gray-1)"),z(_,"x1",k=t[6][t[35].feature](t[45].q3)??0),z(_,"x2",L=t[6][t[35].feature](t[45].high)??0),z(_,"stroke-width",S=1),z(_,"stroke","var(--gray-1)"),z(e,"transform",A="translate(0,"+((t[10](t[44])??0)+t[10].bandwidth()/2)+")")},m(t,r){x(t,e,r),w(e,n),w(e,o),w(e,c),w(e,m),w(e,_)},p(t,s){68&s[0]&&r!==(r=t[15](t[6][t[35].feature],t[45].densities))&&z(n,"d",r),4100&s[0]&&i!==(i=t[12](t[44]))&&z(n,"fill",i),68&s[0]&&l!==(l=t[6][t[35].feature](t[45].q1)??0)&&z(o,"x",l),68&s[0]&&a!==(a=(t[6][t[35].feature](t[45].q3)??0)-(t[6][t[35].feature](t[45].q1)??0))&&z(o,"width",a),68&s[0]&&u!==(u=t[6][t[35].feature](t[45].median)??0)&&z(c,"x1",u),68&s[0]&&d!==(d=t[6][t[35].feature](t[45].median)??0)&&z(c,"x2",d),68&s[0]&&v!==(v=t[6][t[35].feature](t[45].low)??0)&&z(m,"x1",v),68&s[0]&&y!==(y=t[6][t[35].feature](t[45].q1)??0)&&z(m,"x2",y),68&s[0]&&k!==(k=t[6][t[35].feature](t[45].q3)??0)&&z(_,"x1",k),68&s[0]&&L!==(L=t[6][t[35].feature](t[45].high)??0)&&z(_,"x2",L),1028&s[0]&&A!==(A="translate(0,"+((t[10](t[44])??0)+t[10].bandwidth()/2)+")")&&z(e,"transform",A)},d(t){t&&$(e)}}}function Wc(t){let e,n,r,i,o;return{c(){e=M("rect"),z(e,"x",n=tu(t[41].data[0],t[6][t[35].feature])+1),z(e,"width",r=Qc(t[6][t[35].feature])-2),z(e,"y",i=t[11](t[41][1])),z(e,"height",o=t[11](t[41][0])-t[11](t[41][1]))},m(t,n){x(t,e,n)},p(t,l){68&l[0]&&n!==(n=tu(t[41].data[0],t[6][t[35].feature])+1)&&z(e,"x",n),68&l[0]&&r!==(r=Qc(t[6][t[35].feature])-2)&&z(e,"width",r),2052&l[0]&&i!==(i=t[11](t[41][1]))&&z(e,"y",i),2052&l[0]&&o!==(o=t[11](t[41][0])-t[11](t[41][1]))&&z(e,"height",o)},d(t){t&&$(e)}}}function Xc(t){let e,n=t[41][0]!==t[41][1]&&Wc(t);return{c(){n&&n.c(),e=A()},m(t,r){n&&n.m(t,r),x(t,e,r)},p(t,r){t[41][0]!==t[41][1]?n?n.p(t,r):(n=Wc(t),n.c(),n.m(e.parentNode,e)):n&&(n.d(1),n=null)},d(t){n&&n.d(t),t&&$(e)}}}function Yc(t){let e,n,r=t[38],i=[];for(let e=0;e<r.length;e+=1)i[e]=Xc(Hc(t,r,e));return{c(){e=M("g");for(let t=0;t<i.length;t+=1)i[t].c();z(e,"fill",n=t[12](t[40]))},m(t,n){x(t,e,n);for(let t=0;t<i.length;t+=1)i[t].m(e,null)},p(t,o){if(2116&o[0]){let n;for(r=t[38],n=0;n<r.length;n+=1){const l=Hc(t,r,n);i[n]?i[n].p(l,o):(i[n]=Xc(l),i[n].c(),i[n].m(e,null))}for(;n<i.length;n+=1)i[n].d(1);i.length=r.length}4096&o[0]&&n!==(n=t[12](t[40]))&&z(e,"fill",n)},d(t){t&&$(e),_(i,t)}}}function Kc(t){let e,n,r,i,o,l,a,s;const c=[Vc,Ic],u=[];function d(t,e){return"categorical"===t[35].kind?0:1}return n=d(t),r=u[n]=c[n](t),o=new Yr({props:{scale:t[6][t[35].feature],y:t[4].bandwidth()-t[14].bottom,showBaseline:!0,baselineColor:"var(--gray-6)",tickColor:"var(--gray-6)",integerOnly:"discrete"===t[8][t[35].feature].subkind,value_map:Jc(t[8][t[35].feature]),label:t[35].feature}}),{c(){e=M("g"),r.c(),i=M("g"),ht(o.$$.fragment),z(i,"class","x-axis"),z(i,"id",l="axis-"+t[35].feature),z(e,"transform",a="translate(0,"+t[4](t[35].feature)+")")},m(t,r){x(t,e,r),u[n].m(e,null),w(e,i),ft(o,i,null),s=!0},p(t,h){let f=n;n=d(t),n===f?u[n].p(t,h):(it(),at(u[f],1,1,(()=>{u[f]=null})),ot(),r=u[n],r?r.p(t,h):(r=u[n]=c[n](t),r.c()),lt(r,1),r.m(e,i));const p={};68&h[0]&&(p.scale=t[6][t[35].feature]),16&h[0]&&(p.y=t[4].bandwidth()-t[14].bottom),260&h[0]&&(p.integerOnly="discrete"===t[8][t[35].feature].subkind),260&h[0]&&(p.value_map=Jc(t[8][t[35].feature])),4&h[0]&&(p.label=t[35].feature),o.$set(p),(!s||4&h[0]&&l!==(l="axis-"+t[35].feature))&&z(i,"id",l),(!s||20&h[0]&&a!==(a="translate(0,"+t[4](t[35].feature)+")"))&&z(e,"transform",a)},i(t){s||(lt(r),lt(o.$$.fragment,t),s=!0)},o(t){at(r),at(o.$$.fragment,t),s=!1},d(t){t&&$(e),u[n].d(),pt(o)}}}function Uc(t){let e,n,r,i,o,l,a,s,c,u,d,h,f,p,g,m,v=t[5].length+"",y=1===t[5].length?"instance":"instances",b=t[13].length>0&&Rc(t),A=t[2],N=[];for(let e=0;e<A.length;e+=1)N[e]=Kc(Ec(t,A,e));const T=t=>at(N[t],1,1,(()=>{N[t]=null}));return{c(){e=k("div"),n=k("div"),r=k("div"),r.textContent="Feature Distributions",i=S(),o=k("div"),b&&b.c(),l=S(),a=k("div"),s=L(v),c=S(),u=L(y),d=L(" selected"),h=S(),f=k("div"),p=M("svg"),g=M("g");for(let t=0;t<N.length;t+=1)N[t].c();z(r,"class","pdpilot-bold"),z(o,"class","distributions-settings svelte-1bbr6a4"),z(n,"class","distributions-header svelte-1bbr6a4"),z(p,"width",t[0]),z(p,"height",t[7]),z(f,"class","distribution-plots svelte-1bbr6a4"),z(e,"class","distributions-container svelte-1bbr6a4")},m(v,y){x(v,e,y),w(e,n),w(n,r),w(n,i),w(n,o),b&&b.m(o,null),w(o,l),w(o,a),w(a,s),w(a,c),w(a,u),w(a,d),w(e,h),w(e,f),w(f,p),w(p,g);for(let t=0;t<N.length;t+=1)N[t].m(g,null);t[26](g),t[27](f),m=!0},p(t,e){if(t[13].length>0?b?b.p(t,e):(b=Rc(t),b.c(),b.m(o,l)):b&&(b.d(1),b=null),(!m||32&e[0])&&v!==(v=t[5].length+"")&&C(s,v),(!m||32&e[0])&&y!==(y=1===t[5].length?"instance":"instances")&&C(u,y),56662&e[0]){let n;for(A=t[2],n=0;n<A.length;n+=1){const r=Ec(t,A,n);N[n]?(N[n].p(r,e),lt(N[n],1)):(N[n]=Kc(r),N[n].c(),lt(N[n],1),N[n].m(g,null))}for(it(),n=A.length;n<N.length;n+=1)T(n);ot()}(!m||1&e[0])&&z(p,"width",t[0]),(!m||128&e[0])&&z(p,"height",t[7])},i(t){if(!m){for(let t=0;t<A.length;t+=1)lt(N[t]);m=!0}},o(t){N=N.filter(Boolean);for(let t=0;t<N.length;t+=1)at(N[t]);m=!1},d(n){n&&$(e),b&&b.d(),_(N,n),t[26](null),t[27](null)}}}const Gc=5;function Zc(t){return"categorical"===t.kind}function Jc(t){return"value_map"in t?t.value_map:{}}function Qc(t){return t&&"bandwidth"in t?t.bandwidth():0}function tu(t,e){var n;return e&&null!==(n=e(t))&&void 0!==n?n:0}function eu(t,e,n){let r,i,o,l,a,s,c,u,d,h,f,g,m,v,y,w,b;p(t,Bn,(t=>n(23,y=t))),p(t,Cn,(t=>n(8,w=t))),p(t,jn,(t=>n(24,b=t)));let{pd:x}=e,{features:$}=e;const _={top:10,right:5,bottom:40,left:50};let k,M=0,L=0;H((()=>{const t=new ResizeObserver((t=>{if(1!==t.length)return;const e=t[0];if(e.contentBoxSize){const t=Array.isArray(e.contentBoxSize)?e.contentBoxSize[0]:e.contentBoxSize;n(0,M=t.inlineSize),n(18,L=t.blockSize)}else n(0,M=e.contentRect.width),n(18,L=e.contentRect.height)}));return t.observe(k),()=>t.unobserve(k)}));let S=!1,A=[];const N=new Map,z=R();function T({selection:t}){const e=this.id.split("-",2)[1];if(null===t)N.delete(e);else{const[n,r]=t,i=h[e];if("bandwidth"in i){const t=i.domain().filter((t=>{var e;const o=null!==(e=i(t))&&void 0!==e?e:0,l=o+i.bandwidth();return n<=l&&r>=o}));N.set(e,{kind:"categorical",categories:t})}else{const t=i.invert(n),o=i.invert(r);N.set(e,{kind:"quantitative",left:t,right:o})}}n(5,u=c.filter((t=>Array.from(N).every((([e,n])=>{const r=w[e];if("quantitative"===n.kind&&"quantitative"===r.kind){const r=y[e][t];return r>=n.left&&r<=n.right}if("categorical"===n.kind&&"categorical"===r.kind){const r=y[e][t];return n.categories.includes(r)}return!1}))))),z("filter",u)}let C,B;return t.$$set=t=>{"pd"in t&&n(16,x=t.pd),"features"in t&&n(17,$=t.features)},t.$$.update=()=>{458752&t.$$.dirty[0]&&n(7,r=Math.max(L,$.length*(x.ice.num_clusters*Gc*4+_.top+_.bottom))),65536&t.$$.dirty[0]&&n(21,i=x.ice.clusters[x.ice.num_clusters].cluster_labels),65536&t.$$.dirty[0]&&n(19,o=xn(x.ice.num_clusters)),131328&t.$$.dirty[0]&&n(13,l=$.filter((t=>"categorical"===w[t].kind))),524288&t.$$.dirty[0]&&n(12,a=dr().domain(o).range(An)),131200&t.$$.dirty[0]&&n(4,s=hr().domain($).range([0,r])),16777216&t.$$.dirty[0]&&(c=xn(b)),16777216&t.$$.dirty[0]&&n(5,u=xn(b)),524290&t.$$.dirty[0]&&n(22,d=function(){var t=_r([]),e=fc,n=hc,r=pc;function i(i){var o,l,a=Array.from(t.apply(this,arguments),gc),s=a.length,c=-1;for(const t of i)for(o=0,++c;o<s;++o)(a[o][c]=[0,+r(t,a[o].key,c,i)]).data=t;for(o=0,l=$r(e(a));o<s;++o)a[l[o]].index=o;return n(a,l),a}return i.keys=function(e){return arguments.length?(t="function"==typeof e?e:_r(Array.from(e)),i):t},i.value=function(t){return arguments.length?(r="function"==typeof t?t:_r(+t),i):r},i.order=function(t){return arguments.length?(e=null==t?fc:"function"==typeof t?t:_r(Array.from(t)),i):e},i.offset=function(t){return arguments.length?(n=null==t?hc:t,i):n},i}().keys(o).value(((t,e)=>{var n;return null!==(n=t[1].get(e))&&void 0!==n?n:0})).offset(S?mc:hc).order(vc)),131329&t.$$.dirty[0]&&n(6,h=Object.fromEntries($.map((t=>{const e=w[t];return[t,"quantitative"===e.kind?en().domain([e.values[0],e.values[e.values.length-1]]).range([_.left,M-_.right]):hr().domain(e.values).range([_.left,M-_.right])]})))),14811424&t.$$.dirty[0]&&n(2,A=$.map((t=>{if("categorical"===w[t].kind){const e=bn(u,(t=>t.length),(e=>y[t][e]),(t=>i[t]));return{feature:t,kind:"categorical",data:d(Array.from(e))}}{const e=bn(u,(e=>{var n,r,i,o,l;const a=e.map((e=>y[t][e])).sort(ve);let s=[];if(a.length>1){const t=function(t,e,n){var r,i;return r=zc.gaussian,i=Tc.nrd(t),function(e){var n=0,o=0;for(n=0;n<t.length;n++)o+=r((e-t[n])/i);return o/i/t.length}}(a),e=Oe(a[0],a[a.length-1],20);e[0]!==a[0]&&e.unshift(a[0]),e[e.length-1]!==a[a.length-1]&&e.push(a[a.length-1]),s=e.map((e=>({x:e,density:t(e)})))}const c=null!==(n=uc(a,.5))&&void 0!==n?n:0,u=null!==(r=uc(a,.25))&&void 0!==r?r:0,d=null!==(i=uc(a,.75))&&void 0!==i?i:0,h=d-u,f=u-1.5*h,p=d+1.5*h;return{low:null!==(o=dc(a,(t=>t>=f?t:Number.POSITIVE_INFINITY)))&&void 0!==o?o:0,q1:u,median:c,q3:d,high:null!==(l=cc(a,(t=>t<=p?t:Number.NEGATIVE_INFINITY)))&&void 0!==l?l:0,densities:s}}),(t=>i[t]));return{feature:t,kind:"quantitative",data:Array.from(e,(([t,e])=>({cluster:t,box:e})))}}}))),4&t.$$.dirty[0]&&n(20,f=Math.max(...A.filter(Zc).map((t=>t.data)).flat(3))),1048594&t.$$.dirty[0]&&n(11,g=en().domain([0,S?1:f]).range([s.bandwidth()-_.bottom,_.top])),524304&t.$$.dirty[0]&&n(10,m=hr().domain(o).range([_.top,s.bandwidth()-_.bottom]).paddingInner(.1).paddingOuter(.5)),17&t.$$.dirty[0]&&(v=gs().extent([[_.left,-5+s.bandwidth()-_.bottom],[M-_.right,5+s.bandwidth()-_.bottom]]).on("start brush end",T)),131080&t.$$.dirty[0]&&C&&$&&async function(){await(K(),X),B=wl(C).selectAll(".x-axis"),B.call(v),B.call(v.clear)}()},[M,S,A,C,s,u,h,r,w,k,m,g,a,l,_,function(t,e){var n;const r=en().domain([0,null!==(n=cc(e,(t=>t.density)))&&void 0!==n?n:0]).range([0,m.bandwidth()/2]),i=function(t,e,n){var r=null,i=_r(!0),o=null,l=Mr,a=null;function s(s){var c,u,d,h,f,p=(s=$r(s)).length,g=!1,m=new Array(p),v=new Array(p);for(null==o&&(a=l(f=xr())),c=0;c<=p;++c){if(!(c<p&&i(h=s[c],c,s))===g)if(g=!g)u=c,a.areaStart(),a.lineStart();else{for(a.lineEnd(),a.lineStart(),d=c-1;d>=u;--d)a.point(m[d],v[d]);a.lineEnd(),a.areaEnd()}g&&(m[c]=+t(h,c,s),v[c]=+e(h,c,s),a.point(r?+r(h,c,s):m[c],n?+n(h,c,s):v[c]))}if(f)return a=null,f+""||null}function c(){return Ar().defined(i).curve(l).context(o)}return t="function"==typeof t?t:void 0===t?Lr:_r(+t),e="function"==typeof e?e:_r(void 0===e?0:+e),n="function"==typeof n?n:void 0===n?Sr:_r(+n),s.x=function(e){return arguments.length?(t="function"==typeof e?e:_r(+e),r=null,s):t},s.x0=function(e){return arguments.length?(t="function"==typeof e?e:_r(+e),s):t},s.x1=function(t){return arguments.length?(r=null==t?null:"function"==typeof t?t:_r(+t),s):r},s.y=function(t){return arguments.length?(e="function"==typeof t?t:_r(+t),n=null,s):e},s.y0=function(t){return arguments.length?(e="function"==typeof t?t:_r(+t),s):e},s.y1=function(t){return arguments.length?(n=null==t?null:"function"==typeof t?t:_r(+t),s):n},s.lineX0=s.lineY0=function(){return c().x(t).y(e)},s.lineY1=function(){return c().x(t).y(n)},s.lineX1=function(){return c().x(r).y(e)},s.defined=function(t){return arguments.length?(i="function"==typeof t?t:_r(!!t),s):i},s.curve=function(t){return arguments.length?(l=t,null!=o&&(a=l(o)),s):l},s.context=function(t){return arguments.length?(null==t?o=a=null:a=l(o=t),s):o},s}().x((e=>{var n;return null!==(n=t(e.x))&&void 0!==n?n:0})).y0((t=>{const e=r(t.density);return e>.01?-e:0})).y1((t=>{const e=r(t.density);return e>.01?e:0}));return i(e)},x,$,L,o,f,i,d,y,b,function(){S=this.checked,n(1,S)},function(t){V[t?"unshift":"push"]((()=>{C=t,n(3,C)}))},function(t){V[t?"unshift":"push"]((()=>{k=t,n(9,k)}))}]}const nu=class extends mt{constructor(t){super(),gt(this,t,eu,Uc,d,{pd:16,features:17},Pc,[-1,-1])}};function ru(t){b(t,"svelte-18fd23d",".zoomed-pdp-container.svelte-18fd23d.svelte-18fd23d.svelte-18fd23d{width:100%;height:100%;display:flex;flex-direction:column}.zoomed-pdp-header.svelte-18fd23d.svelte-18fd23d.svelte-18fd23d{height:2em;display:flex;align-items:center;background-color:white;gap:1.5em;padding-left:0.5em;padding-right:0.5em;border-bottom:1px solid var(--gray-1)}.feature-selects.svelte-18fd23d.svelte-18fd23d.svelte-18fd23d{flex:0 1 auto;min-width:0;display:flex;align-items:center;gap:0.5em}.feature-selects.svelte-18fd23d label.svelte-18fd23d.svelte-18fd23d{flex:0 1 auto;display:flex;align-items:center;gap:0.25em;min-width:0}.feature-selects.svelte-18fd23d label span.svelte-18fd23d.svelte-18fd23d{flex:0 0 auto}.feature-selects.svelte-18fd23d label.svelte-18fd23d select.svelte-18fd23d{flex:0 1 auto;min-width:0;text-overflow:ellipsis}.zoomed-pdp-content.svelte-18fd23d.svelte-18fd23d.svelte-18fd23d{flex:1;padding:0.5em;min-height:0px}.one-way-pdp-grid.svelte-18fd23d.svelte-18fd23d.svelte-18fd23d{display:flex;width:100%;height:100%}.two-way-pdp-grid.svelte-18fd23d.svelte-18fd23d.svelte-18fd23d{display:grid;width:100%;height:100%}.label-and-input.svelte-18fd23d.svelte-18fd23d.svelte-18fd23d{flex:0 0 auto;display:flex;align-items:center;gap:0.25em}.showOneWay-true-color-both.svelte-18fd23d.svelte-18fd23d.svelte-18fd23d{grid-template-rows:1fr 2fr;grid-template-columns:1fr 1fr;grid-template-areas:'one-way-left one-way-right'\n      'two-way-interaction two-way-pdp'}.showOneWay-true-color-interactions.svelte-18fd23d.svelte-18fd23d.svelte-18fd23d{grid-template-rows:1fr 2fr;grid-template-columns:1fr 1fr;grid-template-areas:'one-way-left one-way-right'\n      'two-way-interaction two-way-interaction'}.showOneWay-true-color-predictions.svelte-18fd23d.svelte-18fd23d.svelte-18fd23d{grid-template-rows:1fr 2fr;grid-template-columns:1fr 1fr;grid-template-areas:'one-way-left one-way-right'\n      'two-way-pdp two-way-pdp'}.showOneWay-false-color-both.svelte-18fd23d.svelte-18fd23d.svelte-18fd23d{grid-template-rows:1fr 1fr;grid-template-columns:1fr 1fr;grid-template-areas:'two-way-interaction two-way-pdp'\n      'two-way-interaction two-way-pdp'}.showOneWay-false-color-interactions.svelte-18fd23d.svelte-18fd23d.svelte-18fd23d{grid-template-rows:1fr 1fr;grid-template-columns:1fr 1fr;grid-template-areas:'two-way-interaction two-way-interaction'\n      'two-way-interaction two-way-interaction'}.showOneWay-false-color-predictions.svelte-18fd23d.svelte-18fd23d.svelte-18fd23d{grid-template-rows:1fr 1fr;grid-template-columns:1fr 1fr;grid-template-areas:'two-way-pdp two-way-pdp'\n      'two-way-pdp two-way-pdp'}.detailed-plot-message-container.svelte-18fd23d.svelte-18fd23d.svelte-18fd23d{height:100%;width:100%;align-items:center;justify-content:center;display:flex}.detailed-plot-message-content.svelte-18fd23d.svelte-18fd23d.svelte-18fd23d{width:40em;display:flex;flex-direction:column;justify-content:center;gap:1em}.detailed-plot-message-content.svelte-18fd23d>button.svelte-18fd23d.svelte-18fd23d{margin:auto}.pdpilot-no-clusters-message.svelte-18fd23d.svelte-18fd23d.svelte-18fd23d{flex:1;text-align:center;align-self:center}")}function iu(t,e,n){const r=t.slice();return r[39]=e[n].value,r[40]=e[n].title,r}function ou(t,e,n){const r=t.slice();return r[43]=e[n],r}function lu(t,e,n){const r=t.slice();return r[43]=e[n],r}function au(t){let e,n,r,i=t[43]+"";return{c(){e=k("option"),n=L(i),e.__value=r=t[43],e.value=e.__value},m(t,r){x(t,e,r),w(e,n)},p(t,o){131072&o[0]&&i!==(i=t[43]+"")&&C(n,i),131072&o[0]&&r!==(r=t[43])&&(e.__value=r,e.value=e.__value)},d(t){t&&$(e)}}}function su(t){let e,n,r,i=t[43]+"";return{c(){e=k("option"),n=L(i),e.__value=r=t[43],e.value=e.__value},m(t,r){x(t,e,r),w(e,n)},p(t,o){131072&o[0]&&i!==(i=t[43]+"")&&C(n,i),131072&o[0]&&r!==(r=t[43])&&(e.__value=r,e.value=e.__value)},d(t){t&&$(e)}}}function cu(t){let e,n,r,i,o,l,a,s,u,d,h,f,p=1===t[0].num_features?"Distribution":"Distributions";function g(t,e){return 2===t[0].num_features?du:uu}let m=g(t),v=m(t);return{c(){e=k("label"),n=k("input"),r=S(),i=L(p),o=S(),l=k("label"),a=k("input"),s=L("Scale\n        locally"),u=S(),v.c(),d=A(),z(n,"type","checkbox"),z(e,"class","label-and-input svelte-18fd23d"),z(a,"type","checkbox"),z(l,"class","label-and-input svelte-18fd23d")},m(c,p){x(c,e,p),w(e,n),n.checked=t[18],w(e,r),w(e,i),x(c,o,p),x(c,l,p),w(l,a),a.checked=t[19],w(l,s),x(c,u,p),v.m(c,p),x(c,d,p),h||(f=[N(n,"change",t[30]),N(a,"change",t[31])],h=!0)},p(t,e){262144&e[0]&&(n.checked=t[18]),1&e[0]&&p!==(p=1===t[0].num_features?"Distribution":"Distributions")&&C(i,p),524288&e[0]&&(a.checked=t[19]),m===(m=g(t))&&v?v.p(t,e):(v.d(1),v=m(t),v&&(v.c(),v.m(d.parentNode,d)))},d(t){t&&$(e),t&&$(o),t&&$(l),t&&$(u),v.d(t),t&&$(d),h=!1,c(f)}}}function uu(t){let e,n,r,i,o,l,a,s=t[21],c=[];for(let e=0;e<s.length;e+=1)c[e]=hu(iu(t,s,e));let u="cluster-lines"===t[4]&&fu(t);return{c(){e=k("label"),n=L("Plot\n          "),r=k("select");for(let t=0;t<c.length;t+=1)c[t].c();i=S(),u&&u.c(),o=A(),z(r,"class","svelte-18fd23d"),void 0===t[4]&&U((()=>t[34].call(r))),z(e,"class","label-and-input svelte-18fd23d")},m(s,d){x(s,e,d),w(e,n),w(e,r);for(let t=0;t<c.length;t+=1)c[t].m(r,null);q(r,t[4]),x(s,i,d),u&&u.m(s,d),x(s,o,d),l||(a=N(r,"change",t[34]),l=!0)},p(t,e){if(2097152&e[0]){let n;for(s=t[21],n=0;n<s.length;n+=1){const i=iu(t,s,n);c[n]?c[n].p(i,e):(c[n]=hu(i),c[n].c(),c[n].m(r,null))}for(;n<c.length;n+=1)c[n].d(1);c.length=s.length}2097168&e[0]&&q(r,t[4]),"cluster-lines"===t[4]?u?u.p(t,e):(u=fu(t),u.c(),u.m(o.parentNode,o)):u&&(u.d(1),u=null)},d(t){t&&$(e),_(c,t),t&&$(i),u&&u.d(t),t&&$(o),l=!1,a()}}}function du(t){let e,n,r,i,o,l,a,s,u,d,h,f,p,g;return{c(){e=k("label"),n=k("input"),r=L("One-way plots"),i=S(),o=k("label"),l=L("Color\n          "),a=k("select"),s=k("option"),s.textContent="both",u=k("option"),u.textContent="interactions",d=k("option"),d.textContent="predictions",h=S(),f=k("button"),f.textContent="Flip",z(n,"type","checkbox"),z(e,"class","label-and-input svelte-18fd23d"),s.__value="both",s.value=s.__value,u.__value="interactions",u.value=u.__value,d.__value="predictions",d.value=d.__value,z(a,"class","svelte-18fd23d"),void 0===t[10]&&U((()=>t[33].call(a))),z(o,"class","label-and-input svelte-18fd23d"),z(f,"title","Swap x and y axes")},m(c,m){x(c,e,m),w(e,n),n.checked=t[9],w(e,r),x(c,i,m),x(c,o,m),w(o,l),w(o,a),w(a,s),w(a,u),w(a,d),q(a,t[10]),x(c,h,m),x(c,f,m),p||(g=[N(n,"change",t[32]),N(a,"change",t[33]),N(f,"click",t[23])],p=!0)},p(t,e){512&e[0]&&(n.checked=t[9]),1024&e[0]&&q(a,t[10])},d(t){t&&$(e),t&&$(i),t&&$(o),t&&$(h),t&&$(f),p=!1,c(g)}}}function hu(t){let e,n,r,i=t[40]+"";return{c(){e=k("option"),n=L(i),e.__value=r=t[39],e.value=e.__value},m(t,r){x(t,e,r),w(e,n)},p:l,d(t){t&&$(e)}}}function fu(t){let e,n,r,i,o;return{c(){e=k("label"),n=k("input"),r=L("Describe clusters"),z(n,"type","checkbox"),z(e,"class","label-and-input svelte-18fd23d")},m(l,a){x(l,e,a),w(e,n),n.checked=t[1],w(e,r),i||(o=N(n,"change",t[35]),i=!0)},p(t,e){2&e[0]&&(n.checked=t[1])},d(t){t&&$(e),i=!1,o()}}}function pu(t){let e,n,r,i,o,l=null!==t[7]&&null!==t[8]&&t[9]&&vu(t),a=("both"===t[10]||"interactions"===t[10])&&yu(t),s=("both"===t[10]||"predictions"===t[10])&&wu(t);return{c(){e=k("div"),l&&l.c(),n=S(),a&&a.c(),r=S(),s&&s.c(),z(e,"class",i="two-way-pdp-grid showOneWay-"+(null!==t[7]&&null!==t[8]&&t[9])+"-color-"+t[10]+" svelte-18fd23d")},m(t,i){x(t,e,i),l&&l.m(e,null),w(e,n),a&&a.m(e,null),w(e,r),s&&s.m(e,null),o=!0},p(t,c){null!==t[7]&&null!==t[8]&&t[9]?l?(l.p(t,c),896&c[0]&&lt(l,1)):(l=vu(t),l.c(),lt(l,1),l.m(e,n)):l&&(it(),at(l,1,1,(()=>{l=null})),ot()),"both"===t[10]||"interactions"===t[10]?a?(a.p(t,c),1024&c[0]&&lt(a,1)):(a=yu(t),a.c(),lt(a,1),a.m(e,r)):a&&(it(),at(a,1,1,(()=>{a=null})),ot()),"both"===t[10]||"predictions"===t[10]?s?(s.p(t,c),1024&c[0]&&lt(s,1)):(s=wu(t),s.c(),lt(s,1),s.m(e,null)):s&&(it(),at(s,1,1,(()=>{s=null})),ot()),(!o||1920&c[0]&&i!==(i="two-way-pdp-grid showOneWay-"+(null!==t[7]&&null!==t[8]&&t[9])+"-color-"+t[10]+" svelte-18fd23d"))&&z(e,"class",i)},i(t){o||(lt(l),lt(a),lt(s),o=!0)},o(t){at(l),at(a),at(s),o=!1},d(t){t&&$(e),l&&l.d(),a&&a.d(),s&&s.d()}}}function gu(t){let e,n,r,i;const o=[xu,bu],l=[];function a(t,e){return"cluster-lines"===t[4]&&1===t[0].ice.num_clusters?0:1}return n=a(t),r=l[n]=o[n](t),{c(){e=k("div"),r.c(),z(e,"class","one-way-pdp-grid svelte-18fd23d")},m(t,r){x(t,e,r),l[n].m(e,null),i=!0},p(t,i){let s=n;n=a(t),n===s?l[n].p(t,i):(it(),at(l[s],1,1,(()=>{l[s]=null})),ot(),r=l[n],r?r.p(t,i):(r=l[n]=o[n](t),r.c()),lt(r,1),r.m(e,null))},i(t){i||(lt(r),i=!0)},o(t){at(r),i=!1},d(t){t&&$(e),l[n].d()}}}function mu(t){let e,n;function r(t,e){return""===t[6]&&""===t[5]?ku:_u}let i=r(t),o=i(t);return{c(){e=k("div"),n=k("div"),o.c(),z(n,"class","detailed-plot-message-content svelte-18fd23d"),z(e,"class","detailed-plot-message-container svelte-18fd23d")},m(t,r){x(t,e,r),w(e,n),o.m(n,null)},p(t,e){i===(i=r(t))&&o?o.p(t,e):(o.d(1),o=i(t),o&&(o.c(),o.m(n,null)))},i:l,o:l,d(t){t&&$(e),o.d()}}}function vu(t){let e,n,r,i,o,l;return n=new sc({props:{pd:t[7],width:t[15],height:t[14],scaleLocally:t[19],showMarginalDistribution:t[18],marginTop:t[18]?Lu:10,distributionHeight:t[18]?Lu:0,iceLevel:"lines"}}),o=new sc({props:{pd:t[8],width:t[15],height:t[14],scaleLocally:t[19],showMarginalDistribution:t[18],marginTop:t[18]?Lu:10,distributionHeight:t[18]?Lu:0,iceLevel:"lines"}}),{c(){e=k("div"),ht(n.$$.fragment),r=S(),i=k("div"),ht(o.$$.fragment),j(e,"grid-area","one-way-left"),j(i,"grid-area","one-way-right")},m(t,a){x(t,e,a),ft(n,e,null),x(t,r,a),x(t,i,a),ft(o,i,null),l=!0},p(t,e){const r={};128&e[0]&&(r.pd=t[7]),32768&e[0]&&(r.width=t[15]),16384&e[0]&&(r.height=t[14]),524288&e[0]&&(r.scaleLocally=t[19]),262144&e[0]&&(r.showMarginalDistribution=t[18]),262144&e[0]&&(r.marginTop=t[18]?Lu:10),262144&e[0]&&(r.distributionHeight=t[18]?Lu:0),n.$set(r);const i={};256&e[0]&&(i.pd=t[8]),32768&e[0]&&(i.width=t[15]),16384&e[0]&&(i.height=t[14]),524288&e[0]&&(i.scaleLocally=t[19]),262144&e[0]&&(i.showMarginalDistribution=t[18]),262144&e[0]&&(i.marginTop=t[18]?Lu:10),262144&e[0]&&(i.distributionHeight=t[18]?Lu:0),o.$set(i)},i(t){l||(lt(n.$$.fragment,t),lt(o.$$.fragment,t),l=!0)},o(t){at(n.$$.fragment,t),at(o.$$.fragment,t),l=!1},d(t){t&&$(e),pt(n),t&&$(r),t&&$(i),pt(o)}}}function yu(t){let e,n,r;return n=new sc({props:{pd:t[0],width:"both"===t[10]?t[15]:t[2],height:null!==t[7]&&null!==t[8]&&t[9]?t[13]:t[3],scaleLocally:t[19],showMarginalDistribution:t[18],marginTop:t[18]?Lu:10,marginRight:t[18]?Lu:10,distributionHeight:t[18]?Lu:0,iceLevel:"lines",colorShows:"interactions",showColorLegend:!0}}),{c(){e=k("div"),ht(n.$$.fragment),j(e,"grid-area","two-way-interaction")},m(t,i){x(t,e,i),ft(n,e,null),r=!0},p(t,e){const r={};1&e[0]&&(r.pd=t[0]),33796&e[0]&&(r.width="both"===t[10]?t[15]:t[2]),9096&e[0]&&(r.height=null!==t[7]&&null!==t[8]&&t[9]?t[13]:t[3]),524288&e[0]&&(r.scaleLocally=t[19]),262144&e[0]&&(r.showMarginalDistribution=t[18]),262144&e[0]&&(r.marginTop=t[18]?Lu:10),262144&e[0]&&(r.marginRight=t[18]?Lu:10),262144&e[0]&&(r.distributionHeight=t[18]?Lu:0),n.$set(r)},i(t){r||(lt(n.$$.fragment,t),r=!0)},o(t){at(n.$$.fragment,t),r=!1},d(t){t&&$(e),pt(n)}}}function wu(t){let e,n,r;return n=new sc({props:{pd:t[0],width:"both"===t[10]?t[15]:t[2],height:null!==t[7]&&null!==t[8]&&t[9]?t[13]:t[3],scaleLocally:t[19],showMarginalDistribution:t[18],marginTop:t[18]?Lu:10,marginRight:t[18]?Lu:10,distributionHeight:t[18]?Lu:0,iceLevel:t[4],showColorLegend:!0}}),{c(){e=k("div"),ht(n.$$.fragment),j(e,"grid-area","two-way-pdp")},m(t,i){x(t,e,i),ft(n,e,null),r=!0},p(t,e){const r={};1&e[0]&&(r.pd=t[0]),33796&e[0]&&(r.width="both"===t[10]?t[15]:t[2]),9096&e[0]&&(r.height=null!==t[7]&&null!==t[8]&&t[9]?t[13]:t[3]),524288&e[0]&&(r.scaleLocally=t[19]),262144&e[0]&&(r.showMarginalDistribution=t[18]),262144&e[0]&&(r.marginTop=t[18]?Lu:10),262144&e[0]&&(r.marginRight=t[18]?Lu:10),262144&e[0]&&(r.distributionHeight=t[18]?Lu:0),16&e[0]&&(r.iceLevel=t[4]),n.$set(r)},i(t){r||(lt(n.$$.fragment,t),r=!0)},o(t){at(n.$$.fragment,t),r=!1},d(t){t&&$(e),pt(n)}}}function bu(t){let e,n,r,i,o;n=new sc({props:{pd:t[0],width:t[1]?t[15]:t[2],height:t[3],scaleLocally:t[19],showMarginalDistribution:t[18],marginTop:t[18]?Lu:10,distributionHeight:t[18]?Lu:0,iceLevel:t[4],indices:t[12],allowBrushing:!0,showColorLegend:!1,showTitle:t[1]&&"cluster-lines"===t[4]}});let l=t[1]&&$u(t);return{c(){e=k("div"),ht(n.$$.fragment),r=S(),l&&l.c(),i=A(),j(e,"flex","1")},m(t,a){x(t,e,a),ft(n,e,null),x(t,r,a),l&&l.m(t,a),x(t,i,a),o=!0},p(t,e){const r={};1&e[0]&&(r.pd=t[0]),32774&e[0]&&(r.width=t[1]?t[15]:t[2]),8&e[0]&&(r.height=t[3]),524288&e[0]&&(r.scaleLocally=t[19]),262144&e[0]&&(r.showMarginalDistribution=t[18]),262144&e[0]&&(r.marginTop=t[18]?Lu:10),262144&e[0]&&(r.distributionHeight=t[18]?Lu:0),16&e[0]&&(r.iceLevel=t[4]),4096&e[0]&&(r.indices=t[12]),18&e[0]&&(r.showTitle=t[1]&&"cluster-lines"===t[4]),n.$set(r),t[1]?l?(l.p(t,e),2&e[0]&&lt(l,1)):(l=$u(t),l.c(),lt(l,1),l.m(i.parentNode,i)):l&&(it(),at(l,1,1,(()=>{l=null})),ot())},i(t){o||(lt(n.$$.fragment,t),lt(l),o=!0)},o(t){at(n.$$.fragment,t),at(l),o=!1},d(t){t&&$(e),pt(n),t&&$(r),l&&l.d(t),t&&$(i)}}}function xu(t){let e;return{c(){e=k("div"),e.textContent="This feature does not have any distinct clusters of ICE lines.",z(e,"class","pdpilot-no-clusters-message svelte-18fd23d")},m(t,n){x(t,e,n)},p:l,i:l,o:l,d(t){t&&$(e)}}}function $u(t){let e,n,r;return n=new nu({props:{pd:t[0],features:t[0].ice.clusters[t[0].ice.num_clusters].interacting_features}}),n.$on("filter",t[22]),{c(){e=k("div"),ht(n.$$.fragment),j(e,"flex","1")},m(t,i){x(t,e,i),ft(n,e,null),r=!0},p(t,e){const r={};1&e[0]&&(r.pd=t[0]),1&e[0]&&(r.features=t[0].ice.clusters[t[0].ice.num_clusters].interacting_features),n.$set(r)},i(t){r||(lt(n.$$.fragment,t),r=!0)},o(t){at(n.$$.fragment,t),r=!1},d(t){t&&$(e),pt(n)}}}function _u(t){let e,n,r,i,o,l,a,s,c,u,d,h,f=2===t[16].length?"Computing...":"Compute Now";return{c(){e=k("div"),n=L("The two-way PDP between "),r=L(t[6]),i=L(" and "),o=L(t[5]),l=L("\n              was not pre-computed, since we did not detect a likely interaction\n              between the two features."),a=S(),s=k("button"),c=L(f),s.disabled=u=2===t[16].length,z(s,"class","svelte-18fd23d")},m(u,f){x(u,e,f),w(e,n),w(e,r),w(e,i),w(e,o),w(e,l),x(u,a,f),x(u,s,f),w(s,c),d||(h=N(s,"click",t[20]),d=!0)},p(t,e){64&e[0]&&C(r,t[6]),32&e[0]&&C(o,t[5]),65536&e[0]&&f!==(f=2===t[16].length?"Computing...":"Compute Now")&&C(c,f),65536&e[0]&&u!==(u=2===t[16].length)&&(s.disabled=u)},d(t){t&&$(e),t&&$(a),t&&$(s),d=!1,h()}}}function ku(t){let e;return{c(){e=k("div"),e.textContent="Select one or two features above.",j(e,"text-align","center")},m(t,n){x(t,e,n)},p:l,d(t){t&&$(e)}}}function Mu(t){let e,n,r,i,o,l,a,s,u,d,h,f,p,g,m,v,y,b,M,L,A,T,C=t[17],B=[];for(let e=0;e<C.length;e+=1)B[e]=au(lu(t,C,e));let j=t[17],P=[];for(let e=0;e<j.length;e+=1)P[e]=su(ou(t,j,e));let E=t[0]&&cu(t);const O=[mu,gu,pu],D=[];function H(t,e){return null===t[0]?0:1===t[0].num_features?1:2}return b=H(t),M=D[b]=O[b](t),{c(){e=k("div"),n=k("div"),r=k("div"),i=k("label"),o=k("span"),o.textContent="Feat. 1",l=S(),a=k("select"),s=k("option");for(let t=0;t<B.length;t+=1)B[t].c();u=S(),d=k("label"),h=k("span"),h.textContent="Feat. 2",f=S(),p=k("select"),g=k("option");for(let t=0;t<P.length;t+=1)P[t].c();m=S(),E&&E.c(),v=S(),y=k("div"),M.c(),z(o,"class","svelte-18fd23d"),s.__value="",s.value=s.__value,z(a,"class","svelte-18fd23d"),void 0===t[6]&&U((()=>t[28].call(a))),z(i,"class","svelte-18fd23d"),z(h,"class","svelte-18fd23d"),g.__value="",g.value=g.__value,z(p,"class","svelte-18fd23d"),void 0===t[5]&&U((()=>t[29].call(p))),z(d,"class","svelte-18fd23d"),z(r,"class","feature-selects svelte-18fd23d"),z(n,"class","zoomed-pdp-header svelte-18fd23d"),z(y,"class","zoomed-pdp-content svelte-18fd23d"),z(e,"class","zoomed-pdp-container svelte-18fd23d")},m(c,$){x(c,e,$),w(e,n),w(n,r),w(r,i),w(i,o),w(i,l),w(i,a),w(a,s);for(let t=0;t<B.length;t+=1)B[t].m(a,null);q(a,t[6]),w(r,u),w(r,d),w(d,h),w(d,f),w(d,p),w(p,g);for(let t=0;t<P.length;t+=1)P[t].m(p,null);q(p,t[5]),w(n,m),E&&E.m(n,null),w(e,v),w(e,y),D[b].m(y,null),t[36](y),L=!0,A||(T=[N(a,"change",t[28]),N(p,"change",t[29])],A=!0)},p(t,e){if(131072&e[0]){let n;for(C=t[17],n=0;n<C.length;n+=1){const r=lu(t,C,n);B[n]?B[n].p(r,e):(B[n]=au(r),B[n].c(),B[n].m(a,null))}for(;n<B.length;n+=1)B[n].d(1);B.length=C.length}if(131136&e[0]&&q(a,t[6]),131072&e[0]){let n;for(j=t[17],n=0;n<j.length;n+=1){const r=ou(t,j,n);P[n]?P[n].p(r,e):(P[n]=su(r),P[n].c(),P[n].m(p,null))}for(;n<P.length;n+=1)P[n].d(1);P.length=j.length}131104&e[0]&&q(p,t[5]),t[0]?E?E.p(t,e):(E=cu(t),E.c(),E.m(n,null)):E&&(E.d(1),E=null);let r=b;b=H(t),b===r?D[b].p(t,e):(it(),at(D[r],1,1,(()=>{D[r]=null})),ot(),M=D[b],M?M.p(t,e):(M=D[b]=O[b](t),M.c()),lt(M,1),M.m(y,null))},i(t){L||(lt(M),L=!0)},o(t){at(M),L=!1},d(n){n&&$(e),_(B,n),_(P,n),E&&E.d(),D[b].d(),t[36](null),A=!1,c(T)}}}const Lu=50;function Su(t,e,n){let r,i,o,l,a,s,c,u,d,h,f,g;var v,y;p(t,Pn,(t=>n(26,l=t))),p(t,Un,(t=>n(4,a=t))),p(t,Xn,(t=>n(27,s=t))),p(t,Kn,(t=>n(5,c=t))),p(t,Yn,(t=>n(6,u=t))),p(t,Fn,(t=>n(16,d=t))),p(t,Tn,(t=>n(17,h=t))),p(t,Gn,(t=>n(18,f=t))),p(t,Zn,(t=>n(19,g=t)));let w=null,b=null,x=null,$=!1;const _=[{value:"lines",title:"Standard"},{value:"centered-lines",title:"Centered"},{value:"cluster-lines",title:"Clusters"}];let k,M,L,S=!0,A="both";H((()=>{const t=new ResizeObserver((t=>{if(1!==t.length)return;const e=t[0];if(e.contentBoxSize){const t=Array.isArray(e.contentBoxSize)?e.contentBoxSize[0]:e.contentBoxSize;n(2,M=t.inlineSize),n(3,L=t.blockSize)}else n(2,M=e.contentRect.width),n(3,L=e.contentRect.height)}));return t.observe(k),()=>t.unobserve(k)}));let N=null;return t.$$.update=()=>{if(96&t.$$.dirty[0]&&function(){var t,e;u===c&&m(Kn,c="",c),""===u&&""!==c&&(m(Yn,u=c,u),m(Kn,c="",c)),n(0,w=""===c?null!==(t=s.get(u))&&void 0!==t?t:null:null!==(e=l.find((t=>t.x_feature===u&&t.y_feature===c||t.x_feature===c&&t.y_feature===u)))&&void 0!==e?e:null)}(),67108864&t.$$.dirty[0]&&l&&function(){const t=l.find((t=>t.x_feature===d[0]&&t.y_feature===d[1]||t.x_feature===d[1]&&t.y_feature===d[0]));t&&(2===d.length&&d[0]===u&&d[1]===c&&n(0,w=t),m(Fn,d=[],d))}(),184549377&t.$$.dirty[0]&&w&&2===w.num_features){let t=w.x_feature<w.y_feature?w.x_feature:w.y_feature,e=w.x_feature>w.y_feature?w.x_feature:w.y_feature;n(7,b=null!==n(24,v=s.get(t))&&void 0!==v?v:null),n(8,x=null!==n(25,y=s.get(e))&&void 0!==y?y:null)}16&t.$$.dirty[0]&&"cluster-lines"!==a&&n(1,$=!1),4&t.$$.dirty[0]&&n(15,r=M/2),8&t.$$.dirty[0]&&n(14,i=L/3),8&t.$$.dirty[0]&&n(13,o=2*L/3),2&t.$$.dirty[0]&&($||n(12,N=null))},[w,$,M,L,a,c,u,b,x,S,A,k,N,o,i,r,d,h,f,g,function(){m(Fn,d=[u,c],d)},_,function(t){n(12,N=t.detail)},function(){w&&1!==w.num_features&&(Object.assign(w,{x_feature:w.y_feature,x_axis:w.y_axis,x_values:w.y_values,y_feature:w.x_feature,y_axis:w.x_axis,y_values:w.x_values}),n(0,w),Pn.set(l))},v,y,l,s,function(){u=P(this),Yn.set(u)},function(){c=P(this),Kn.set(c)},function(){f=this.checked,Gn.set(f)},function(){g=this.checked,Zn.set(g)},function(){S=this.checked,n(9,S)},function(){A=P(this),n(10,A)},function(){a=P(this),Un.set(a),n(21,_)},function(){$=this.checked,n(1,$),n(4,a)},function(t){V[t?"unshift":"push"]((()=>{k=t,n(11,k)}))}]}const Au=class extends mt{constructor(t){super(),gt(this,t,Su,Mu,d,{},ru,[-1,-1])}};function Nu(t){b(t,"svelte-q4ax5s",".controls-features.svelte-q4ax5s.svelte-q4ax5s{display:flex;flex-direction:column;max-height:100%;row-gap:0.25em}ul.svelte-q4ax5s.svelte-q4ax5s{list-style:none}.fs-row.svelte-q4ax5s.svelte-q4ax5s{display:flex;align-items:center;column-gap:0.25em}input.svelte-q4ax5s.svelte-q4ax5s{min-width:0}.fs-row.svelte-q4ax5s label.svelte-q4ax5s{flex:1}.individual-features.svelte-q4ax5s.svelte-q4ax5s{flex:0 1 auto;overflow-y:auto;min-height:0}.hidden.svelte-q4ax5s.svelte-q4ax5s{display:none}")}function zu(t,e,n){const r=t.slice();return r[13]=e[n].feature,r[14]=e[n].hidden,r[15]=e[n].disabled,r}function Tu(t,e){let n,r,i,o,l,a,s,c,u,d,h,f,p,g=e[13]+"";return{key:t,first:null,c(){n=k("li"),r=k("input"),a=S(),s=k("label"),c=L(g),h=S(),z(r,"id",i=e[0]+"-"+e[13]+"-checkbox"),z(r,"type","checkbox"),z(r,"name","features"),r.__value=o=e[13],r.value=r.__value,r.disabled=l=e[15],z(r,"class","svelte-q4ax5s"),e[9][0].push(r),z(s,"class","pdpilot-cutoff svelte-q4ax5s"),z(s,"for",u=e[0]+"-"+e[13]+"-checkbox"),z(s,"title",d=e[13]),z(n,"class","fs-row svelte-q4ax5s"),E(n,"hidden",e[14]),this.first=n},m(t,i){x(t,n,i),w(n,r),r.checked=~e[2].indexOf(r.__value),w(n,a),w(n,s),w(s,c),w(n,h),f||(p=N(r,"change",e[8]),f=!0)},p(t,a){e=t,9&a&&i!==(i=e[0]+"-"+e[13]+"-checkbox")&&z(r,"id",i),8&a&&o!==(o=e[13])&&(r.__value=o,r.value=r.__value),8&a&&l!==(l=e[15])&&(r.disabled=l),4&a&&(r.checked=~e[2].indexOf(r.__value)),8&a&&g!==(g=e[13]+"")&&C(c,g),9&a&&u!==(u=e[0]+"-"+e[13]+"-checkbox")&&z(s,"for",u),8&a&&d!==(d=e[13])&&z(s,"title",d),8&a&&E(n,"hidden",e[14])},d(t){t&&$(n),e[9][0].splice(e[9][0].indexOf(r),1),f=!1,p()}}}function Cu(t){let e,n,r,i,o,a,s,c,u=[],d=new Map,h=t[3];const f=t=>t[13];for(let e=0;e<h.length;e+=1){let n=zu(t,h,e),r=f(n);d.set(r,u[e]=Tu(r,n))}return{c(){e=k("div"),n=k("label"),r=L("Search\n    "),i=k("input"),o=S(),a=k("ul");for(let t=0;t<u.length;t+=1)u[t].c();z(i,"class","svelte-q4ax5s"),z(n,"class","fs-row svelte-q4ax5s"),z(a,"class","individual-features svelte-q4ax5s"),z(e,"class","controls-features svelte-q4ax5s")},m(l,d){x(l,e,d),w(e,n),w(n,r),w(n,i),B(i,t[1]),w(e,o),w(e,a);for(let t=0;t<u.length;t+=1)u[t].m(a,null);s||(c=N(i,"input",t[7]),s=!0)},p(t,[e]){2&e&&i.value!==t[1]&&B(i,t[1]),13&e&&(h=t[3],u=ut(u,e,f,1,t,h,d,a,st,Tu,null,zu))},i:l,o:l,d(t){t&&$(e);for(let t=0;t<u.length;t+=1)u[t].d();s=!1,c()}}}function Bu(t,e,n){let r,i;p(t,Tn,(t=>n(6,i=t)));let{enabledFeatures:o}=e,{idPrefix:l}=e;const a=R();let s="",c=[];function u(t){0===t.length?a("changeNameFilters",i):a("changeNameFilters",t)}const d=[[]];return t.$$set=t=>{"enabledFeatures"in t&&n(4,o=t.enabledFeatures),"idPrefix"in t&&n(0,l=t.idPrefix)},t.$$.update=()=>{16&t.$$.dirty&&function(t){n(2,c=t.length===i.length?[]:t),u(c)}(o),82&t.$$.dirty&&n(3,r=i.map((t=>({feature:t,hidden:!t.toLocaleLowerCase().includes(s.toLocaleLowerCase()),disabled:!o.includes(t)})))),68&t.$$.dirty&&c.length===i.length&&n(2,c=[]),4&t.$$.dirty&&u(c)},[l,s,c,r,o,function(){n(2,c=[])},i,function(){s=this.value,n(1,s)},function(){c=T(d[0],this.__value,this.checked),n(2,c),n(6,i)},d]}const ju=class extends mt{constructor(t){super(),gt(this,t,Bu,Cu,d,{enabledFeatures:4,idPrefix:0,clear:5},Nu)}get clear(){return this.$$.ctx[5]}};function qu(t){b(t,"svelte-zyfurg","ul.svelte-zyfurg.svelte-zyfurg{list-style:none}.label-and-input.svelte-zyfurg.svelte-zyfurg{display:flex;align-items:center;gap:0.25em}ul.svelte-zyfurg ul.svelte-zyfurg{margin-left:1em}")}function Pu(t){let e,n,r,i,o,a,s,u,d,h,f,p,g,m,v,y,b,_,M,L,A,T,C,B,j,q,P,E;return{c(){e=k("div"),n=k("ul"),r=k("li"),i=k("label"),o=k("input"),s=k("span"),s.textContent="Ordered",u=S(),d=k("ul"),h=k("li"),f=k("label"),p=k("input"),g=k("span"),g.textContent="Increasing",m=S(),v=k("label"),y=k("input"),b=k("span"),b.textContent="Decreasing",_=S(),M=k("label"),L=k("input"),A=k("span"),A.textContent="Mixed",T=S(),C=k("li"),B=k("label"),j=k("input"),q=k("span"),q.textContent="Nominal",z(o,"type","checkbox"),o.indeterminate=a=t[0].ordered.shapes.length>0&&t[0].ordered.shapes.length<t[1].length,z(i,"class","label-and-input svelte-zyfurg"),z(p,"type","checkbox"),p.__value="increasing",p.value=p.__value,t[7][0].push(p),z(f,"class","label-and-input svelte-zyfurg"),z(y,"type","checkbox"),y.__value="decreasing",y.value=y.__value,t[7][0].push(y),z(v,"class","label-and-input svelte-zyfurg"),z(L,"type","checkbox"),L.__value="mixed",L.value=L.__value,t[7][0].push(L),z(M,"class","label-and-input svelte-zyfurg"),z(d,"class","svelte-zyfurg"),z(j,"type","checkbox"),z(B,"class","label-and-input svelte-zyfurg"),z(n,"class","svelte-zyfurg")},m(l,a){x(l,e,a),w(e,n),w(n,r),w(r,i),w(i,o),o.checked=t[0].ordered.checked,w(i,s),w(r,u),w(r,d),w(d,h),w(h,f),w(f,p),p.checked=~t[0].ordered.shapes.indexOf(p.__value),w(f,g),w(h,m),w(h,v),w(v,y),y.checked=~t[0].ordered.shapes.indexOf(y.__value),w(v,b),w(h,_),w(h,M),w(M,L),L.checked=~t[0].ordered.shapes.indexOf(L.__value),w(M,A),w(n,T),w(n,C),w(C,B),w(B,j),j.checked=t[0].nominal.checked,w(B,q),P||(E=[N(o,"change",t[5]),N(o,"change",t[2]),N(p,"change",t[6]),N(p,"change",t[3]),N(y,"change",t[8]),N(y,"change",t[3]),N(L,"change",t[9]),N(L,"change",t[3]),N(j,"change",t[10])],P=!0)},p(t,[e]){1&e&&a!==(a=t[0].ordered.shapes.length>0&&t[0].ordered.shapes.length<t[1].length)&&(o.indeterminate=a),1&e&&(o.checked=t[0].ordered.checked),1&e&&(p.checked=~t[0].ordered.shapes.indexOf(p.__value)),1&e&&(y.checked=~t[0].ordered.shapes.indexOf(y.__value)),1&e&&(L.checked=~t[0].ordered.shapes.indexOf(L.__value)),1&e&&(j.checked=t[0].nominal.checked)},i:l,o:l,d(n){n&&$(e),t[7][0].splice(t[7][0].indexOf(p),1),t[7][0].splice(t[7][0].indexOf(y),1),t[7][0].splice(t[7][0].indexOf(L),1),P=!1,c(E)}}}function Eu(t,e,n){let r=["increasing","decreasing","mixed"];const i={ordered:{checked:!0,shapes:r},nominal:{checked:!0}};let o={ordered:{checked:!1,shapes:[]},nominal:{checked:!1}};const l=R();function a(t){t.nominal.checked||t.ordered.checked||0!==t.ordered.shapes.length?l("changeKindFilters",t):l("changeKindFilters",i)}H((()=>{a(o)}));const s=[[]];return t.$$.update=()=>{1&t.$$.dirty&&o.nominal.checked&&o.ordered.checked&&o.ordered.shapes.length===r.length&&n(0,o={ordered:{checked:!1,shapes:[]},nominal:{checked:!1}}),1&t.$$.dirty&&a(o)},[o,r,function(){o.ordered.checked?n(0,o.ordered.shapes=r,o):n(0,o.ordered.shapes=[],o)},function(){n(0,o.ordered.checked=0!==o.ordered.shapes.length,o)},function(){n(0,o={ordered:{checked:!1,shapes:[]},nominal:{checked:!1}})},function(){o.ordered.checked=this.checked,n(0,o),n(1,r)},function(){o.ordered.shapes=T(s[0],this.__value,this.checked),n(0,o),n(1,r)},s,function(){o.ordered.shapes=T(s[0],this.__value,this.checked),n(0,o),n(1,r)},function(){o.ordered.shapes=T(s[0],this.__value,this.checked),n(0,o),n(1,r)},function(){o.nominal.checked=this.checked,n(0,o),n(1,r)}]}const Ou=class extends mt{constructor(t){super(),gt(this,t,Eu,Pu,d,{clear:4},qu)}get clear(){return this.$$.ctx[4]}};function Du(t){b(t,"svelte-2uqume",".toggle-and-title.svelte-2uqume.svelte-2uqume{display:flex;align-items:center;gap:0.25em}.icon-tabler-chevron-down.svelte-2uqume polyline.svelte-2uqume{transition:transform 150ms}.rotate-polyline.svelte-2uqume.svelte-2uqume{transform-origin:50% 50%;transform:rotate(-90deg)}")}function Hu(t){let e,n,r,i,o,a,s,c,u,d,h,f=`${Ru}px`,p=`${Ru}px`;return{c(){e=k("div"),n=k("button"),r=M("svg"),i=M("path"),o=M("polyline"),s=S(),c=k("div"),u=L(t[1]),z(i,"stroke","none"),z(i,"d","M0 0h24v24H0z"),z(i,"fill","none"),z(o,"points",a="2 12 12 22 22 12"),z(o,"class","svelte-2uqume"),E(o,"rotate-polyline",!t[0]),z(r,"xmlns","http://www.w3.org/2000/svg"),z(r,"class","icon-tabler icon-tabler-chevron-down svelte-2uqume"),z(r,"width",Ru),z(r,"height",Ru),z(r,"viewBox","0 0 24 24"),z(r,"stroke-width","4"),z(r,"stroke","currentColor"),z(r,"fill","none"),z(r,"stroke-linecap","round"),z(r,"stroke-linejoin","round"),j(n,"border","none"),j(n,"width",f),j(n,"height",p),j(n,"padding","0"),z(c,"class","pdpilot-bold"),z(e,"class","toggle-and-title svelte-2uqume")},m(l,a){x(l,e,a),w(e,n),w(n,r),w(r,i),w(r,o),w(e,s),w(e,c),w(c,u),d||(h=N(n,"click",t[2]),d=!0)},p(t,[e]){1&e&&E(o,"rotate-polyline",!t[0]),2&e&&C(u,t[1])},i:l,o:l,d(t){t&&$(e),d=!1,h()}}}const Ru=8;function Iu(t,e,n){let{expanded:r=!1}=e,{title:i}=e;return t.$$set=t=>{"expanded"in t&&n(0,r=t.expanded),"title"in t&&n(1,i=t.title)},[r,i,()=>n(0,r=!r)]}const Vu=class extends mt{constructor(t){super(),gt(this,t,Iu,Hu,d,{expanded:0,title:1},Du)}};function Fu(t){b(t,"svelte-1mkvanr",".controls-container.svelte-1mkvanr.svelte-1mkvanr{height:100%;flex:0 0 200px;min-width:200px;max-width:200px;padding:0.25em;border-right:1px solid var(--gray-1);display:flex;flex-direction:column;gap:0.5em}.feature-selector-wrapper-outer.svelte-1mkvanr.svelte-1mkvanr{flex:0 1 auto;min-height:0;display:flex;flex-direction:column}.feature-selector-wrapper-inner.svelte-1mkvanr.svelte-1mkvanr{flex:1;min-height:0}.filter-header.svelte-1mkvanr+.filter-content.svelte-1mkvanr{margin-top:0.25em}.filter-content.svelte-1mkvanr.svelte-1mkvanr{margin-left:0.75em}")}function Wu(t){let e,n,r,i,o,l,a,s,c,u,d,h,f,p,g,m,v,y,b,_,M,L,A;function T(e){t[11](e)}let C={title:"Type"};function B(e){t[13](e)}void 0!==t[2]&&(C.expanded=t[2]),s=new Vu({props:C}),V.push((()=>dt(s,"expanded",T,t[2]))),h=new Ou({props:{}}),t[12](h),h.$on("changeKindFilters",t[5]);let q={title:"Name"};void 0!==t[3]&&(q.expanded=t[3]),m=new Vu({props:q}),V.push((()=>dt(m,"expanded",B,t[3])));let P={enabledFeatures:t[4],idPrefix:"pdpilot-one"};return _=new ju({props:P}),t[14](_),_.$on("changeNameFilters",t[6]),{c(){e=k("div"),n=k("div"),n.textContent="Feature Filters",r=S(),i=k("button"),i.textContent="Clear Filters",o=S(),l=k("div"),a=k("div"),ht(s.$$.fragment),u=S(),d=k("div"),ht(h.$$.fragment),f=S(),p=k("div"),g=k("div"),ht(m.$$.fragment),y=S(),b=k("div"),ht(_.$$.fragment),z(n,"class","pdpilot-bold"),j(i,"align-self","start"),z(a,"class","filter-header svelte-1mkvanr"),z(d,"class","filter-content svelte-1mkvanr"),E(d,"pdp-hide",!t[2]),z(g,"class","filter-header svelte-1mkvanr"),z(b,"class","filter-content feature-selector-wrapper-inner svelte-1mkvanr"),E(b,"pdp-hide",!t[3]),z(p,"class","filter-container feature-selector-wrapper-outer svelte-1mkvanr"),z(e,"class","controls-container svelte-1mkvanr")},m(c,v){x(c,e,v),w(e,n),w(e,r),w(e,i),w(e,o),w(e,l),w(l,a),ft(s,a,null),w(l,u),w(l,d),ft(h,d,null),w(e,f),w(e,p),w(p,g),ft(m,g,null),w(p,y),w(p,b),ft(_,b,null),M=!0,L||(A=N(i,"click",t[7]),L=!0)},p(t,[e]){const n={};!c&&4&e&&(c=!0,n.expanded=t[2],G((()=>c=!1))),s.$set(n),h.$set({}),(!M||4&e)&&E(d,"pdp-hide",!t[2]);const r={};!v&&8&e&&(v=!0,r.expanded=t[3],G((()=>v=!1))),m.$set(r);const i={};16&e&&(i.enabledFeatures=t[4]),_.$set(i),(!M||8&e)&&E(b,"pdp-hide",!t[3])},i(t){M||(lt(s.$$.fragment,t),lt(h.$$.fragment,t),lt(m.$$.fragment,t),lt(_.$$.fragment,t),M=!0)},o(t){at(s.$$.fragment,t),at(h.$$.fragment,t),at(m.$$.fragment,t),at(_.$$.fragment,t),M=!1},d(n){n&&$(e),pt(s),t[12](null),pt(h),pt(m),t[14](null),pt(_),L=!1,A()}}}function Xu(t,e,n){let r,i,o;p(t,Xn,(t=>n(9,i=t))),p(t,Tn,(t=>n(10,o=t)));const l=R();let a,s,c,u=!0,d=!0;return t.$$.update=()=>{1792&t.$$.dirty&&n(4,r=o.filter((t=>{const e=i.get(t);return!(!e||!c)&&(e.ordered?c.ordered.shapes.includes(e.shape):c.nominal.checked)})))},[a,s,u,d,r,function(t){n(8,c=t.detail)},function(t){l("changeFilters",t.detail)},function(){a&&a.clear(),s&&s.clear()},c,i,o,function(t){u=t,n(2,u)},function(t){V[t?"unshift":"push"]((()=>{a=t,n(0,a)}))},function(t){d=t,n(3,d)},function(t){V[t?"unshift":"push"]((()=>{s=t,n(1,s)}))}]}const Yu=class extends mt{constructor(t){super(),gt(this,t,Xu,Wu,d,{},Fu)}};function Ku(t){return 0===t.length||1===t[0].num_features}function Uu(t){b(t,"svelte-19snser",".tooltip-container.svelte-19snser{position:relative;display:flex;align-items:center}.tooltip-content.svelte-19snser{position:absolute;padding:5px;border-radius:5px;max-width:30em;border:1px solid black;color:black;background-color:white;z-index:1;pointer-events:none}")}function Gu(t){let e,n,r,i,o,a,s;return{c(){e=M("svg"),n=M("path"),r=M("circle"),i=M("line"),o=M("path"),z(n,"stroke","none"),z(n,"d","M0 0h24v24H0z"),z(r,"cx","12"),z(r,"cy","12"),z(r,"r","9"),z(i,"x1","12"),z(i,"y1","17"),z(i,"x2","12"),z(i,"y2","17.01"),z(o,"d","M12 13.5a1.5 1.5 0 0 1 1 -1.5a2.6 2.6 0 1 0 -3 -4"),z(e,"xmlns","http://www.w3.org/2000/svg"),z(e,"class","pdpilot-icon icon-tabler icon-tabler-help"),z(e,"width","24"),z(e,"height","24"),z(e,"viewBox","0 0 24 24"),z(e,"stroke-width","2"),z(e,"stroke","currentColor"),z(e,"fill","none"),z(e,"stroke-linecap","round"),z(e,"stroke-linejoin","round")},m(l,c){x(l,e,c),w(e,n),w(e,r),w(e,i),w(e,o),a||(s=[N(e,"mouseenter",t[15]),N(e,"mouseleave",t[16])],a=!0)},p:l,d(t){t&&$(e),a=!1,c(s)}}}function Zu(t){let e,n,r,i,o,a,s;return{c(){e=M("svg"),n=M("path"),r=M("circle"),i=M("line"),o=M("line"),z(n,"stroke","none"),z(n,"d","M0 0h24v24H0z"),z(n,"fill","none"),z(r,"cx","12"),z(r,"cy","12"),z(r,"r","9"),z(i,"x1","12"),z(i,"y1","8"),z(i,"x2","12"),z(i,"y2","12"),z(o,"x1","12"),z(o,"y1","16"),z(o,"x2","12.01"),z(o,"y2","16"),z(e,"xmlns","http://www.w3.org/2000/svg"),z(e,"class","pdpilot-icon icon-tabler icon-tabler-alert-circle"),z(e,"width","24"),z(e,"height","24"),z(e,"viewBox","0 0 24 24"),z(e,"stroke-width","2"),z(e,"stroke","currentColor"),z(e,"fill","none"),z(e,"stroke-linecap","round"),z(e,"stroke-linejoin","round")},m(l,c){x(l,e,c),w(e,n),w(e,r),w(e,i),w(e,o),a||(s=[N(e,"mouseenter",t[13]),N(e,"mouseleave",t[14])],a=!0)},p:l,d(t){t&&$(e),a=!1,c(s)}}}function Ju(t){let e,n,r=`${t[5]}\n      ${t[6]}\n      ${t[7]}\n      ${t[8]}`;const i=t[12].default,o=function(t,e,n,r){if(t){const r=g(t,e,n,null);return t[0](r)}}(i,t,t[11]);return{c(){e=k("div"),o&&o.c(),z(e,"class","tooltip-content pdpilot-small svelte-19snser"),j(e,"top",t[1]),j(e,"right",t[3]),j(e,"bottom",t[4]),j(e,"left",t[2]),j(e,"margin",r),j(e,"width",t[9])},m(t,r){x(t,e,r),o&&o.m(e,null),n=!0},p(t,l){o&&o.p&&(!n||2048&l)&&function(t,e,n,r,i,o){if(i){const l=g(e,n,r,o);t.p(l,i)}}(o,i,t,t[11],n?function(t,e,n,r){if(t[2]&&r){const i=t[2](r(n));if(void 0===e.dirty)return i;if("object"==typeof i){const t=[],n=Math.max(e.dirty.length,i.length);for(let r=0;r<n;r+=1)t[r]=e.dirty[r]|i[r];return t}return e.dirty|i}return e.dirty}(i,t[11],l,null):function(t){if(t.ctx.length>32){const e=[],n=t.ctx.length/32;for(let t=0;t<n;t++)e[t]=-1;return e}return-1}(t[11]),null),2&l&&j(e,"top",t[1]),8&l&&j(e,"right",t[3]),16&l&&j(e,"bottom",t[4]),4&l&&j(e,"left",t[2]),480&l&&r!==(r=`${t[5]}\n      ${t[6]}\n      ${t[7]}\n      ${t[8]}`)&&j(e,"margin",r),512&l&&j(e,"width",t[9])},i(t){n||(lt(o,t),n=!0)},o(t){at(o,t),n=!1},d(t){t&&$(e),o&&o.d(t)}}}function Qu(t){let e,n,r;function i(t,e){return"alert"===t[0]?Zu:Gu}let o=i(t),l=o(t),a=t[10]&&Ju(t);return{c(){e=k("div"),l.c(),n=S(),a&&a.c(),z(e,"class","tooltip-container svelte-19snser")},m(t,i){x(t,e,i),l.m(e,null),w(e,n),a&&a.m(e,null),r=!0},p(t,[r]){o===(o=i(t))&&l?l.p(t,r):(l.d(1),l=o(t),l&&(l.c(),l.m(e,n))),t[10]?a?(a.p(t,r),1024&r&&lt(a,1)):(a=Ju(t),a.c(),lt(a,1),a.m(e,null)):a&&(it(),at(a,1,1,(()=>{a=null})),ot())},i(t){r||(lt(a),r=!0)},o(t){at(a),r=!1},d(t){t&&$(e),l.d(),a&&a.d()}}}function td(t,e,n){let{$$slots:r={},$$scope:i}=e,{kind:o="help"}=e,{top:l="auto"}=e,{left:a="auto"}=e,{right:s="auto"}=e,{bottom:c="auto"}=e,{marginTop:u="0"}=e,{marginRight:d="0"}=e,{marginBottom:h="0"}=e,{marginLeft:f="0"}=e,{width:p="30em"}=e,g=!1;return t.$$set=t=>{"kind"in t&&n(0,o=t.kind),"top"in t&&n(1,l=t.top),"left"in t&&n(2,a=t.left),"right"in t&&n(3,s=t.right),"bottom"in t&&n(4,c=t.bottom),"marginTop"in t&&n(5,u=t.marginTop),"marginRight"in t&&n(6,d=t.marginRight),"marginBottom"in t&&n(7,h=t.marginBottom),"marginLeft"in t&&n(8,f=t.marginLeft),"width"in t&&n(9,p=t.width),"$$scope"in t&&n(11,i=t.$$scope)},[o,l,a,s,c,u,d,h,f,p,g,i,r,()=>n(10,g=!0),()=>n(10,g=!1),()=>n(10,g=!0),()=>n(10,g=!1)]}const ed=class extends mt{constructor(t){super(),gt(this,t,td,Qu,d,{kind:0,top:1,left:2,right:3,bottom:4,marginTop:5,marginRight:6,marginBottom:7,marginLeft:8,width:9},Uu)}};function nd(t){b(t,"svelte-1tyx1jr",".group-container.svelte-1tyx1jr.svelte-1tyx1jr{height:100%;width:100%;display:flex;flex-direction:column;min-height:2em}.pdp-grid-container.svelte-1tyx1jr.svelte-1tyx1jr{flex:1;min-height:0}.pdpilot-no-plots-container.svelte-1tyx1jr.svelte-1tyx1jr{width:100%;height:100%;display:flex;align-items:center;justify-content:center}.pdpilot-no-plots-message.svelte-1tyx1jr.svelte-1tyx1jr{max-width:28em}.pdp-grid.svelte-1tyx1jr.svelte-1tyx1jr{height:100%;display:grid}.group-header.svelte-1tyx1jr.svelte-1tyx1jr{height:2em;display:flex;align-items:center;gap:1em;border-bottom:1px solid var(--gray-1);padding-left:0.5em;padding-right:0.5em}.two-way-color-container.svelte-1tyx1jr.svelte-1tyx1jr{flex:1;margin-left:auto;display:flex;align-items:center}.two-way-color-legend.svelte-1tyx1jr.svelte-1tyx1jr{flex:1}.page-change.svelte-1tyx1jr.svelte-1tyx1jr{display:flex;align-items:center}.current-page-number.svelte-1tyx1jr.svelte-1tyx1jr{width:2em;text-align:center}.label-and-input.svelte-1tyx1jr.svelte-1tyx1jr{display:flex;align-items:center;gap:0.25em}.pdp-grid-element.svelte-1tyx1jr.svelte-1tyx1jr{position:relative}.pdp-grid-element.svelte-1tyx1jr:hover .expand-pdp-button.svelte-1tyx1jr{display:block}.expand-pdp-button.svelte-1tyx1jr.svelte-1tyx1jr{position:absolute;display:none;bottom:2px;left:2px}.dont-shrink.svelte-1tyx1jr.svelte-1tyx1jr{flex:0 0 auto}.dont-show.svelte-1tyx1jr.svelte-1tyx1jr{display:none}ul.svelte-1tyx1jr.svelte-1tyx1jr{list-style:none}li.svelte-1tyx1jr+li.svelte-1tyx1jr{margin-top:0.5em}")}function rd(t,e,n){const r=t.slice();return r[53]=e[n],r}function id(t,e,n){const r=t.slice();return r[56]=e[n].value,r[57]=e[n].title,r}function od(t,e,n){const r=t.slice();return r[60]=e[n],r}function ld(t){let e,n,r,i=t[60].name+"";return{c(){e=k("option"),n=L(i),e.__value=r=t[60],e.value=e.__value},m(t,r){x(t,e,r),w(e,n)},p(t,o){2&o[0]&&i!==(i=t[60].name+"")&&C(n,i),2&o[0]&&r!==(r=t[60])&&(e.__value=r,e.value=e.__value)},d(t){t&&$(e)}}}function ad(t){let e;return{c(){e=k("ul"),e.innerHTML='<li class="svelte-1tyx1jr"><span class="pdpilot-bold">Interaction:</span> Plots for feature\n                pairs with more interaction are ranked higher.</li> \n              <li class="svelte-1tyx1jr"><span class="pdpilot-bold">Variance:</span> Plots that have more\n                variation in their average predictions are ranked higher.</li>',z(e,"class","svelte-1tyx1jr")},m(t,n){x(t,e,n)},d(t){t&&$(e)}}}function sd(t){let e;return{c(){e=k("ul"),e.innerHTML='<li class="svelte-1tyx1jr"><span class="pdpilot-bold">Variance:</span> Plots that have more\n                variance in their ICE lines are ranked higher.</li> \n              <li class="svelte-1tyx1jr"><span class="pdpilot-bold">Cluster difference:</span> Plots that\n                have ICE clusters farther from the partial dependence line are ranked\n                higher.</li> \n              <li class="svelte-1tyx1jr"><span class="pdpilot-bold">Highlighted similarity:</span> Plots where\n                the highlighted lines are closer together and farther from the partial\n                dependence line are ranked higher.</li> \n              <li class="svelte-1tyx1jr"><span class="pdpilot-bold">Highlighted distribution:</span> Plots\n                for features whose distributions of highlighted instances are more\n                different from the overall distributions are ranked higher.</li>',z(e,"class","svelte-1tyx1jr")},m(t,n){x(t,e,n)},d(t){t&&$(e)}}}function cd(t){let e;function n(t,e){return 1===t[19]?sd:ad}let r=n(t),i=r(t);return{c(){e=k("div"),i.c()},m(t,n){x(t,e,n),i.m(e,null)},p(t,o){r!==(r=n(t))&&(i.d(1),i=r(t),i&&(i.c(),i.m(e,null)))},d(t){t&&$(e),i.d()}}}function ud(t){let e,n,r,i,o,l,a,s;return{c(){e=k("button"),n=M("svg"),r=M("path"),i=M("path"),o=M("path"),z(r,"stroke","none"),z(r,"d","M0 0h24v24H0z"),z(r,"fill","none"),z(i,"d","M20 11a8.1 8.1 0 0 0 -15.5 -2m-.5 -4v4h4"),z(o,"d","M4 13a8.1 8.1 0 0 0 15.5 2m.5 4v-4h-4"),z(n,"xmlns","http://www.w3.org/2000/svg"),z(n,"class","pdpilot-icon icon-tabler icon-tabler-refresh"),z(n,"width","24"),z(n,"height","24"),z(n,"viewBox","0 0 24 24"),z(n,"stroke-width","2"),z(n,"stroke","currentColor"),z(n,"fill","none"),z(n,"stroke-linecap","round"),z(n,"stroke-linejoin","round"),z(e,"title","Update sorting"),e.disabled=l=!t[14]},m(l,c){x(l,e,c),w(e,n),w(n,r),w(n,i),w(n,o),a||(s=N(e,"click",t[34]),a=!0)},p(t,n){16384&n[0]&&l!==(l=!t[14])&&(e.disabled=l)},d(t){t&&$(e),a=!1,s()}}}function dd(t){let e,n,r,i,o,l=t[22],a=[];for(let e=0;e<l.length;e+=1)a[e]=hd(id(t,l,e));return{c(){e=k("label"),n=L("Plot\n        "),r=k("select");for(let t=0;t<a.length;t+=1)a[t].c();void 0===t[7]&&U((()=>t[35].call(r))),z(e,"class","label-and-input dont-shrink svelte-1tyx1jr")},m(l,s){x(l,e,s),w(e,n),w(e,r);for(let t=0;t<a.length;t+=1)a[t].m(r,null);q(r,t[7]),i||(o=N(r,"change",t[35]),i=!0)},p(t,e){if(4194304&e[0]){let n;for(l=t[22],n=0;n<l.length;n+=1){const i=id(t,l,n);a[n]?a[n].p(i,e):(a[n]=hd(i),a[n].c(),a[n].m(r,null))}for(;n<a.length;n+=1)a[n].d(1);a.length=l.length}4194432&e[0]&&q(r,t[7])},d(t){t&&$(e),_(a,t),i=!1,o()}}}function hd(t){let e,n,r,i=t[57]+"";return{c(){e=k("option"),n=L(i),e.__value=r=t[56],e.value=e.__value},m(t,r){x(t,e,r),w(e,n)},p:l,d(t){t&&$(e)}}}function fd(t){let e,n,r,i,o;return{c(){e=k("label"),n=k("input"),r=k("span"),r.textContent="Distributions",z(n,"type","checkbox"),z(e,"class","label-and-input svelte-1tyx1jr")},m(l,a){x(l,e,a),w(e,n),n.checked=t[9],w(e,r),i||(o=N(n,"change",t[37]),i=!0)},p(t,e){512&e[0]&&(n.checked=t[9])},d(t){t&&$(e),i=!1,o()}}}function pd(t){let e,n,r,i,o,l,a,s,c,u,d;return s=new ed({props:{kind:"help",right:"0",top:"0",marginRight:"1em",marginTop:"1.5em",width:"30em",$$slots:{default:[vd]},$$scope:{ctx:t}}}),{c(){e=k("div"),n=k("label"),r=L("Color\n            "),i=k("select"),o=k("option"),o.textContent="interactions",l=k("option"),l.textContent="predictions",a=S(),ht(s.$$.fragment),o.__value="interactions",o.value=o.__value,l.__value="predictions",l.value=l.__value,void 0===t[8]&&U((()=>t[38].call(i))),z(n,"class","label-and-input svelte-1tyx1jr"),z(e,"class","label-and-input dont-shrink svelte-1tyx1jr")},m(h,f){x(h,e,f),w(e,n),w(n,r),w(n,i),w(i,o),w(i,l),q(i,t[8]),w(e,a),ft(s,e,null),c=!0,u||(d=N(i,"change",t[38]),u=!0)},p(t,e){256&e[0]&&q(i,t[8]);const n={};1048832&e[0]|2&e[2]&&(n.$$scope={dirty:e,ctx:t}),s.$set(n)},i(t){c||(lt(s.$$.fragment,t),c=!0)},o(t){at(s.$$.fragment,t),c=!1},d(t){t&&$(e),pt(s),u=!1,d()}}}function gd(t){let e;return{c(){e=L("This color scale is for a standard two-way PDP. The color of a\n                cell represents the model's average prediction when setting the\n                instances to have the given values for pair of features.")},m(t,n){x(t,e,n)},p:l,d(t){t&&$(e)}}}function md(t){let e,n,r,i,o;return{c(){e=L("This color scale shows the difference between the value in a\n                two-way PDP and the expected value if there was no interaction\n                between the pair of features. It indicates whether the\n                interaction between the two features makes the model's average\n                prediction for the given values "),n=k("span"),n.textContent="lower",r=L("\n                or\n                "),i=k("span"),i.textContent="higher",o=L(". The units are the same as your target variable."),j(n,"background",t[20].interpolator()(.1)),j(n,"border-radius","4px"),j(n,"padding","0.125em 0.25em"),j(n,"color","white"),j(i,"background",t[20].interpolator()(.9)),j(i,"border-radius","4px"),j(i,"padding","0.125em 0.25em"),j(i,"color","white")},m(t,l){x(t,e,l),x(t,n,l),x(t,r,l),x(t,i,l),x(t,o,l)},p(t,e){1048576&e[0]&&j(n,"background",t[20].interpolator()(.1)),1048576&e[0]&&j(i,"background",t[20].interpolator()(.9))},d(t){t&&$(e),t&&$(n),t&&$(r),t&&$(i),t&&$(o)}}}function vd(t){let e;function n(t,e){return"interactions"===t[8]?md:gd}let r=n(t),i=r(t);return{c(){e=k("div"),i.c()},m(t,n){x(t,e,n),i.m(e,null)},p(t,o){r===(r=n(t))&&i?i.p(t,o):(i.d(1),i=r(t),i&&(i.c(),i.m(e,null)))},d(t){t&&$(e),i.d()}}}function yd(t){let e,n,r=[],i=new Map,o=`repeat(${t[6]}, minmax(0,${t[12]}px))`,l=`repeat(${t[5]}, minmax(0,${t[13]}px))`,a=t[18];const s=t=>t[53].id;for(let e=0;e<a.length;e+=1){let n=rd(t,a,e),o=s(n);i.set(o,r[e]=bd(o,n))}return{c(){e=k("div");for(let t=0;t<r.length;t+=1)r[t].c();z(e,"class","pdp-grid svelte-1tyx1jr"),j(e,"grid-template-columns",o),j(e,"grid-template-rows",l)},m(t,i){x(t,e,i);for(let t=0;t<r.length;t+=1)r[t].m(e,null);n=!0},p(t,n){34419584&n[0]&&(a=t[18],it(),r=ut(r,n,s,1,t,a,i,e,ct,bd,null,rd),ot()),4160&n[0]&&o!==(o=`repeat(${t[6]}, minmax(0,${t[12]}px))`)&&j(e,"grid-template-columns",o),8224&n[0]&&l!==(l=`repeat(${t[5]}, minmax(0,${t[13]}px))`)&&j(e,"grid-template-rows",l)},i(t){if(!n){for(let t=0;t<a.length;t+=1)lt(r[t]);n=!0}},o(t){for(let t=0;t<r.length;t+=1)at(r[t]);n=!1},d(t){t&&$(e);for(let t=0;t<r.length;t+=1)r[t].d()}}}function wd(t){let e,n,r;return{c(){e=k("div"),n=k("div"),r=L(t[2]),z(n,"class","pdpilot-no-plots-message svelte-1tyx1jr"),z(e,"class","pdpilot-no-plots-container svelte-1tyx1jr")},m(t,i){x(t,e,i),w(e,n),w(n,r)},p(t,e){4&e[0]&&C(r,t[2])},i:l,o:l,d(t){t&&$(e)}}}function bd(t,e){let n,r,i,o,l,a,s,c,u=`${e[12]}px`,d=`${e[13]}px`;function h(){return e[40](e[53])}return r=new sc({props:{pd:e[53],width:e[12],height:e[13],scaleLocally:e[16],colorShows:e[8],showMarginalDistribution:e[9],marginTop:11,marginRight:10,distributionHeight:10,showColorLegend:e[16],iceLevel:e[7],allowBrushing:1===e[19],showBrushedBorder:1===e[19],iceLineWidth:.5}}),{key:t,first:null,c(){n=k("div"),ht(r.$$.fragment),i=S(),o=k("button"),o.innerHTML='<svg xmlns="http://www.w3.org/2000/svg" class="pdpilot-icon icon-tabler icon-tabler-arrows-maximize" width="24" height="24" viewBox="0 0 24 24" stroke-width="2" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"></path><path d="M16 4l4 0l0 4m-6 2l6 -6m-12 16l-4 0l0 -4m0 4l6 -6m6 6l4 0l0 -4m-6 -2l6 6m-12 -16l-4 0l0 4m0 -4l6 6"></path></svg>',l=S(),z(o,"class","expand-pdp-button svelte-1tyx1jr"),z(n,"class","pdp-grid-element svelte-1tyx1jr"),j(n,"max-width",u),j(n,"max-height",d),this.first=n},m(t,e){x(t,n,e),ft(r,n,null),w(n,i),w(n,o),w(n,l),a=!0,s||(c=N(o,"click",h),s=!0)},p(t,i){e=t;const o={};262144&i[0]&&(o.pd=e[53]),4096&i[0]&&(o.width=e[12]),8192&i[0]&&(o.height=e[13]),65536&i[0]&&(o.scaleLocally=e[16]),256&i[0]&&(o.colorShows=e[8]),512&i[0]&&(o.showMarginalDistribution=e[9]),65536&i[0]&&(o.showColorLegend=e[16]),128&i[0]&&(o.iceLevel=e[7]),524288&i[0]&&(o.allowBrushing=1===e[19]),524288&i[0]&&(o.showBrushedBorder=1===e[19]),r.$set(o),4096&i[0]&&u!==(u=`${e[12]}px`)&&j(n,"max-width",u),8192&i[0]&&d!==(d=`${e[13]}px`)&&j(n,"max-height",d)},i(t){a||(lt(r.$$.fragment,t),a=!0)},o(t){at(r.$$.fragment,t),a=!1},d(t){t&&$(n),pt(r),s=!1,c()}}}function xd(t){let e,n,r,i,o,l,a,s,u,d,h,f,p,g,m,v,y,b,A,T,B,j,P,O,D,H,R,I,V,F,W,X,Y,K,G,Z,J,Q,tt,et,nt,rt,st,ct,ut,dt,gt,mt=t[1],vt=[];for(let e=0;e<mt.length;e+=1)vt[e]=ld(od(t,mt,e));I=new ed({props:{kind:"help",left:"0",top:"0",marginRight:"1em",marginTop:"1.5em",width:"30em",$$slots:{default:[cd]},$$scope:{ctx:t}}});let yt=1===t[19]&&t[3].forBrushing&&ud(t),wt=1===t[19]&&dd(t),bt=1===t[19]&&fd(t),xt=2===t[19]&&pd(t);et=new Fs({props:{width:t[15],height:$d,color:"interactions"===t[8]?t[20]:t[21],marginLeft:15,marginRight:15}});const $t=[wd,yd],_t=[];function kt(t,e){return 0===t[18].length?0:1}return st=kt(t),ct=_t[st]=$t[st](t),{c(){e=k("div"),n=k("div"),r=k("div"),i=k("button"),o=M("svg"),l=M("path"),a=M("line"),s=M("line"),u=M("line"),h=S(),f=k("div"),p=L(t[4]),g=S(),m=k("button"),v=M("svg"),y=M("path"),b=M("line"),A=M("line"),T=M("line"),j=S(),P=k("div"),O=k("label"),D=L("Sort\n        "),H=k("select");for(let t=0;t<vt.length;t+=1)vt[t].c();R=S(),ht(I.$$.fragment),V=S(),yt&&yt.c(),F=S(),wt&&wt.c(),W=S(),X=k("label"),Y=k("input"),K=k("span"),K.textContent="Scale locally",G=S(),bt&&bt.c(),Z=S(),J=k("div"),xt&&xt.c(),Q=S(),tt=k("div"),ht(et.$$.fragment),nt=S(),rt=k("div"),ct.c(),z(l,"stroke","none"),z(l,"d"," M0 0h24v24H0z"),z(l,"fill","none"),z(a,"x1","5"),z(a,"y1","12"),z(a,"x2","19"),z(a,"y2","12"),z(s,"x1","5"),z(s,"y1","12"),z(s,"x2","11"),z(s,"y2","18"),z(u,"x1","5"),z(u,"y1","12"),z(u,"x2","11"),z(u,"y2","6"),z(o,"xmlns","http://www.w3.org/2000/svg"),z(o,"class","pdpilot-icon icon-tabler icon-tabler-arrow-left"),z(o,"width","24"),z(o,"height","24"),z(o,"viewBox","0 0 24 24"),z(o,"stroke-width","2"),z(o,"stroke","currentColor"),z(o,"fill","none"),z(o,"stroke-linecap","round"),z(o,"stroke-linejoin","round"),i.disabled=d=t[4]<=1,z(i,"title","Previous page"),z(f,"class","current-page-number svelte-1tyx1jr"),z(y,"stroke","none"),z(y,"d","M0 0h24v24H0z"),z(y,"fill","none"),z(b,"x1","5"),z(b,"y1","12"),z(b,"x2","19"),z(b,"y2","12"),z(A,"x1","13"),z(A,"y1","18"),z(A,"x2","19"),z(A,"y2","12"),z(T,"x1","13"),z(T,"y1","6"),z(T,"x2","19"),z(T,"y2","12"),z(v,"xmlns","http://www.w3.org/2000/svg"),z(v,"class","pdpilot-icon icon-tabler icon-tabler-arrow-right"),z(v,"width","24"),z(v,"height","24"),z(v,"viewBox","0 0 24 24"),z(v,"stroke-width","2"),z(v,"stroke","currentColor"),z(v,"fill","none"),z(v,"stroke-linecap","round"),z(v,"stroke-linejoin","round"),m.disabled=B=t[4]>=t[17],z(m,"title","Next page"),z(r,"class","page-change dont-shrink svelte-1tyx1jr"),void 0===t[3]&&U((()=>t[33].call(H))),z(O,"class","label-and-input svelte-1tyx1jr"),z(P,"class","dont-shrink label-and-input svelte-1tyx1jr"),z(Y,"type","checkbox"),z(X,"class","label-and-input dont-shrink svelte-1tyx1jr"),z(tt,"class","two-way-color-legend svelte-1tyx1jr"),E(tt,"dont-show",1===t[19]||t[16]),z(J,"class","two-way-color-container svelte-1tyx1jr"),z(n,"class","group-header svelte-1tyx1jr"),z(rt,"class","pdp-grid-container svelte-1tyx1jr"),z(e,"class","group-container svelte-1tyx1jr")},m(c,d){x(c,e,d),w(e,n),w(n,r),w(r,i),w(i,o),w(o,l),w(o,a),w(o,s),w(o,u),w(r,h),w(r,f),w(f,p),w(r,g),w(r,m),w(m,v),w(v,y),w(v,b),w(v,A),w(v,T),w(n,j),w(n,P),w(P,O),w(O,D),w(O,H);for(let t=0;t<vt.length;t+=1)vt[t].m(H,null);q(H,t[3]),w(P,R),ft(I,P,null),w(n,V),yt&&yt.m(n,null),w(n,F),wt&&wt.m(n,null),w(n,W),w(n,X),w(X,Y),Y.checked=t[16],w(X,K),w(n,G),bt&&bt.m(n,null),w(n,Z),w(n,J),xt&&xt.m(J,null),w(J,Q),w(J,tt),ft(et,tt,null),t[39](tt),w(e,nt),w(e,rt),_t[st].m(rt,null),t[41](rt),ut=!0,dt||(gt=[N(i,"click",t[31]),N(m,"click",t[32]),N(H,"change",t[33]),N(Y,"change",t[36])],dt=!0)},p(t,e){if((!ut||16&e[0]&&d!==(d=t[4]<=1))&&(i.disabled=d),(!ut||16&e[0])&&C(p,t[4]),(!ut||131088&e[0]&&B!==(B=t[4]>=t[17]))&&(m.disabled=B),2&e[0]){let n;for(mt=t[1],n=0;n<mt.length;n+=1){const r=od(t,mt,n);vt[n]?vt[n].p(r,e):(vt[n]=ld(r),vt[n].c(),vt[n].m(H,null))}for(;n<vt.length;n+=1)vt[n].d(1);vt.length=mt.length}10&e[0]&&q(H,t[3]);const r={};524288&e[0]|2&e[2]&&(r.$$scope={dirty:e,ctx:t}),I.$set(r),1===t[19]&&t[3].forBrushing?yt?yt.p(t,e):(yt=ud(t),yt.c(),yt.m(n,F)):yt&&(yt.d(1),yt=null),1===t[19]?wt?wt.p(t,e):(wt=dd(t),wt.c(),wt.m(n,W)):wt&&(wt.d(1),wt=null),65536&e[0]&&(Y.checked=t[16]),1===t[19]?bt?bt.p(t,e):(bt=fd(t),bt.c(),bt.m(n,Z)):bt&&(bt.d(1),bt=null),2===t[19]?xt?(xt.p(t,e),524288&e[0]&&lt(xt,1)):(xt=pd(t),xt.c(),lt(xt,1),xt.m(J,Q)):xt&&(it(),at(xt,1,1,(()=>{xt=null})),ot());const o={};32768&e[0]&&(o.width=t[15]),3145984&e[0]&&(o.color="interactions"===t[8]?t[20]:t[21]),et.$set(o),(!ut||589824&e[0])&&E(tt,"dont-show",1===t[19]||t[16]);let l=st;st=kt(t),st===l?_t[st].p(t,e):(it(),at(_t[l],1,1,(()=>{_t[l]=null})),ot(),ct=_t[st],ct?ct.p(t,e):(ct=_t[st]=$t[st](t),ct.c()),lt(ct,1),ct.m(rt,null))},i(t){ut||(lt(I.$$.fragment,t),lt(xt),lt(et.$$.fragment,t),lt(ct),ut=!0)},o(t){at(I.$$.fragment,t),at(xt),at(et.$$.fragment,t),at(ct),ut=!1},d(n){n&&$(e),_(vt,n),pt(I),yt&&yt.d(),wt&&wt.d(),bt&&bt.d(),xt&&xt.d(),pt(et),t[39](null),_t[st].d(),t[41](null),dt=!1,c(gt)}}}const $d=24;function _d(t,e,n){let r,i,o,l,a,s,c,u,d,h,f,g,v,y,w,b,x,$;p(t,Wn,(t=>n(42,c=t))),p(t,Un,(t=>n(43,u=t))),p(t,Zn,(t=>n(44,d=t))),p(t,Gn,(t=>n(45,h=t))),p(t,Kn,(t=>n(46,f=t))),p(t,Yn,(t=>n(47,g=t))),p(t,Jn,(t=>n(30,v=t))),p(t,Cn,(t=>n(48,y=t))),p(t,tr,(t=>n(49,w=t))),p(t,Vn,(t=>n(50,b=t))),p(t,nr,(t=>n(20,x=t))),p(t,er,(t=>n(21,$=t)));let _,{data:k}=e,{sortingOptions:M}=e,{noPlotsMessage:L}=e;const S=[{value:"lines",title:"Standard"},{value:"centered-lines",title:"Centered"},{value:"cluster-centers",title:"Clusters"}];let A,N,z,T,C,B,j="lines",q="interactions",E=!1;H((()=>{const t=new ResizeObserver((t=>{if(1!==t.length)return;const e=t[0];if(e.contentBoxSize){const t=Array.isArray(e.contentBoxSize)?e.contentBoxSize[0]:e.contentBoxSize;n(27,z=t.inlineSize),n(28,T=t.blockSize)}else n(27,z=e.contentRect.width),n(28,T=e.contentRect.height)}));t.observe(A);const e=new ResizeObserver((t=>{if(1!==t.length)return;const e=t[0];if(e.contentBoxSize){const t=Array.isArray(e.contentBoxSize)?e.contentBoxSize[0]:e.contentBoxSize;n(15,D=t.inlineSize)}else n(15,D=e.contentRect.width)}));return e.observe(N),()=>{t.unobserve(A),e.unobserve(A)}}));let O=!1,D=140,R=M[0];function I(t){n(14,O=!1),n(26,_=R.sort(t,{highlightedIndices:b,highlightedDistributions:w,featureInfo:y})),W(1)}let F=1;function W(t){t<1||t>a||n(4,F=t)}let X=!1;function Y(t){m(Yn,g=t.x_feature,g),m(Kn,f=2===t.num_features?t.y_feature:"",f),m(Gn,h=E,h),m(Zn,d=X,d),1===t.num_features&&m(Un,u="cluster-centers"===j?"cluster-lines":j,u),m(Wn,c="detailed-plot",c)}return t.$$set=t=>{"data"in t&&n(0,k=t.data),"sortingOptions"in t&&n(1,M=t.sortingOptions),"noPlotsMessage"in t&&n(2,L=t.noPlotsMessage)},t.$$.update=()=>{1&t.$$.dirty[0]&&n(19,r=Ku(k)?1:2),1&t.$$.dirty[0]&&n(29,i=Math.min(k.length,12)),536870912&t.$$.dirty[0]&&n(5,[o,l]=function(t){const e=Math.ceil(Math.sqrt(t)),n=Math.ceil(t/e);return 1===r?[e,n]:[n,e]}(i),o,(n(6,l),n(29,i),n(0,k))),134217792&t.$$.dirty[0]&&n(12,C=Math.floor(z/l)),268435488&t.$$.dirty[0]&&n(13,B=Math.floor(T/o)),9&t.$$.dirty[0]&&(R.forBrushing||(n(26,_=R.sort(k)),W(1))),8&t.$$.dirty[0]&&"Highlighted distribution"===R.name&&n(9,E=!0),9&t.$$.dirty[0]&&R.forBrushing&&I(k),1073741824&t.$$.dirty[0]&&v&&n(14,O=!0),536870913&t.$$.dirty[0]&&n(17,a=Math.ceil(k.length/i)),603979792&t.$$.dirty[0]&&n(18,s=_.slice((F-1)*i,F*i))},[k,M,L,R,F,o,l,j,q,E,A,N,C,B,O,D,X,a,s,r,x,$,S,I,W,Y,_,z,T,i,v,()=>W(F-1),()=>W(F+1),function(){R=P(this),n(3,R),n(1,M)},()=>I(k),function(){j=P(this),n(7,j),n(22,S)},function(){X=this.checked,n(16,X)},function(){E=this.checked,n(9,E)},function(){q=P(this),n(8,q)},function(t){V[t?"unshift":"push"]((()=>{N=t,n(11,N)}))},t=>Y(t),function(t){V[t?"unshift":"push"]((()=>{A=t,n(10,A)}))}]}const kd=class extends mt{constructor(t){super(),gt(this,t,_d,xd,d,{data:0,sortingOptions:1,noPlotsMessage:2},nd,[-1,-1,-1])}};function Md(t){return t.length}function Ld(t,e){let n=0,r=0;if(void 0===e)for(let e of t)null!=e&&(e=+e)>=e&&(++n,r+=e);else{let i=-1;for(let o of t)null!=(o=e(o,++i,t))&&(o=+o)>=o&&(++n,r+=o)}if(n)return r/n}const Sd=[{name:"Variance",forBrushing:!1,sort:function(t){return 0!==t.length&&Ku(t)?t.sort(((t,e)=>ye(t.deviation,e.deviation))):t}},{name:"Cluster difference",forBrushing:!1,sort:function(t){return 0!==t.length&&Ku(t)?t.sort(((t,e)=>{var n,r,i,o;return ye(null!==(r=null===(n=t.ice.clusters[t.ice.num_clusters])||void 0===n?void 0:n.cluster_distance)&&void 0!==r?r:-1/0,null!==(o=null===(i=e.ice.clusters[e.ice.num_clusters])||void 0===i?void 0:i.cluster_distance)&&void 0!==o?o:-1/0)})):t}},{name:"Highlighted similarity",forBrushing:!0,sort:function(t,e){if(0===t.length||!Ku(t)||!e||!e.highlightedIndices||e.highlightedIndices.length<=1)return t;const n=e.highlightedIndices,r=Object.fromEntries(t.map((t=>{var e;const r=n.map((e=>t.ice.centered_ice_lines[e])),i=function(t){if(!(i=t.length))return[];for(var e=-1,n=dc(t,Md),r=new Array(n);++e<n;)for(var i,o=-1,l=r[e]=new Array(i);++o<i;)l[o]=t[o][e];return r}(r).map((t=>{var e;return null!==(e=Ld(t))&&void 0!==e?e:0})),o=function(t,e,n){return t.map((t=>{let r=0,i=0;for(let o=0;o<t.length;o++)r+=(t[o]-e[o])**2,i+=(t[o]-n[o])**2;return Math.sqrt(i)/Math.sqrt(r)}))}(r,i,t.ice.centered_pdp);return[t.x_feature,null!==(e=Ld(o))&&void 0!==e?e:0]})));return t.sort(((t,e)=>ye(r[t.x_feature],r[e.x_feature])))}},{name:"Highlighted distribution",forBrushing:!0,sort:function(t,e){if(!(0!==t.length&&Ku(t)&&e&&e.highlightedDistributions&&e.featureInfo))return t;const n=e.highlightedDistributions,r=e.featureInfo,i=Object.fromEntries(t.map((t=>{const e=n.get(t.x_feature);if(!e)return[t.x_feature,0];const i=r[t.x_feature].distribution.percents,o=e.percents;let l=0;for(let t=0;t<i.length;t++)l+=Math.abs(o[t]-i[t]);return[t.x_feature,l]})));return t.sort(((t,e)=>ye(i[t.x_feature],i[e.x_feature])))}}],Ad=[{name:"Interaction",forBrushing:!1,sort:function(t){return 0===t.length||Ku(t)?t:t.sort(((t,e)=>ye(t.H,e.H)))}},{name:"Variance",forBrushing:!1,sort:function(t){return 0===t.length||Ku(t)?t:t.sort(((t,e)=>ye(t.deviation,e.deviation)))}}];function Nd(t){b(t,"svelte-cuqal2",".one-way-grid-container.svelte-cuqal2{height:100%;display:flex}.pdp-grid-wrapper.svelte-cuqal2{flex:1;min-width:0}")}function zd(t){let e,n,r,i,o,l,a;return r=new Yu({}),r.$on("changeFilters",t[1]),l=new kd({props:{data:t[0],sortingOptions:Sd,noPlotsMessage:"No plots to show."}}),{c(){e=k("div"),n=k("div"),ht(r.$$.fragment),i=S(),o=k("div"),ht(l.$$.fragment),z(o,"class","pdp-grid-wrapper svelte-cuqal2"),z(e,"class","one-way-grid-container svelte-cuqal2")},m(t,s){x(t,e,s),w(e,n),ft(r,n,null),w(e,i),w(e,o),ft(l,o,null),a=!0},p(t,[e]){const n={};1&e&&(n.data=t[0]),l.$set(n)},i(t){a||(lt(r.$$.fragment,t),lt(l.$$.fragment,t),a=!0)},o(t){at(r.$$.fragment,t),at(l.$$.fragment,t),a=!1},d(t){t&&$(e),pt(r),pt(l)}}}function Td(t,e,n){let r,i,o;p(t,qn,(t=>n(3,i=t))),p(t,Tn,(t=>n(4,o=t)));let l=o;return t.$$.update=()=>{12&t.$$.dirty&&n(0,r=i.filter((t=>l.includes(t.x_feature))))},[r,function(t){n(2,l=t.detail)},l,i]}const Cd=class extends mt{constructor(t){super(),gt(this,t,Td,zd,d,{},Nd)}};function Bd(t){b(t,"svelte-fnunp4",".controls-container.svelte-fnunp4.svelte-fnunp4{height:100%;flex:0 0 200px;min-width:200px;max-width:200px;padding:0.25em;border-right:1px solid var(--gray-1);display:flex;flex-direction:column;gap:0.5em}.feature-selector-wrapper-outer.svelte-fnunp4.svelte-fnunp4{flex:0 1 auto;min-height:0;display:flex;flex-direction:column}.feature-selector-wrapper-middle.svelte-fnunp4.svelte-fnunp4{flex:1;min-height:0;display:flex;flex-direction:column}.feature-selector-wrapper-inner.svelte-fnunp4.svelte-fnunp4{flex:1;min-height:0}.filter-header.svelte-fnunp4+.filter-content.svelte-fnunp4{margin-top:0.25em}.filter-content.svelte-fnunp4.svelte-fnunp4{margin-left:0.75em}hr.svelte-fnunp4.svelte-fnunp4{margin:0.75em 0;border:0;height:1px;background:var(--gray-2)}.two-way-filter-radio.svelte-fnunp4.svelte-fnunp4{display:flex;flex-direction:column}")}function jd(t){let e,n,r,i,o,l,a,s,u,d,h,f,p,g,m,v,y,b,_,M,A,T,C,B,q,P,O,D,H;function R(e){t[7](e)}let I={title:"Name"};void 0!==t[1]&&(I.expanded=t[1]),s=new Vu({props:I}),V.push((()=>dt(s,"expanded",R,t[1])));let F={enabledFeatures:t[3],idPrefix:"pdpilot-two"};return P=new ju({props:F}),t[11](P),P.$on("changeNameFilters",t[4]),{c(){e=k("div"),n=k("div"),n.textContent="Feature Filters",r=S(),i=k("button"),i.textContent="Clear Filters",o=S(),l=k("div"),a=k("div"),ht(s.$$.fragment),d=S(),h=k("div"),f=k("div"),p=k("div"),p.textContent="Plots must contain",g=S(),m=k("label"),v=k("input"),y=L("\n          1+ selected feature"),b=S(),_=k("label"),M=k("input"),A=L("\n          2 selected features"),T=S(),C=k("hr"),B=S(),q=k("div"),ht(P.$$.fragment),z(n,"class","pdpilot-bold"),j(i,"align-self","start"),z(a,"class","filter-header svelte-fnunp4"),z(v,"type","radio"),z(v,"name","op"),v.__value="or",v.value=v.__value,t[9][0].push(v),z(M,"type","radio"),z(M,"name","op"),M.__value="and",M.value=M.__value,t[9][0].push(M),z(f,"class","two-way-filter-radio svelte-fnunp4"),z(C,"class","svelte-fnunp4"),z(q,"class","feature-selector-wrapper-inner svelte-fnunp4"),z(h,"class","filter-content feature-selector-wrapper-middle svelte-fnunp4"),E(h,"pdp-hide",!t[1]),z(l,"class","filter-container feature-selector-wrapper-outer svelte-fnunp4"),z(e,"class","controls-container svelte-fnunp4")},m(c,u){x(c,e,u),w(e,n),w(e,r),w(e,i),w(e,o),w(e,l),w(l,a),ft(s,a,null),w(l,d),w(l,h),w(h,f),w(f,p),w(f,g),w(f,m),w(m,v),v.checked=v.__value===t[2],w(m,y),w(f,b),w(f,_),w(_,M),M.checked=M.__value===t[2],w(_,A),w(h,T),w(h,C),w(h,B),w(h,q),ft(P,q,null),O=!0,D||(H=[N(i,"click",t[6]),N(v,"change",t[8]),N(v,"change",t[5]),N(M,"change",t[10]),N(M,"change",t[5])],D=!0)},p(t,[e]){const n={};!u&&2&e&&(u=!0,n.expanded=t[1],G((()=>u=!1))),s.$set(n),4&e&&(v.checked=v.__value===t[2]),4&e&&(M.checked=M.__value===t[2]);const r={};8&e&&(r.enabledFeatures=t[3]),P.$set(r),(!O||2&e)&&E(h,"pdp-hide",!t[1])},i(t){O||(lt(s.$$.fragment,t),lt(P.$$.fragment,t),O=!0)},o(t){at(s.$$.fragment,t),at(P.$$.fragment,t),O=!1},d(n){n&&$(e),pt(s),t[9][0].splice(t[9][0].indexOf(v),1),t[9][0].splice(t[9][0].indexOf(M),1),t[11](null),pt(P),D=!1,c(H)}}}function qd(t,e,n){let r;p(t,Tn,(t=>n(3,r=t)));const i=R();let o,l=!0,a="and",s=r;return[o,l,a,r,function(t){i("changeFilters",{features:t.detail,op:a}),s=t.detail},function(){i("changeFilters",{features:s,op:a})},function(){o&&o.clear()},function(t){l=t,n(1,l)},function(){a=this.__value,n(2,a)},[[]],function(){a=this.__value,n(2,a)},function(t){V[t?"unshift":"push"]((()=>{o=t,n(0,o)}))}]}const Pd=class extends mt{constructor(t){super(),gt(this,t,qd,jd,d,{},Bd)}};function Ed(t){b(t,"svelte-1akrxps",".two-way-grid-container.svelte-1akrxps{height:100%;display:flex}.pdp-grid-wrapper.svelte-1akrxps{flex:1;min-width:0}")}function Od(t){let e,n,r,i,o,l,a;return r=new Pd({}),r.$on("changeFilters",t[3]),l=new kd({props:{data:t[2],sortingOptions:Ad,noPlotsMessage:1===t[0].length&&"and"===t[1]?"No plots to show.":"No plots to show. PDPilot only pre-computes two-way PDPs when it detects likely interaction between the pair of features."}}),{c(){e=k("div"),n=k("div"),ht(r.$$.fragment),i=S(),o=k("div"),ht(l.$$.fragment),z(o,"class","pdp-grid-wrapper svelte-1akrxps"),z(e,"class","two-way-grid-container svelte-1akrxps")},m(t,s){x(t,e,s),w(e,n),ft(r,n,null),w(e,i),w(e,o),ft(l,o,null),a=!0},p(t,[e]){const n={};4&e&&(n.data=t[2]),3&e&&(n.noPlotsMessage=1===t[0].length&&"and"===t[1]?"No plots to show.":"No plots to show. PDPilot only pre-computes two-way PDPs when it detects likely interaction between the pair of features."),l.$set(n)},i(t){a||(lt(r.$$.fragment,t),lt(l.$$.fragment,t),a=!0)},o(t){at(r.$$.fragment,t),at(l.$$.fragment,t),a=!1},d(t){t&&$(e),pt(r),pt(l)}}}function Dd(t,e,n){let r,i,o;p(t,Pn,(t=>n(4,i=t))),p(t,Tn,(t=>n(5,o=t)));let l=o,a="and";return t.$$.update=()=>{19&t.$$.dirty&&n(2,r=i.filter((t=>"and"===a?l.includes(t.x_feature)&&l.includes(t.y_feature):l.includes(t.x_feature)||l.includes(t.y_feature))))},[l,a,r,function(t){n(0,l=t.detail.features),n(1,a=t.detail.op)},i]}const Hd=class extends mt{constructor(t){super(),gt(this,t,Dd,Od,d,{},Ed)}};function Rd(t){b(t,"svelte-1qv3cht",".pdpilot-widget-container.svelte-1qv3cht{box-sizing:border-box;width:100%;display:flex;flex-direction:column;font-size:16px;border:1px solid var(--gray-1);background-color:white;color:black;--magenta:rgb(121, 35, 103);--blue:rgb(0, 95, 204);--gray-0:rgb(247, 247, 247);--gray-1:rgb(226, 226, 226);--gray-2:rgb(198, 198, 198);--gray-3:rgb(171, 171, 171);--gray-4:rgb(145, 145, 145);--gray-5:rgb(119, 119, 119);--gray-6:rgb(94, 94, 94);--gray-7:rgb(71, 71, 71);--gray-8:rgb(48, 48, 48);--gray-9:rgb(27, 27, 27);--black:black;--red:#d62728;--light-red:#fc655a}.pdp-tab-content.svelte-1qv3cht{flex:1;min-height:0}.pdpilot-widget-container.svelte-1qv3cht .pdp-hide{display:none}.pdpilot-widget-container.svelte-1qv3cht canvas,.pdpilot-widget-container.svelte-1qv3cht svg{display:block}.pdpilot-widget-container.svelte-1qv3cht *{box-sizing:border-box;margin:0;padding:0;line-height:1.2}.pdpilot-widget-container.svelte-1qv3cht button{color:black;background-color:white;border:1px solid black;border-radius:0.25em;text-align:center;cursor:pointer;font-size:1em;padding:0.0625em 0.0625em;font-family:inherit}.pdpilot-widget-container.svelte-1qv3cht button:hover:enabled{background-color:var(--gray-0)}.pdpilot-widget-container.svelte-1qv3cht button:active:enabled{background-color:var(--gray-1)}.pdpilot-widget-container.svelte-1qv3cht button:disabled{cursor:not-allowed;background-color:transparent;color:var(--gray-4);border-color:var(--gray-4)}.pdpilot-widget-container.svelte-1qv3cht h1{font-size:1.125em;font-weight:500}.pdpilot-widget-container.svelte-1qv3cht h2{font-size:1.0625em;font-weight:500}.pdpilot-widget-container.svelte-1qv3cht .pdpilot-large{font-size:1.125em}.pdpilot-widget-container.svelte-1qv3cht .pdpilot-small{font-size:0.875em}.pdpilot-widget-container.svelte-1qv3cht .pdpilot-bold{font-weight:500}.pdpilot-widget-container.svelte-1qv3cht .pdpilot-icon{width:1em;height:1em}.pdpilot-widget-container.svelte-1qv3cht .pdpilot-cutoff{overflow:hidden;white-space:nowrap;text-overflow:ellipsis}.pdpilot-widget-container.svelte-1qv3cht .icon-tabler{-webkit-transform:translate(0px, 0px);transform:translate(0px, 0px)}")}function Id(t){let e,n,r,i,o,l,a,s,c,u,d,h,f=`${t[0]}px`;return n=new cr({}),o=new Cd({}),s=new Hd({}),d=new Au({}),{c(){e=k("div"),ht(n.$$.fragment),r=S(),i=k("div"),ht(o.$$.fragment),l=S(),a=k("div"),ht(s.$$.fragment),c=S(),u=k("div"),ht(d.$$.fragment),z(i,"class","pdp-tab-content svelte-1qv3cht"),E(i,"pdp-hide","one-way-plots"!==t[1]),z(a,"class","pdp-tab-content svelte-1qv3cht"),E(a,"pdp-hide","two-way-plots"!==t[1]),z(u,"class","pdp-tab-content svelte-1qv3cht"),E(u,"pdp-hide","detailed-plot"!==t[1]),z(e,"class","pdpilot-widget-container svelte-1qv3cht"),j(e,"height",f)},m(t,f){x(t,e,f),ft(n,e,null),w(e,r),w(e,i),ft(o,i,null),w(e,l),w(e,a),ft(s,a,null),w(e,c),w(e,u),ft(d,u,null),h=!0},p(t,[n]){(!h||2&n)&&E(i,"pdp-hide","one-way-plots"!==t[1]),(!h||2&n)&&E(a,"pdp-hide","two-way-plots"!==t[1]),(!h||2&n)&&E(u,"pdp-hide","detailed-plot"!==t[1]),1&n&&f!==(f=`${t[0]}px`)&&j(e,"height",f)},i(t){h||(lt(n.$$.fragment,t),lt(o.$$.fragment,t),lt(s.$$.fragment,t),lt(d.$$.fragment,t),h=!0)},o(t){at(n.$$.fragment,t),at(o.$$.fragment,t),at(s.$$.fragment,t),at(d.$$.fragment,t),h=!1},d(t){t&&$(e),pt(n),pt(o),pt(s),pt(d)}}}function Vd(t,e,n){let r,i;return p(t,In,(t=>n(0,r=t))),p(t,Wn,(t=>n(1,i=t))),[r,i]}const Fd=class extends mt{constructor(t){super(),gt(this,t,Vd,Id,d,{},Rd)}};class Wd extends o.DOMWidgetModel{defaults(){return Object.assign(Object.assign({},super.defaults()),{_model_name:Wd.model_name,_model_module:Wd.model_module,_model_module_version:Wd.model_module_version,_view_name:Wd.view_name,_view_module:Wd.view_module,_view_module_version:Wd.view_module_version,feature_names:[],feature_info:{},dataset:{},num_instances:0,one_way_pds:[],two_way_pds:[],two_way_pdp_extent:[0,0],two_way_interaction_extent:[0,0],ice_line_extent:[0,0],ice_cluster_center_extent:[0,0],centered_ice_line_extent:[0,0],height:600,highlighted_indices:[],two_way_to_calculate:[]})}}Wd.serializers=Object.assign({},o.DOMWidgetModel.serializers),Wd.model_name="PDPilotModel",Wd.model_module=n,Wd.model_module_version=e,Wd.view_name="PDPilotView",Wd.view_module=n,Wd.view_module_version=e;class Xd extends o.DOMWidgetView{render(){rr(this.model),new Fd({target:this.el})}}window.__webpack_public_path__=document.querySelector("body").getAttribute("data-base-url")+"nbextensions/pdpilot"})(),i})()));